	INTEGER*4 FUNCTION TERM_NUMBER(TERM_DEVICE)
C
C Function to create an integer value from a terminal number.
C
C  term_device is a string variable containing the terminal symbol.
C
	PARAMETER NLINES=96

	CHARACTER*(*) TERM_DEVICE
	CHARACTER*4   TERM_NAME

	IF (TERM_DEVICE(1:1) .EQ. '_') THEN
	   TERM_NAME = TERM_DEVICE (2:)
	ELSE
	   TERM_NAME = TERM_DEVICE(1:)
	END IF
	NT = NBLANK (TERM_NAME) + 1
D	TYPE *, TERM_DEVICE, TERM_NAME, NT
	GO TO (1, 2, 3, 4, 5), NT
C
C	No terminal specification.
C
1	   TERM_NAME = 'TTA0'
	   GO TO 5
C
C		TTx0:
C
2	   TERM_NAME = 'TT'//TERM_NAME(1:1)//'0'
	   GO TO 5
C
C		TTxx:
C
3	   TERM_NAME = 'TT'//TERM_NAME(1:2)
	   GO TO 5
C
C		TTx:
C
4	   TERM_NAME = TERM_NAME(1:3)//'0'
	   GO TO 5
C
C	Full specification provided.
C
5	TERM_NUMBER = ICHAR(TERM_NAME(4:4)) - ICHAR('0') +
	1	 8 * (ICHAR(TERM_NAME(3:3)) - ICHAR('A')) + 1

D	TYPE *, TERM_NUMBER, TERM_NAME

	IF (TERM_NUMBER .GT. NLINES .OR.
	1	TERM_NUMBER. LE. 0) TERM_NUMBER = -1

	IF (TERM_NAME(1:2). NE. 'TT' .OR.
	1	TERM_NAME(4:4) .GT. '7')TERM_NUMBER = -1

	RETURN

	END
