	logical function get_pid (pid, term_name)
c
c	Little subroutine to get a user's terminal name
c		when given his PID.
c
c			Dave Cook
c		Ball Aerospace Systems Division
c			2-Sept-82
c
	external	jpi$_username, jpi$_terminal
	external	ss$_normal, ss$_nonexpr
	integer*4	ss$_normal, ss$_nonexpr

	character*(*)	term_name
	character	name*12

	integer*4	jpi_list_4(4)
	integer*2	jpi_list_2(8)
	equivalence	(jpi_list_4, jpi_list_2)

	integer*4	sys$getjpi, pid, t_len
c
c	Form getjpi list.
c
	jpi_list_2(1) = 6
	jpi_list_2(2) = %loc(jpi$_terminal)
	jpi_list_4(2) = %loc(term_name)
	jpi_list_4(3) = %loc(t_len)

	jpi_list_4(4) = 0
c
c	Fetch info.
c
	get_pid = .true.
	istat = sys$getjpi (,pid,,jpi_list_4,,,)
c
c	And handle return condition.
c
	if (istat .eq. %loc(ss$_nonexpr)) then
	   get_pid = .false.
	else if (istat .ne. %loc(ss$_normal)) then
	   call errmes (istat)
	   stop	'Error exit.'
	end if

	return

	end
