	PROGRAM NAFBMX
C***
C	CREATE MAILBOX TO BE EQUATED TO SYS$OUTPUT
C	  AND SYS$INPUT ( A DIFFERENT BOX)
C	S.R. BERMAN, JULY 15, 1981
C***
	IMPLICIT INTEGER (A-Z)
	EXTERNAL NAFAST
	CHARACTER*10 TTEQU
	CHARACTER*132 DATA
	BYTE JUNK(132)
	LOGICAL OPENFL
C	PUT UNIT NUMBERS INTO AN ARRAY TO PASS TO THE AST ROUTINE
	COMMON UNITS(4),TTCHAN
C	UNITS IS AN ARRAY CONTAINING THE FOLLOWING:
C		UNITS(1) : UNIT NO. OF INMAIL
C		UNITS(2) : UNIT NO. OF TT
C		UNITS(3) : UNIT NO. OF OUTPUT.ECO (LOG FILE)
C		UNITS(4) : UNIT NO. OF TTMBX
	EQUIVALENCE (UNITS(1),CHANI), (UNITS(2),I), (UNITS(3),J)
	EQUIVALENCE (UNITS(4),CHANAUX)
D	CHARACTER*10 NAME_OUT
C	FIRST, CREATE THE MAILBOX FOR SYS$OUTPUT
	STATUS = SYS$CREMBX (,CHAN,%VAL(256),,,,'OUTMAIL')
	IF (.NOT. STATUS) CALL LIB$STOP (%VAL(STATUS))
D	WRITE (6,100) CHAN
D 100	FORMAT (' CHANNEL ',I3)
D	STATUS = SYS$TRNLOG ('OUTMAIL',,NAME_OUT,,,)
D	IF (.NOT.STATUS) CALL LIB$STOP (%VAL(STATUS))
D	WRITE (6,101) NAME_OUT
D 101	FORMAT (' THE NAME IS ',A)
C	NOW THE SYS$INPUT MAILBOX
	STATUS = SYS$CREMBX (,CHANI,%VAL(132),,,,'INMAIL')
	IF (.NOT. STATUS) CALL LIB$STOP (%VAL(STATUS))
D	WRITE (6,102) CHANI
D 102	FORMAT (' INPUT CHANNEL ',I3)
D	STATUS = SYS$TRNLOG ('INMAIL',,NAME_OUT,,,)
D	IF (.NOT.STATUS) CALL LIB$STOP (%VAL(STATUS))
D	WRITE (6,101) NAME_OUT
C	NOW THE MAILBOX TO BE ASSOCIATED WITH THE TERMINAL
	STATUS = SYS$CREMBX (,CHANAUX,%VAL(132),,,,'TTMBX')
	IF (.NOT.STATUS) CALL LIB$STOP (%VAL(STATUS))
	OPEN (UNIT=CHAN,NAME='OUTMAIL',TYPE='OLD',READONLY)
	OPEN (UNIT=CHANI,NAME='INMAIL',TYPE='UNKNOWN')
	OPEN (UNIT=CHANAUX,NAME='TTMBX',TYPE='OLD',READONLY)
C	FIND LOGICAL NAME TT
	STATUS = SYS$TRNLOG ('TT',,TTEQU,,,)
	IF (.NOT. STATUS) CALL LIB$STOP (%VAL(STATUS))
D	WRITE (6,103) TTEQU
D 103	FORMAT (' THE TT EQUIVALENT NAME IS ',A)
C****
C	OPEN UNITS OF VARIOUS KINDS
C****
C	FIND AN AVAILABLE UNIT NUMBER
	DO 1 I=1,100
	INQUIRE (I,OPENED=OPENFL)
	IF (.NOT. OPENFL) GO TO 2
    1	CONTINUE
C	OPEN THE TT TO ECHO PRINT SYS$OUTPUT TO
    2	OPEN (UNIT=I,NAME=TTEQU,TYPE='UNKNOWN')
	DO 5 J=1,100
	INQUIRE (J,OPENED=OPENFL)
	IF (.NOT. OPENFL) GO TO 6
    5	CONTINUE
C	OPEN THE FILE TO ECHO PRINT BOTH SYS$OUTPUT AND SYS$INPUT TO
    6	OPEN (UNIT=J,NAME='OUTPUT.ECO',TYPE='NEW',INITIALSIZE=3,
     1	EXTENDSIZE=3)
D	WRITE (J,105) UNITS
D 105	FORMAT (' NAFBMX - UNITS ARE ',4I4)
C***
C	ASSOCIATE A MAILBOX WITH THE TERMINAL TO GET A MESSAGE SAYING
C	THERE IS UNSOLICITED DATA AVAILABLE FROM THE TERMINAL.
C***
	STATUS = SYS$ASSIGN (TTEQU,TTCHAN,%VAL(1),'TTMBX')
	IF (.NOT.STATUS) CALL LIB$STOP (%VAL(STATUS))
C***
C	THE DEVICE DRIVER WILL WRITE TO TTMBX WHEN UNSOLICITED INPUT IS
C	  SENT FROM THE TT KEYBOARD.
C***
C****
C	SET UP WRITE ATTENTION AST FOR THE SYS$INPUT MAILBOX TO AWAKEN 
C	WITH AN INTERRUPT
C	  ROUTINE WHEN SOMETHING OCCURS ON THAT UNIT
C	THE VALUE 291 BELOW REPRESENTS IO$_SETMODE (35) .OR. 
C	  IO$M_WRTATTN (256)
C****
D	WRITE (6,104)
D 104	FORMAT (' QIO FROM NAFBMX EXECUTED - SETS AST')
	STATUS = SYS$QIO (,%VAL(CHANAUX),%VAL(291),,,,NAFAST,DUMMY,
     1	%VAL(1),,,)
	IF (.NOT.STATUS) CALL LIB$STOP (%VAL(STATUS))
C****
C	SIT HERE AND WAIT UNTIL DATA IS SENT TO SYS$OUTPUT; THEN COME ALIVE
C****
    3	READ (CHAN,4,END=8) ICNT,DATA
    4	FORMAT (Q,A)
C	DISABLE AST'S WHILE WRITING FILE
	STATUS = SYS$SETAST (%VAL(0))
	IF (.NOT.STATUS) CALL LIB$STOP (%VAL(STATUS))
	WRITE (I,7) DATA(1:ICNT)
	WRITE (J,7) DATA(1:ICNT)
    7	FORMAT (1H A)
C	ENABLE AST'S NOW
	STATUS = SYS$SETAST (%VAL(1))
	IF (.NOT.STATUS) CALL LIB$STOP (%VAL(STATUS))
	GO TO 3
C****
C	EOF FROM OUTMAIL BOX.
C****
    8	CONTINUE
D	WRITE (I,9)
D   9	FORMAT (' E O F FROM MAILBOX')
D	WRITE (J,9)
C***	OVERCOME THE EOF ON INPUT MAILBOX BY READING IT HERE
C	QIO MUST BE USED TO FORCE THE READ N O W
C	IO$M_NOW IS 64, IO$_READVBLK IS 49.
	STATUS = SYS$QIO (,%VAL(CHANI),%VAL(113),,,,JUNK,%VAL(132),,,,)
	IF (.NOT.STATUS) CALL LIB$STOP (%VAL(STATUS))
	GO TO 3
	END
