$!***************************************************************************
$!									    *
$!  COPYRIGHT (c) 1983                                                      *
$!  By TECHNOLOGY DEVELOPMENT OF CALIFORNIA, INCORPORATED.		    *
$!     Defense Systems Group						    *
$!     624 Six Flags Drive, 						    *
$!     Arlington, Tx.							    *
$!     76012								    *
$!     (817) 461-1242							    *
$! 									    *
$!  THIS SOFTWARE IS FURNISHED WITHOUT LICENSE AND MAY BE USED AND  COPIED  *
$!  ONLY WITH THE INCLUSION OF THE ABOVE COPYRIGHT NOTICE.		    *
$! 									    *
$!  THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE  *
$!  AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY T.D.C.		    *
$! 									    *
$!  TECHNOLOGY DEVELOPMENT OF CALIFORNIA ASSUMES NO RESPONSIBILITY FOR THE  *
$!  USE OR RELIABILITY OF THIS SOFTWARE. 				    *
$!									    *
$!***************************************************************************
$ !
$ FULL_NAME = F$SEARCH("SYS$SNAP:''P1'.OLD;-1")	!See if the 'previous' file exists
$ IF FULL_NAME .EQS. "" THEN GOTO NO_FILE !If not notify someone
$ !
$ DIFF/OUTPUT=SYS$SNAP:'P1'.DIF -	!Check the 'Previous' and 'Current'
SYS$SNAP:'P1'.OLD;-1 SYS$SNAP:'P1'.OLD;0 !files for differences
$ !
$ OPEN DIF SYS$SNAP:'P1'.DIF		!Open the 'differences' file
$ COLON_COUNT = 0
$ !
$READ_LOOP:
$ READ/END=DONE DIF LINE		!Read a line
$ LEN='F$LENGTH(LINE)			!Get length of line read
$ COL='F$LOCATE("found:",LINE)		!Look for specific string
$ IF LEN .EQS. COL THEN GOTO READ_LOOP	!If this is not it, keep looking
$ !
$ COLON_COUNT = COLON_COUNT + 1
$ COL=COL + 6
$ !
$ VAL1 = 'F$EXTRACT(COL,5,LINE)		!Extract 'No. of differences'
$ IF VAL1 .NE. 0 THEN GOTO MAIL		!Did we find differences, send mail
$ IF COLON_COUNT .EQ. 2 THEN GOTO DONE	!Are we ready to quit
$ GOTO READ_LOOP			!Nope, keep checking
$!
$MAIL:
$ CLOSE DIF				!Close differences file
$ CREATION_DATE1 = F$FILE_ATTRIBUTES("SYS$SNAP:''P1'.OLD;0","CDT")
$ CREATION_DATE2 = F$FILE_ATTRIBUTES("SYS$SNAP:''P1'.OLD;-1","CDT")
$ !
$ OPEN/APPEND DIF SYS$SNAP:'P1'.DIF	!Reopen diff file with append access
$ WRITE DIF " "				!Add creation dates to bottom
$ WRITE DIF "''P1'.OLD;0  created on ''CREATION_DATE1'"
$ WRITE DIF "''P1'.OLD;-1 created on ''CREATION_DATE2'"
$ WRITE DIF " "
$ WRITE DIF "''P1'.OLD;-1 has now been deleted..."
$ CLOSE DIF
$ !
$ MAIL/SUBJECT="SNAPSHOT DIFFERENCES" SYS$SNAP:'P1'.DIF SNAP$RECIPIENT !Notify 
$ DELETE/NOCONFIRM SYS$SNAP:'P1'.OLD;-1	!Clean up files
$ DELETE/NOCONFIRM SYS$SNAP:'P1'.DIF;0
$ EXIT
$!
$DONE:					!No differences...
$ CLOSE DIF
$ DELETE/NOCONFIRM SYS$SNAP:'P1'.OLD;0	!Clean up files
$ DELETE/NOCONFIRM SYS$SNAP:'P1'.DIF;0
$ EXIT
$ !
$NO_FILE:				!No 'previous' file to check against
$ MAIL/SUBJECT="No ''P1'.OLD;-1 file" SYS$INPUT SNAP$RECIPIENT !Notify someone

		The file 'previous' .OLD file was not present in 
		SYS$SNAP. This message is normal for the 'initial'
		run of the SNAPSHOT package, however should not appear
		once you have established '.OLD' data in SYS$SNAP.
$ !
$ EXIT
