	subroutine search_for(ibeg,iend,length_search,bytes,
     1				fixed,complete_search)
	implicit integer (a-z)
	include 'flags.inc'

 	logical overflow
	common /too_large/ overflow,large_length,iaddress

	logical fixed,match_found,reverse_on
	common /rflag/ reverse_on
	byte buffer(32768),bytes(length_search)
	common /buf/ buffer
	external rms$_eof
	integer*2 size
	data size /32768/
	logical attention_flag,display_message
	common /control_c/ attention_flag,display_message

	attention_flag=.false.

	rewind 3
	match_found=.false.
c
c skip first records
c
	do i=1,ibeg-1
		call get_record(3,buffer,size,length_total,
     1				istat,fixed)
		if (overflow) then
			istat1=lib$free_vm(large_length,iaddress)
			if (.not. istat1) then
				type 111
 111				format(/' Error free virtual memory',
     1					' in search'/)
				iaddress=0
				large_length=0
			 endif
		 endif
		if (istat.eq.%loc(rms$_eof)) goto 9000
	 enddo

	len2=length_search
	do i=ibeg,iend
		if (attention_flag) then
			attention_flag=.false.
			type 12
 12			format(/' Aborted by CNTL C'/)
			goto 55
		 endif
		call get_record(3,buffer,size,length_total,
     1				istat,fixed)
		if (istat.eq.%loc(rms$_eof)) goto 9000
!
! reverse bytes if necessary
!
		if (reverse_on) then
			if (overflow) then
				lens=large_length/2
				call std_swap_bytes(lens,%val(iaddress))
			 else
				lens=length_total/2
				call std_swap_bytes(lens,buffer)
			 endif
		 endif

		istart=0
5		continue

		if (overflow) then
			len1=large_length
			im=matchc(%val(iaddress+istart),
     1					len1,bytes,len2,ifound)
		 else
			len1=length_total
			im=matchc(buffer(istart+1),len1,
     1					bytes,len2,ifound)
		 endif

		if (im.eq.0) then			! if zero, a match
			match_found=.true.
			type 10,i,ifound+istart
 10			format(' match in rec #',i7,' byte pos ',i7)
			if (display_on) then
				if (overflow) then
					call special(%val(iaddress),
     1						large_length,1,' ',1)
				 else
					call special(buffer,
     1						length_total,1,' ',1)
				 endif
			 endif
			
			if (complete_search) then
				istart=istart+ifound+len2-1
				goto 5
			 endif
		 endif
!
! free virtual memory used for search of this record
!
		if (overflow) then
			istat1=lib$free_vm(large_length,iaddress)
			if (.not. istat1) then
				type 111
 				iaddress=0
				large_length=0
			 endif
		 endif
	 enddo
 55	rewind 3
	if (.not. match_found) then
		type 20
 20		format(' *** no matches found')
	 endif
	return
 9000	continue
	if (.not. match_found) then
		type 20
	 endif
	type *,' hit eof while searching '
	rewind 3
	return
	end
