$!..StartFing.Com			Start finger stuff at BOOT time
$!..					R. Garland / C.U.Chemistry / 7-Oct-1983
$!
$!  Note: you must edit this file - Change the symbol DIRECTORY to
$!	point to the place where you keep programs like this.  Change
$!	the terminal locations, and host routing appropriately.
$ Define	 Finger$Directory	'F$Log("Chem$User")'
$!
$!
$!	PARAMETERS:
$!		P1	:= "REBUILD" 	reconstruct FINGERSHR database
$!
$!  Note: Finger needs SYSPRV (so it can read SYSUAF.DAT and users'
$!	MAIL.MAI files), WORLD (so it can do GETJPI on all processes),
$!	and CMKRNL (so it can get the terminal idle times).
$!
$!	FINGERSHR is the shared databse for usernames, terminal locations
$!	and remote host routing.
$!
$!	NOTE: (this one is wierd) FINGERSHR must first be unprotected
$!	(WORLD is given write privilege) then installed, then reprotected
$!	to work properly!!
$!
$ Set	Prot=(W:RWE)	Finger$Directory:FingerShr.Exe
$ Run	Sys$System:Install
Finger$Directory:Finger	/Delete
Finger$Directory:Finger	/Open /Shared /Header /Priv=(Sysprv,World,Cmkrnl)
Finger$Directory:FingerShr /Delete
Finger$Directory:FingerShr /Open /Shared /Header /Write /Priv=(Sysprv,Sysgbl)
$ Set	Prot=(W:RE)	Finger$Directory:FingerShr.Exe
$!
$!  Note: FINGERSHR must be defined so the image activator can find
$!	the shared section containing the finger database.
$!
$ Define/System		FingerShr	'F$Log("Finger$Directory")'FingerShr
$!
$!  Note: the finger database does not need to be rebuilt each time you Boot.
$!	However, since you may have added names to the UAF and forgotten
$!	to add them to the finger database, you may want to rebuild.
$!
$!  Format of entries:
$!	Users:  ADD /USER=BLOW /PERSONALNAME="Blow, Joe"
$!		or
$!		ADD /USER /UAF
$!	terminals:
$!		ADD /TERMINAL=TTA1: /LOCATION="Main office"/TTType=ADM3
$!	Hosts:	ADD /HOST=FRODO /TYPE=D
$!		TYPES: L=local, D=DECnet, B=BITnet
$!		/LINK is used for the actual host name when /HOST
$!		is a pseudonym.  /ROUTE is for poor-man's-routing or
$!		internet gateway-ing.
$!	    Note: you do not need to make an entry for DECnet hosts
$!		with no pseudonyms as these ar found by default.
$!
$ If	P1	.eqs. ""	Then GoTo NoRebuild
$ If	P1	.nes.	"REBUILD" Then GoTo NoRebuild
$ Run	Finger$Directory:FingMaint
Clear	/All
Add	/User	/UAF	! Get names from the authorization file
Add	/Term=OPA0: /Location="505 Havemeyer"	/TTType="DEC LA36"
Add	/Term=TTA0: /Location="505 Havemeyer"	/TTType="DEC VT100"
Add	/Term=TTA1: /Location="958b Chandler"	/TTType="DEC VT100"
Add	/Term=TTA2: /Location="958a Chandler"	/TTType="Hazeltine 1500"
Add	/Term=TTA3: /Location="958a Chandler"	/TTType="DEC VT100"
Add	/Term=TTA4: /Location="958a Chandler"	/TTType="Tektronix 4010"
Add	/Term=TTA5: /Location="966 Chandler" 	/TTType="DEC WS78"
Add	/Term=TTA6: /Location="963 Chandler" 	/TTType="(Instrument)"
Add	/Term=TTA7: /Location="862 Chandler" 	/TTType="Hazeltine 1500"
Add	/Term=TTB0: /Location="316 Havemeyer"
Add	/Term=TTB1: /Location="553 Chandler" 	/TTType="DEC VT100-Retrographics"
Add	/Term=TTB2: /Location="553 Chandler" 	/TTType="Hazeltine 1500"
Add	/Term=TTB3: /Location="PACX"
Add	/Term=TTB4: /Location="PACX"
Add	/Term=TTB5: /Location="263 Chandler"	/TTType="DEC WS78"
Add	/Term=TTB6: /Location="210 Havemeyer"	/TTType="DEC VT105"
Add	/Term=TTB7: /Location="214 Havemeyer"	/TTType="DEC VT105"
Add	/Term=TTC0: /Location="102 Havemeyer"	/TTType="Tektronix 4025"
Add	/Term=TTC1: /Location="102 Havemeyer"	/TTType="DEC LA36"
Add	/Term=TTC2: /Location="106 Havemeyer"	/TTType="DEC LA36"
Add	/Term=TTC3: /Location="106 Havemeyer"	/TTType="Heathkit H19"
Add	/Term=TTC4: /Location="515 Havemeyer"	/TTType="DEC WS78"
Add	/Term=TTC5: /Location="515 Havemeyer"	/TTType="DEC VT100"
Add	/Term=TTC6: /Location="509 Havemeyer"	/TTType="(Instrument)"
Add	/Term=TTC7: /Location="408 Havemeyer"	/TTType="Heathkit H19"
Add	/Term=TTD0: /Location="201 Uris"	/TTType="DEC VT100"
Add	/Term=TTD1: /Location="604 Havemeyer"	/TTType="DEC VT100-Retrographics"
Add	/Term=TTD2: /Location="604 Havemeyer"  
Add	/Term=TTD3: /Location="766 Chandler"	/TTType="DEC WS78"
Add	/Term=TTD4: /Location="753 Chandler"	/TTType="DEC VT100"
Add	/Term=TTD5: /Location="763 Chandler"	/TTType="DEC VT100-Retrographics"
Add	/Term=TTD6: /Location="657 Chandler"	/TTType="DEC VT100"
Add	/Term=TTD7: /Location="666 Chandler"	/TTType="DEC WS78"
Add	/Term=TTE0: /Location="507 Havemeyer"	/TTType="DEC VT100"
Add	/Term=TTE1: /Location="507 Havemeyer"	/TTType="Tektronix 4010"
Add	/Term=TTE2: /Location="280-3037 Dialup"	/TTType="300/1200 baud "
Add	/Term=TTE3: /Location="280-5275 Dialup"	/TTType="300/1200 baud"
Add	/Term=TTE4: /Location="280-3043 Dialup"	/TTType="300/1200 baud "
Add	/Term=TTE5: /Location="954 Chandler"	/TTType="DEC VT100"
Add	/Term=TTE6: /Location="280-4484 Dialup"	/TTType="300 baud"
Add	/Term=TTE7: /Location="280-4485 Dialup"	/TTType="300 baud"
Add	/Term=TTF0: /Location="305 Havemeyer"	/TTType="DEC WS78"
Add	/Term=TTF1: /Location="605 Havemeyer"	/TTType="DEC VT131"
Add	/Term=TTF2: /Location="608 Havemeyer"	/TTType="DEC VT100-Retrographics"
Add	/Term=TTF3: /Location="955 Chandler"	/TTType="DEC VT101"
Add	/Term=TTF4: /Location="960 Chandler"	/TTType="Hazeltine 1500"
Add	/Term=TTF5: /Location="212 Havemeyer"	/TTType="Rainbow 100"
Add	/Term=TTF6: /Location="214b Havemeyer"	/TTType="Heathkit H19"
Add	/Term=TTF7: /Location="214 Havemeyer"	/TTType="Heathkit H19"
Add	/Host=CUCHEM	/Type=L				! Local Host
Add	/Host=LOOP	/Type=D	/Link=CU20B /Route="@CUCHEM" ! loop test
Add	/Host=LOCAL	/Type=D	/Link=CUCHEM		! Local DECnet test
Add	/Host=A		/Type=D	/Link=CU20A		! DECnet pseudonyms
Add	/Host=B		/Type=D	/Link=CU20B           
Add	/Host=C		/Type=D	/Link=CU20C
Add	/Host=D		/Type=D	/Link=CU20D
Add	/Host=ARPA	/Type=D	/Link=CUCS20
Add	/Host=PSY-A	/Type=D	/Link=CMPSYA
Add	/Host=PSUVMS1	/Type=B				! BITnet hosts
Add	/Host=PSU	/Type=B	/Link=PSUVMS1
Add	/Host=SLACCB	/Type=B
Add	/Host=SLACMAC	/Type=B
Exit
$ NoRebuild:
$!
