$ !
$ !	K E Y B O A R D . C O M
$ !
$ ! Description:
$ !
$ !	This command procedure calls the keyboard exercise program.
$ !
$ ! Parameters:
$ !
$ !	P1	Skill level (1,2,3)
$ !	P2	Beep on right keypress (Y/N)
$ !	P3	Beep on wrong keypress (Y/N)
$ !
$ ! History:
$ !
$ !	23-Mar-83 Jesse Black	Original.
$ !	24-Sep-83 Jesse Black	Add beep options.
$ !
$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$		!
$	COURSE = P1
$	BEEP_RIGHT = P2
$	BEEP_WRONG = P3
$		!
$	IF COURSE .GT. 0 THEN GOTO AFTER_QUERY
$		!
$	COPY SYS$INPUT SYS$OUTPUT

This program helps develop familiarity with the VT100 keyboard.

	1	=	Alphabetic and numeric keys
	2	=	All keys on main keyboard
	3	=	Favorite words and phrases

$	INQUIRE COURSE "Enter the number of the desired course"
$ AFTER_QUERY:
$	IF COURSE .LE. 0 THEN EXIT
$	IF COURSE .GT. 3 THEN EXIT
$		!
$	IF (BEEP_RIGHT .LES. " " ) THEN -
		INQUIRE/NOPUNCT BEEP_RIGHT "Beep on correct keypresses? "
$	IF (BEEP_WRONG .LES. " " ) THEN -
		INQUIRE/NOPUNCT BEEP_WRONG "Beep on incorrect keypresses? "
$		!
$	WRITE SYS$OUTPUT "Use control-Z to terminate the program."
$	WRITE SYS$OUTPUT "Loading... "
$	WAIT 00:00:03.00
$		!
$	OPEN/WRITE FILE KEYBOARD.INP
$	WRITE FILE COURSE		! 1, 2, 3
$	WRITE FILE BEEP_RIGHT		! beep on right keys
$	WRITE FILE BEEP_WRONG		! don't beep on wrong keys
$	CLOSE FILE
$		!
$	DEFINE/USER FOR001 KEYBOARD.PIC
$	DEFINE/USER FOR002 KEYBOARD.INP
$	DEFINE/USER FOR003 KEYBOARD.WRD
$		!
$	RUN KEYBOARD
