$ !	M O N S T E R
$ !
$ ! Description:
$ !
$ !	1.	Display the instruction panel for the MONSTER game.
$ !	2.	Associate Fortran Unit #1 with the file containing game boards.
$ !	3.	Run the MONSTER program.
$ !
$ ! History:
$ !
$ !	15-Feb-82 Jesse Black	Add instructions.
$ !
$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$	TYPE SYS$INPUT


This is the game of MONSTER.

$	INQUIRE/NOPUNCT YESNO "Do you need instructions? "
$	IF .NOT.YESNO THEN GOTO AFTER
$	TYPE SYS$INPUT


You will be placed into a maze along with several monsters.  If these monsters 
catch you, they will eat you (try to avoid that!).  These monsters are very 
mean and very ugly, but have very sensitive personalities. To defeat them, 
you will have to hurl insults at them.  If the insult is on target, the monster
will vanish.  The monsters are also a bit clumsy; if one is chasing you, you 
may be able to gain some distance from it by scooting around a corner (the 
monsters don't know how to "scoot").

If you want to move, use the number keys (particularly the numeric keypad).
Numbers 1,4,7 move you left;  3,6,9 move you right;  1,2,3 move you down;
and 7,8,9 move you up.  5 lets you stay in place.

If you want to hurl an insult, use the arrow keys to indicate the direction
to send it.  Note: Since it's hard to think up good insults under pressure,
you can't hurl an insult if the monster is right next to you.

The monsters will also hurl insults at you, which I won't bother to print
because you wouldn't understand them anyway.  Luckily, if a monster is close
to you, it will prefer to try to catch and eat you rather than insult you.

$	INQUIRE JUNK "Press RETURN to proceed"
$	TYPE SYS$INPUT

If you're really clever you can get the monsters to insult each other.
If you have any insults left over when all the maze has been cleared of
monsters, you can use them in the next maze.

(oh, by the way, control-Z will terminate the game...)

$ AFTER:
$	TYPE SYS$INPUT

You are represented by an asterisk "*"
Monsters are shown as the letter "M" (although they are really much uglier)

$	WAIT 0:00:05
$	IF YESNO THEN INQUIRE JUNK "Press RETURN to proceed"
$	DEFINE/USER FOR001 MONSTER.DAT
$	RUN MONSTER
