$!		KMS CAI driver
$!
$
$	IF P1 .NES. "" THEN GOTO Get_module
$	PAGE
$	WRITE SYS$OUTPUT "KMSCAI -- No module name given"
$	EXIT
$Get_Module:
$	IF P1 .EQS. "DTRCAI"     THEN GOTO Use_DTRCAI
$	IF P1 .EQS. "EDTCAI"     THEN GOTO Use_EDTCAI
$	IF P1 .EQS. "VMSCAI"     THEN GOTO Use_VMSCAI
$	IF P1 .EQS. "TOUCH_TYPE" THEN GOTO Use_Touch_Type
$	RESULT:==""
$	Name="''P1'"
$	FTYP=".SUB"
$	IF P2 .EQS. "TEST" THEN FTYP=".COM"
$	IF P2 .EQS. "TEST" THEN GOTO Got_Module
$	ON ERROR THEN GOTO Not_Found
$	SET MESSAGE/NOTEXT/NOIDENT/NOFACILITY/NOSEVERITY
$	LIBR/OUTPUT='P1'.SUB/EXTRACT='P1' SYS$SYSDEVICE:[VPW.CAI]KMSCAI.TLB
$	SET MESSAGE/TEXT/IDENT/FACILITY/SEVERITY
$	GOTO Got_Module
$
$Not_Found:
$	PAGE
$	WRITE SYS$OUTPUT "KMSCAI -- Module ''P1' not found"
$	WAIT 00:00:04
$	EXIT
$Got_Module:
$	ON CONTROL_Y THEN GOTO The_End
$	On ERROR THEN GOTO The_End
$	Return="The_Start_0"
$	GOTO Set_Escape_Symbols
$The_Start_0:
$	Number_Asked=0
$	Number_Right=0
$!
$The_Start:
$	PAGE
$	@'Name''FTYP' MENU
$Prompt:
$	IF Result .EQS. "DONE" THEN GOTO The_End
$	INQUIRE Choice "''EraseL20'Choice"
$	WRITE SYS$OUTPUT "''Erasel21'"
$	TMP=F$EXTRACT(0,1,Choice)
$	TMP1=F$EXTRACT(0,2,Choice)
$	ON ERROR THEN GOTO Bad_Choice
$	@'Name''FTYP' Select 'Tmp' 'Tmp1'
$	IF Result .EQS. "BAD" THEN GOTO Bad_Choice
$	IF Result .EQS. "DONE" THEN GOTO The_End
$	Return="The_Start"
$	IF Test .EQS. "T" THEN GOTO Test_User
$	GOTO The_Start
$Bad_Choice:
$	WRITE SYS$OUTPUT -
	"''EraseL21'KMSCAI -- ''Choice' is not a valid selection"
$	GOTO Prompt
$!
$The_End:
$	Page
$	IF Number_Asked .GT. 0 THEN WRITE SYS$OUTPUT -
"You got ''Number_Right' correct answers out of ''Number_Asked' questions."
$	ON ERROR THEN EXIT
$	N=1
$	SET MESSAGE/NOTEXT/NOIDENT/NOSEVERITY/NOFACILITY
$The_End_Loop:
$	IF N .LT. 10 THEN NN="0''N'"
$	IF N .GE. 10 THEN NN="''N'"
$	DELETE/SYMBOL/GLOBAL EraseL''NN'
$	N=N+1
$	IF N.LE. 23 THEN GOTO The_End_Loop
$	DELETE/SYMBOL/GLOBAL Bold
$	DELETE/SYMBOL/GLOBAL No_Bold
$	DELETE/SYMBOL/GLOBAL Test
$	DELETE/SYMBOL/GLOBAL RESULT
$	ON ERROR THEN CONTINUE
$	IF FTYP .EQS. ".SUB" THEN DELETE 'NAME'.SUB;*
$	SET MESSAGE/TEXT/IDENT/SEVERITY/FACILITY
$	EXIT
$Test_User:
$	IF Nmax .EQ. 0 THEN GOTO 'Return'
$	N=1
$Test_Loop:
$	X="Example_"+"''N'"
$	Tmpx='X'
$	X="Answer_"+"''N'"
$	Tmp1x='X'
$	X="Reason_"+"''N'"
$	Rsn='X'
$	IF Question .EQS. "" THEN Q="Question_"+"''N'"
$	IF Question .EQS. "" THEN Qtmp='Q'
$	ANS=""
$	IF TMP1x .EQS. "N" THEN ANS="not "
$	WRITE SYS$OUTPUT "''EraseL20'''EraseL21'''EraseL23'"
$	WRITE SYS$OUTPUT "''EraseL15'               ''Tmpx'"
$	IF Question .NES. "" THEN -
	INQUIRE OK "''EraseL17'''Question' [Y/N] (Return ->Exit)"
$	IF Question .EQS. "" Then -
	INQUIRE OK "''EraseL17'''Qtmp' [Y/N] (Return ->Exit)"
$	IF OK .EQS. "" THEN GOTO Clean
$	Tmp2[0,1]:='OK'
$	IF TMP2 .EQS. Tmp1x THEN GOTO Right
$	WRITE SYS$OUTPUT "''EraseL20'Wrong.  ''Tmpx' is ''ANS'correct."
$	WRITE SYS$OUTPUT "''EraseL21'''Rsn'"
$	Number_Asked=Number_Asked+1
$	GOTO End_Loop
$Right:
$	WRITE SYS$OUTPUT "''EraseL20'Correct.  ''Tmpx' is ''ANS'correct."
$	WRITE SYS$OUTPUT "''EraseL21'''Rsn'"
$	Number_Right=Number_Right+1
$	Number_Asked=Number_Asked+1
$End_Loop:
$	N=N+1
$	INQUIRE/NOPUN tmpx "''EraseL17'''EraseL23'Press RETURN when ready"
$	IF N .LE. Nmax THEN GOTO Test_Loop
$	WRITE SYS$OUTPUT "''EraseL20'''EraseL21'''EraseL22'This section is complete"
$	INQUIRE/NOPUN Tmpx "Press RETURN to continue"
$Clean:
$	N=1
$	SET MESSAGE/NOTEXT/NOSEVERITY/NOFACILITY/NOIDENT
$Clean_Loop:
$	DELETE/SYMBOL/GLOBAL Example_'N'
$	DELETE/SYMBOL/GLOBAL ANSWER_'N'
$	DELETE/SYMBOL/GLOBAL REASON_'N'
$	DELETE/SYMBOL/GLOBAL Question_'N'
$	N=N+1
$	IF N .LE. Nmax THEN GOTO Clean_Loop
$	SET MESSAGE/TEXT/SEVERITY/FACILITY/IDENT
$Clean_Done:
$	DELETE/SYMBOL/GLOBAL Nmax
$	DELETE/SYMBOL/GLOBAL Question
$	GOTO 'Return'
$Use_DTRCAI:
$	SET TERM/VT100
$	MC GRAIL SYS$INSTRUCTION:DTR
$	SET TERM/INQUIRE
$	EXIT
$Use_EDTCAI:
$	MC EDTCAI
$	EXIT
$Use_VMSCAI:
$	MC VMSCAI
$	EXIT
$Use_Touch_Type:
$	PAGE
$	TYPE SYS$INPUT
        [7m                                                    [0m
    #3[7m [0m    The Typing Tutor    [0;7m [0m
    #4[7m [0m    The Typing Tutor    [0;7m [0m
        [7m                                                    [0m
                     (Type ^Y to Exit at any point)

$	ON Control_Y THEN GOTO Use_Touch_Type_2
$	WRITE SYS$OUTPUT "[8;24r[7;0H"
$	ASSIGN/USER SYS$COMMAND SYS$INPUT
$	RUN SYS$VPWCAI:TYPIST
$Use_Touch_Type_2:
$	WRITE SYS$OUTPUT "[1;24r"
$	ON CONTROL_Y THEN GOTO The_End
$	EXIT
$Set_Escape_Symbols:
$	EraseL01=="[01;1H[2K"
$	EraseL02=="[02;1H[2K"
$	EraseL03=="[03;1H[2K"
$	EraseL04=="[04;1H[2K"
$	EraseL05=="[05;1H[2K"
$	EraseL06=="[06;1H[2K"
$	EraseL07=="[07;1H[2K"
$	EraseL08=="[08;1H[2K"
$	EraseL09=="[09;1H[2K"
$	EraseL10=="[10;1H[2K"
$	EraseL11=="[11;1H[2K"
$	EraseL12=="[12;1H[2K"
$	EraseL13=="[13;1H[2K"
$	EraseL14=="[14;1H[2K"
$	EraseL15=="[15;1H[2K"
$	EraseL16=="[16;1H[2K"
$	EraseL17=="[17;1H[2K"
$	EraseL18=="[18;1H[2K"
$	EraseL19=="[19;1H[2K"
$	EraseL20=="[20;1H[2K"
$	EraseL21=="[21;1H[2K"
$	EraseL22=="[22;1H[2K"
$	EraseL23=="[23;1H[2K"
$	Bold=="[1m"
$	No_Bold=="[0m"
$!	Clear_Window=="[5;0H[J"		! clear line 5 to bot
$	GOTO 'Return'
