       ID DIVISION.                                                     00010000
       PROGRAM-ID. VBSTOFB.                                             00020009
       AUTHOR. CARL EVANS.                                              00021009
       REMARKS.                                                         00022009
           CONVERT A 512 BYTE VARIBLE BLOCK SPANNED FILE TO             00023009
           80 BYTE FIXED BLOCK FILE. (DEC/IBM UTILITY FILES).           00024009
       ENVIRONMENT DIVISION.                                            00030001
       INPUT-OUTPUT SECTION.                                            00040000
       FILE-CONTROL.                                                    00050000
           SELECT IN-FILE   ASSIGN UT-S-SYSUT1.                         00060002
           SELECT OUT-FILE  ASSIGN UT-S-SYSUT2.                         00070002
       DATA DIVISION.                                                   00080000
       FILE SECTION.                                                    00090000
       FD IN-FILE                                                       00100000
           LABEL RECORDS ARE STANDARD                                   00110000
           BLOCK CONTAINS 512 CHARACTERS                                00120008
           RECORDING MODE IS S.                                         00130008
       01  IN-REC    PIC X(80).                                         00140004
       FD OUT-FILE                                                      00170000
           LABEL RECORDS ARE STANDARD                                   00180000
           BLOCK CONTAINS 0 RECORDS                                     00190000
           RECORDING MODE IS F.                                         00200000
       01  OUT-REC         PIC X(80).                                   00210004
       WORKING-STORAGE SECTION.                                         00220000
       PROCEDURE DIVISION.                                              00240000
           OPEN INPUT IN-FILE                                           00250000
               OUTPUT OUT-FILE.                                         00260000
       1000-READ.                                                       00270002
           READ IN-FILE INTO OUT-REC AT END GO TO 9000-EOJ.             00280007
           WRITE OUT-REC.                                               00300007
           GO TO 1000-READ.                                             00310004
       9000-EOJ.                                                        00340002
           CLOSE IN-FILE OUT-FILE.                                      00350002
           STOP RUN.                                                    00360002
