$!	Install any inhouse privileged images.  
$!	These images fall into two catagories.  Some just need privileges
$!	to access files and even if the operating system is changed via
$! 	an update/upgrade, the system will not crash if these are run.
$!	Others, are linked with SYS$SYSTEM:SYS.STB and these must not be
$!	run iff the system is changed.  Check to see if the
$!	system has changed since images last installed.  If so, do not
$!	install them.  Do this by checking to see what the version of
$!	SYS is.
$!
$!	Find out the most recent version number for SYS.EXE
$!
$	DIR/OUT=XXX.TMP/NOHEADER/NOTRAILING SYS$SYSTEM:SYS.EXE
$	OPEN/READ INFILE XXX.TMP		! Open temp file
$	READ INFILE SYS_File			! and read in file name
$	CLOSE INFILE				!
$	DEL XXX.TMP;*				! Delete temp file
$	IF SYS_File .NES. "SYS$SYSROOT:[SYSEXE]SYS.EXE;4" THEN -
	   GOTO NO_Match			! Woops, something changed
$!
$	WRITE SYS$OUTPUT -			!
	   "INSIMAGES -- Installing KMS privileged images"
$	RUN SYS$SYSTEM:INSTALL			!
	SYS$SYSROOT:[SYSEXE]NOUNLOAD/PRIVILEGE=(CMKRNL,SYSPRV)
	SYS$SYSROOT:[SYSEXE]SETUIC  /PRIVILEGE=(CMKRNL)
$	GOTO Install_Nonpriv			!
$!
$NO_Match:
$	WRITE SYS$OUTPUT -
	"INSIMAGES -- A new system is in.  Rebuild privileged images!"
$	WRITE SYS$OUTPUT "INSIMAGES -- Rebuild NOUNLOAD"
$	WRITE SYS$OUTPUT "INSIMAGES -- Rebuild SETUIC"
$Install_Nonpriv:
$	WRITE SYS$OUTPUT -			!
	"INSIMAGES -- Installing site specific non-privileged images"
$ 	RUN SYS$SYSTEM:INSTALL
	SYS$SYSDEVICE:[VPW]ASK/OPEN/HEADER_RESIDENT/SHARE
	SYS$SYSDEVICE:[VPW]BROADCAST/PRIVILEGE=(OPER,WORLD)
	SYS$SYSDEVICE:[VPW]REMINDER/PRIVILEGE=(SYSPRV)
$	EXIT
$!
$!  File Name:	INSIMAGES
$!  Author:	James G. Downward
$!  Date:	19-May-1982
$!  Function:	Install any site specific images.  Check to be sure the system
$!		has not changed prior to installing any system privileged 
$!		images.
$!
$!  Modified:
$!  		05-July-1982	for VMS V3.0

