C+
C	Display_Help
C
C	This subroutine will format the help information displayed from
C	VPW_HELP.  It will set the scrolling region for terminals
C	and set VT100s to smooth scroll.  
C
C	CALL Display_Help(Cstring,Iterminal,Itop,Ibot)
C	
C	Where
C		Cstring	   Character	Help string specifier for VPW_HELP
C		Iterminal  Integer*4	Terminal identification code
C		Itop	   Integer*4	Top line of scroll region
C		Ibot	   Integer*4	Bottom line of scroll region
C
C	When the help information is finished displaying, Display_Help
C	will wait for the user to press RETURN and then restore the
C	scrolling region and return the terminal to jump scroll.
C
C-
	SUBROUTINE DISPLAY_HELP(Cstring,Iterminal,Itop,Ibot)
	CHARACTER*(*)	Cbold
	CHARACTER*(*)	Cnorm
	CHARACTER*(*)	Press_msg
	CHARACTER*(*)	Press_msg2
	Character*80	Cans
	CHARACTER*(*)	Cstring
	INTEGER*4	Ilength
	PARAMETER (Cbold=CHAR(27)//'[1m')
	PARAMETER (Cnorm=CHAR(27)//'[0m')
	PARAMETER (Press_msg='Press '//Cbold//
     -		   'RETURN'//Cnorm//' to continue')
	PARAMETER (Press_msg2=CHAR(13)//CHAR(10)//CHAR(10)//
     -			      'Press RETURN to continue')

	CALL SCREEN(' ',Iterminal,Itop,0,1)		! Erase to end of Sc

	CALL VPW_SCROLL(Iterminal,Itop+1,Ibot,1)	! scroll window/smooth
	CALL SCREEN(' ',ITERMINAL,Itop+1,0,0)		! Position to start
	CALL VPW_HELP(Cstring,1)			! Display HELP info
	IF(Iterminal.GE.96	.AND.			!
     -	   Ibot.EQ.24)			TYPE *,' '	! For clarity
	TYPE *,' '					!
	IF(Iterminal.GE.96)			THEN	! If VT100
	   CALL SCREEN(Press_msg,Iterminal,24,0,0)	!
	ELSE						! If not leave out
	   CALL SCREEN(Press_msg2,Iterminal,24,0,0)	!  bolding
	END IF						!
	CALL READ_STRING(Cans,Ilength)			!
	IF(Ilength.EQ.-1)		      GOTO 9999 ! ^Z exit
	CALL VPW_Scroll(Iterminal,1,24,0)		! Scroll full window
	IF(Iterminal.GE.96)CALL SCREEN(' ',Iterminal,Itop,1,0)	! For VT100 bug
	RETURN						!
9999	CALL EXIT
	END
