	PROGRAM GETPID
C
C	This little program does nothing more than
C	translate a given process name into the
C	PID. Real handy if you need
C	to do a STOP/ID, but don't want to look
C	at the whole SHOW SYSTEM bullshit.
C
C		Davie Cook	27-Aug-81
C
	EXTERNAL	JPI$_PID
	EXTERNAL	JPI$_PRCNAM
	EXTERNAL	SS$_NORMAL
	EXTERNAL	SS$_NOMOREPROC

	INTEGER*4	SS$_NORMAL
	INTEGER*4	SS$_NOMOREPROC
	INTEGER*4	SYS$GETJPI

	CHARACTER	PROCESS*15, STRING*15
	INTEGER*4	PID, JPID

	INTEGER*2	ITMLST (14)
	INTEGER*4	ITMLST4 (7)
	EQUIVALENCE	(ITMLST, ITMLST4)

	LOGICAL		FOUND_ONE	/.FALSE./
C
C	Find out just what in the hell this dude wants.
C
	CALL IFERR (LIB$GET_FOREIGN (PROCESS, 'Process ? ', LEN),
	1	'LIB$GET_FOREIGN error.')

	IF (LEN .EQ. 0) THEN
C
C	If requestor input a blank line, we'll be
C	doing a wildcard search and printing out
C	all the process and PID's. Therefore, put
C	out a list header.
C
	   WRITE (6, 1000)
1000	   FORMAT (' Process', T19, 'PID')
	END IF
C
C	Now we start looking for info.
C
	   PID = -1

100	   LAST_PID = PID

	   STRING = ' '
	   ITMLST (1) = 15
	   ITMLST (2) = %LOC ( JPI$_PRCNAM )
	   ITMLST4 (2) = %LOC ( STRING )
	   ITMLST4 (3) = 0

	   JPID = 0
	   ITMLST (7) = 4
	   ITMLST (8) = %LOC ( JPI$_PID )
	   ITMLST4 (5) = %LOC (JPID)
	   ITMLST4 (6) = 0

	   ITMLST4 (7) = 0

	   ICODE = SYS$GETJPI (,PID,,ITMLST,,,)
C
C	Search 'til all processes listed.
C
	   IF (ICODE .EQ. %LOC ( SS$_NOMOREPROC ) ) THEN
	      IF (LEN .EQ. 0) THEN
		STOP ' '
	      ELSE IF (FOUND_ONE) THEN
		STOP ' '
	      ELSE
		STOP 'Process not found.'
	      END IF
C
C	GETJPI error.
C
	   ELSE IF (ICODE .NE. %LOC ( SS$_NORMAL ) ) THEN
	      CALL ERRMES (ICODE)
	      STOP 'Unusual error exit.'
	   END IF

	   NS = NBLANK ( STRING )
	   IF (LEN .EQ. 0) THEN
C
C	Print out the process and PID.
C
	      WRITE (6, 1010) STRING (1:NS), JPID
1010	      FORMAT (1H , A, T16, Z8.8)
C
C	Else it's a specific process name he was
C	looking for and, by golly, I guess we found it !!!
C
	   ELSE IF (PROCESS (1:LEN) .EQ. STRING (1:LEN)) THEN

	      WRITE (6, 1020) STRING (1:NS), JPID
1020	      FORMAT (' Process = ', A, T27, 'PID = ', Z8.8)
	      FOUND_ONE = .TRUE.

	   END IF
C
C	Keep going 'til all processes listed.
C
	   GO TO 100

	END
