	SUBROUTINE GETOWNER (PID, OWNER)

C	This subroutine returns the owner process
C	name for a given PID.
C
C	Notes :	Remember to link in JPIDEF to pick up
C		the external reference.
C
C		You must have WORLD privilege to get at
C		JPI info other than your own.
C
C		D. Cook
C	Ball Aerospace Systems Division
C		10/10/81

	EXTERNAL	JPI$_USERNAME

	INTEGER*4	PID
	CHARACTER*12	OWNER

	INTEGER*2	ITMLST2 (8)
	INTEGER*4	ITMLST4 (4)

	EQUIVALENCE	(ITMLST2, ITMLST4)

	ITMLST2 (1) = 12
	ITMLST2 (2) = %LOC (JPI$_USERNAME)
	ITMLST4 (2) = %LOC (OWNER)
	ITMLST4 (3) = 0
	ITMLST4 (4) = 0

	CALL IFERR (SYS$GETJPI (,PID,,ITMLST2,,,),
	1	'GETJPI error.')

	RETURN

	END
