	SUBROUTINE PORT_DSPY (LPORTS, OWNER, NPORTZ, N_START)

C	This subroutine displays the status of the ports
C	as determined by the calling routine PORTS.
C
C	This routine is simply a brute force mechanism at
C	this time. Hopefully I will make it easier to
C	select ports to display and to modify the port
C	configuration in the not too distant future.
C
C		D. Cook
C	Ball Aerospace Systems Division
C		10/9/81

	PARAMETER NPORTS = 64
	PARAMETER NBANKS = NPORTS / 8

	LOGICAL LPORTS (NPORTS)
	CHARACTER*12 OWNER (NPORTS)

	LOGICAL LBANKS (NBANKS)

	LOGICAL FIRST	/.TRUE./

	CHARACTER*6 CPORT, TERM_NAME

	CHARACTER*80 LINE

	IF (FIRST) THEN
	   FIRST = .FALSE.

C	Put headers on the screen.

	   CALL IFERR ( LIB$ERASE_PAGE (1, 1),
	1	'ERASE_PAGE error.')

	   LINE_NUM = 1
	   DO IPORTS = 1, NBANKS
		 LINE = ' '
	         DO IP = 1, 8
		    IPP = ((IPORTS - 1) * 8) + IP + N_START
		    ILP = ((IP - 1) * 10) + 1
		    CPORT = TERM_NAME (IPP)
		    LINE (ILP:) = CPORT (2:)
	         END DO
	         CALL PUTSCRN (LINE, LINE_NUM, 1)
	         LINE_NUM = LINE_NUM + 3
	   END DO
	END IF

C	Now update the screen.

	LINE_NUM = 2
	DO IPORTS = 1, NBANKS
	      LINE = ' '
	      DO IP = 1, 8
		IPP = ((IPORTS - 1) * 8) + IP
		ILP = ((IP - 1) * 10) + 1
		LINE (ILP:) = OWNER(IPP)(1:9)
	      END DO
	      CALL PUTSCRN (LINE, LINE_NUM, 1)
	      LINE_NUM = LINE_NUM + 3
	END DO

	RETURN

	END
