!
! Command procedure to build and install the send
!    program. Note that the executable image must be
!    installed with WORLD privilege to access all the
!    processes on the system with GETJPI, and OPER priv
!    to use BRDCST to remote terminals.
!
!		Dave Cook
!	Ball Aerospace Systems Division
!		(303) 441-4058
!		26-Aug-82
!
$ fort/list send
$ fort/list getpid
$ fort/list getterm
$ link send,getpid,getterm,[-.ncarsubs]ncarsubs/lib
$!!! delete *.obj;*
$ purge
$ copy send.exe sys$system:
$ mcr install
sys$system:send/priv=(world,oper)
!
! Note that the following 'set command' command is only
!    temporary when executed here. It should be installed
!    in SYS$MANAGER:SYSLGI.COM. The command syntax table
!    SEND.CLD should also be installed in the SYS$MANGER:
!    directory in order for the 'set command' to reference
!    it at login time.
!
$ set command send
