	logical function get_term (user_name, term_name)
c
c	Little subroutine to get a user's terminal name
c		when given his process username.
c
c			Dave Cook
c		Ball Aerospace Systems Division
c			2-Sept-82
c
	implicit integer (a - z)

	external	jpi$_username, jpi$_terminal
	external	ss$_normal, ss$_nomoreproc
	integer*4	ss$_normal, ss$_nomoreproc

	character*(*)	user_name, term_name
	character*12	name, term

	integer*4	jpi_list_4(7)
	integer*2	jpi_list_2(14)
	equivalence	(jpi_list_4, jpi_list_2)

	integer*4	sys$getjpi, n_len, pid
c
c	Form the jpi list.
c
	jpi_list_2(1) = 12
	jpi_list_2(2) = %loc(jpi$_username)
	jpi_list_4(2) = %loc(name)
	jpi_list_4(3) = %loc(n_len)

	jpi_list_2(7) = 6
	jpi_list_2(8) = %loc(jpi$_terminal)
	jpi_list_4(5) = %loc(term)
	jpi_list_4(6) = %loc(t_len)

	jpi_list_4(7) = 0
c
c	Do a "wildcard" search for the hoser in question.
c
	pid = -1
	u_len = nblank (user_name)
	get_term = .true.

10	istat = sys$getjpi (,pid,,jpi_list_4,,,)
c
c	Handle return condition.
c
	if (istat .eq. %loc(ss$_nomoreproc)) then
	   get_term = .false.
	   return
	else if (istat .ne. %loc(ss$_normal)) then
	   call errmes (istat)
	   stop	'Error exit.'
	end if
c
c	Loop 'til no-more-processes or else user-found.
c
	if (name(1:u_len) .ne. user_name(1:u_len)) go to 10
d	type *,'user_name = ',user_name
d	type *,'name = ',name
d	type *,'t_len =',t_len
d	type *,'term = ',term
	term_name = term

	return

	end
