$TOP:
$!  Issue instructions to the user
$TYPE SYS$INPUT 

This procedure adds a NOTICE which will be displayed once for each user.

When the screen clears, enter the notice exactly as it should appear on
the user's terminal.  A date and time will be added automatically when
the notice is sent to the user.  When finished with the notice, hit a 
Control-Z, then enter the command EXIT.


$INQUIRE DUMMY "Hit CR to proceed."
$!  Put the user into EDT
$ DEFINE/USER SYS$INPUT SYS$COMMAND
$EDIT/EDT NOTICE.TMP
$!  Replay the notice and ask for verification
$WRITE SYS$OUTPUT "Please verify that the notice is correct:"
$TYPE NOTICE.TMP
$INQUIRE REPLY "Is notice correct? "
$IF .NOT.REPLY  THEN $GOTO TOP
$!  Copy the correct file to BAT$MAIL
$COPY/PROT=W:R NOTICE.TMP BAT$MAIL:NOTICE.TXT
$ DELETE NOTICE.TMP;*
$EXIT
$!
$!++
$!  Title:
$!	ADDNOTICE Add a new system notice
$!  Facility:
$!	System notice processing as handled by LNOTICE and NOTICE utilities.
$!  Abstract:
$!  Procedure to allow operators to define new system notices.
$!
$!  Environment:
$!	DCL command interpreter.  Must be run from account with privilege
$!	to copy a file into directory BAT$MAIL.
$!  Author:
$!	Gary L. Grebus, Creation date: 9-Apr-80
$!  Modified by:
$!	1.00 - Original version
$!
$!	1.01 - 15-Nov-1980  Gary L. Grebus
$!		Changed SYS$MAIL to BAT$MAIL
$!

