$	type sys$input
$DECK
    This command file creates the DISKUSE program in the
    current area. The creation is an unprivileged action.
    Before actually installing DISKUSE, this file will ask
    you if you wish to continue.
    Installation of DISKUSE requires some pretty
    hefty privileges; do not install DISKUSE before reading
    the documentation.
$EOD
$	INQUIRE answer "Are you ready to continue (Y/N) "
$	if answer .nes. "Y" then $ EXIT
$	type sys$input
$DECK
    Assembling DISKUSE by assembling DISKUSE.MAR and GETDISK.MAR.
    This takes a few moments; please be patient.
$EOD
$	MACRO/LIST DISKUSE
$	MACRO/LIST GETDISK
$	type sys$Input
$DECK
    Linking DISKUSE by linking modules DISKUSE, GETDISK, and
    the system symbol table. This is a short process.
$EOD
$	LINK/MAP DISKUSE,GETDISK+SYS$SYSTEM:SYS.STB/SELECTIVE
$	INQUIRE answer "Do you want to copy to system areas (Y/N) "
$	if answer .nes. "Y" then $ EXIT
$	type sys$input
$DECK
    Copying DISKUSE to SYS$SYSTEM:DISKUSE.EXE and protecting
    it suitably. I'll set the owner to [1,4] and try to install
    it. If you want to use DISKUSE, you'll have to add 
    $ MCR INSTALL DISKUSE/PRIV=(SYSPRV,CMKRNL)
    to your system startup files
    and you'll probably want to 
    $ RUN SYS$SYSTEM:DISKUSE
    in the system-wide LOGIN.COM file. This shouldn't take more
    than a few seconds.
$EOD
$	COPY DISKUSE.EXE SYS$SYSTEM:DISKUSE.EXE
$	SET PROT=(S:RWED,O:RWED,G:RWED,W:E) SYS$SYSTEM:DISKUSE.EXE
$	SET FILE/OWNER=[1,4] SYS$SYSTEM:DISKUSE.EXE
$	MCR INSTALL DISKUSE/OPEN/SHARED/PRIV=(SYSPRV,CMKRNL)
$	type sys$input
$DECK
    If you are a current user of DISKUSE V1, now is the time to
    set the protection on your quota files high enough so that
    users can't write all over them. If you've never used DISKUSE,
    your quota files should be adequately protected.
$EOD
$ Exit 1
