	SUBROUTINE LIST
C COPYRIGHT (C) 1983 GLENN EVERHART
C PERMISSION IS GIVEN TO ANYONE TO USE, DISTRIBUTE, OR COPY THIS
C PROGRAM FREELY BUT NOT TO SELL IT COMMERICALLY.
	INCLUDE 'VKLUGPRM.FTN'
C	PARAMETER RRW = 32
C	PARAMETER RCL = 32
C RRW=MAX REAL ROWS
C RCL=MAX REAL COLS
C RRW MUST BE 1 LARGER TO HANDLE 1ST 27 VARIABLES IN AVBLS
C VBLS AND TYPE DIMENSIONED RRW,RCL
C **************************************************
C *                                                *
C *              SUBROUTINE  LIST                  *
C *                                                *
C **************************************************
C
C
C LISTS THE LEGAL CALC COMMANDS AND GIVES A BRIEF
C DESCRIPTION OF THEIR FUNCTION.
C
C
C
C MODIFICATION CLASSES: M1
C
C
C
C
C
C
C LIST IS CALLED BY CALC
C
C
C
C
C
C
C	SUBROUTINE LIST
C  
C
	WRITE (1,10)
	WRITE (1,20)
	WRITE (1,30)
	WRITE (1,40)
	WRITE (1,50)
	WRITE (1,60)
	WRITE (1,70)
	WRITE (1,80)
	WRITE (1,90)
	WRITE (1,100)
	WRITE (1,110)
	WRITE (1,120)
	WRITE (1,130)
	WRITE (1,140)
	WRITE (1,150)
	WRITE (1,160)
	WRITE (1,170)
	WRITE (1,180)
	WRITE (1,190)
	RETURN
10	FORMAT (' COMMANDS-')
20	FORMAT (' *@FILENAME  EXECUTE FILE OF CALC COMMANDS')
30	FORMAT (' *ASCII      DECLARE VARIABLES OF TYPE ASCII')
40	FORMAT (' *B          SET DEFAULT BASE FOR CONSTANTS')
50	FORMAT (' *C          COMMENT, IGNORE REST OF LINE')
60	FORMAT (' *DECIMAL    DECLARE VARIABLE OF TYPE DECIMAL POINT')
70	FORMAT (' *E          EXIT')
80	FORMAT (' *HEX        DECLARE VARIABLE OF TYPE HEXADECIMAL')
90	FORMAT (' *INTEGER    DECLARE VARIABLE OF TYPE INTEGER')
100	FORMAT (' *M10        DECLARE VARIABLE MULTI-PRECISION BASE 10')
110	FORMAT (' *M8         DECLARE VARIABLE MULTI-PRECISION OCTAL',
     ;         ' INTEGER')
120	FORMAT (' *M16        DECLARE VARIABLE MULTI-PRECISION',
     ;         ' HEXADECIMAL INTEGER')
130	FORMAT (' *N          NOVIEW --WHEN VARIABLE IS ASSIGNED ',
     ;         ' DON''T PRINT VALUE')
140	FORMAT (' *OCTAL      DECLARE VARIABLE OF TYPE OCTAL')
150	FORMAT (' *R          READ --ALLOW SINGLE LINE OF INPUT',
     ;         ' WHILE IN A COMMAND FILE')
160	FORMAT (' *REAL       DECLARE A VARIABLE TO BE OF TYPE REAL')
170	FORMAT (' *S          STOP OR EXIT')
180	FORMAT (' *V          VIEW --PRINT VALUE OF VARIABLES WHEN',
     ;         ' NEW VALUE IS ASSIGNED')
190	FORMAT (' *Z          ZERO ALL VARIABLES')
	END
