C..FingMaint.For			Maintain  finger shared commons
C..					R. Garland / C.U.Chemistry / 7-Oct-1983

	Program	FingMaint

c	Note: actually this is called by LIB$INITIALIZE (below)

	Include		'($RMSDEF)'

	Integer		Cli_Flags, Cli$M_Verify /4/
	Integer		I_Length
	Integer		Cli$Dcl_Parse, Cli$Dispatch
	Character	Line*255
	Integer		Lib$Get_Input
	Character	Lib$Get_Foreign*255
	External	Shr_Cld, Signal_Handler

	Common		/Init_flags/ Cli_Flags

	Call Lib$Establish(Signal_Handler)

	Line = Lib$Get_Foreign(,I_Length)
	If ( I_Length .gt. 0 ) then
	    If ( Cli$Dcl_Parse(Line(:I_Length),Shr_Cld) )
	1	Call Cli$Dispatch
	    Call Exit
	End if

	Do while(.true.)
	    If ( Lib$Get_Input(Line,'Finger Maintain> ',I_length)
	1	.eq. Rms$_Eof ) Call Exit
	    If ( I_Length .gt. 0 ) then
		If ( (Cli_Flags .and. Cli$M_Verify) .ne. 0 )
	1		Call Lib$Put_Output(
	2			'Finger Maintain> '//Line(:I_Length))
		If ( Cli$Dcl_Parse(Line(:I_Length),Shr_Cld) )
	1	Call Cli$Dispatch
	    End if
	End do

	End

c------------------------------------------------------------------------------
	Subroutine Lib$Initialize(Transfer_array,
	1			CLI_Dispatcher,
	2			Image_Header,
	3			Image_File_desc,
	4			Link_Flags_VAl,
	5			CLI_Flags_Val)

c	Note:	This is called first by the image activator
c		and in turn calls the main routine. this is so
c		it can get the CLI flags for the main routine.

	Integer		Transfer_array,
	1		CLI_Dispatcher,
	2		Image_Header,
	3		Image_File_Desc,
	4		Link_Flags_VAl, Link_Flags,
	5		CLI_Flags_Val, CLI_Flags

	Common	/Init_Flags/ Cli_Flags

	CLI_Flags = %Loc(CLI_Flags_Val)
	Call FingMaint

	Return
	End

c------------------------------------------------------------------------------
	Integer Function Shr_Add

	Include		'Fingercom.for'

	Character*12	UserName
	Character*25	Owner, PersonalName
	Character	Terminal*7, Location*25, TTType*25
	Character	Host*12, Type*1, Link*12, Route*72
	Logical*1	Record(272)
	Equivalence	(Owner, Record(115))
	Integer		Cli$Present
	Integer		Cli$Get_Value

	Shr_Add = 1

	If ( Cli$Present('USER') ) then
c	  Add User(s)
	    If ( Cli$Present('UAF') ) then
c	      Create the username database (shareable image) from the UAF
		Open(	Unit = 10,
	1		File = 'SYS$SYSTEM:SYSUAF.DAT',
	2		Readonly,
	3		Shared,
	4		Type = 'OLD')
		ii = 1
		Do while (.true.)
		    Read(10,1000,
	2		End= 200)	Username,	Record
	 	   Usr$C_Username(ii) = Username
	 	   Usr$C_Personalname(ii) = Owner
	 	   ii = ii + 1
	 	   If ( ii .eq. Usr$I_Max ) Goto 200
		End do
200		Continue
		Usr$I_Last = ii - 1
		Return
	    End if
	    If ( .not. Cli$Get_Value('USER',UserName) ) Return
	    If ( .not. Cli$Get_Value('PERSONALNAME',Owner) ) Return
	    If ( Usr$I_Last .ge. Usr$I_Max ) Return
	    Usr$I_Last = Usr$I_Last + 1
	    Usr$C_Username(Usr$I_Last) = UserName
	    Usr$C_Personalname(Usr$I_Last) = Owner
	    Return
	Else if ( Cli$Present('TERMINAL') ) then
	    If ( .not. Cli$Get_Value('TERMINAL',Terminal) ) Return
	    If ( .not. Cli$Get_Value('LOCATION',Location) ) Return
	    If ( .not. Cli$Get_Value('TTType',TTType) ) TTType = ' '
	    If ( Loc$I_Last .ge. Loc$I_max ) Return
	    Loc$I_Last = Loc$I_Last + 1
	    Loc$C_Terminal(Loc$I_Last) = Terminal
	    Loc$C_Location(Loc$I_Last) = Location
	    Loc$C_TTType(Loc$I_Last) = TTType
	    Return
	Else if ( Cli$Present('HOST') ) then
	    If ( .not. Cli$Get_Value('HOST',Host) ) Return
	    If ( Host$I_Last .ge. Host$I_max ) Return
	    If ( .not. Cli$Get_Value('TYPE',Type) ) Type = 'D'
	    If ( .not. Cli$Get_Value('LINK',Link) ) Link = ' '
	    If ( .not. Cli$Get_Value('ROUTE',Route) ) Route = ' '
	    Host$I_Last = Host$I_Last + 1
	    Host$C_Host(Host$I_Last) = Host
	    Host$C_Type(Host$I_Last) = Type
	    Host$C_Link(Host$I_Last) = Link
	    Host$C_Route(Host$I_Last) = Route
	    Return
	End if

1000	Format(A,272A1)

	End

c------------------------------------------------------------------------------
	Integer Function Shr_Show

	Include		'Fingercom.for'

	Character	Username*12, Terminal*7, Host*12
	Integer		Cli$Present
	Integer		Cli$Get_Value

	Shr_Show = 1

	If ( Cli$Present('USER') ) then
	    If ( Cli$Present('ALL') ) then
		Write(6,1001) Usr$I_Last, Usr$I_Max
		Do ii = 1,Usr$I_Last
		    Write(6,1002) ii, Usr$C_Username(ii),
	1		Usr$C_Personalname(ii)
		End do
	    Else if ( Cli$Get_Value('USER',Username) ) then
		Do ii = 1,Usr$I_Last
		    If ( Username .eq. Usr$C_Username(ii) ) then
			Write(6,1002) ii, Usr$C_Username(ii),
	2		    Usr$C_Personalname(ii)
			Return
		    End if
	 	End do
		Write(6,4001)
	    End if
	End if
	If ( Cli$Present('TERMINAL') ) then
	    If ( Cli$Present('ALL') ) then
		Write(6,2001) Loc$I_Last, Loc$I_Max
		Do ii = 1,Loc$I_Last
		    Write(6,2002) ii, Loc$C_Terminal(ii),
	1		Loc$C_Location(ii),
	2		Loc$C_TTType(ii)
		End do
	    Else if ( Cli$Get_Value('TERMINAL',Terminal) ) then
		Do ii = 1,Loc$I_Last
		    If ( Terminal .eq. Loc$C_Terminal(ii) ) then
			Write(6,2002) ii, Loc$C_Terminal(ii),
	2		    Loc$C_Location(ii),
	3		    Loc$C_TTType(ii)
			Return
		    End if
		End do
		Write(6,4001)
	    End if
	End if
	If ( Cli$Present('HOST') ) then
	    If ( Cli$Present('ALL') ) then
		Write(6,3001) Host$I_Last, Host$I_Max
		Do ii = 1,Host$I_Last
		    Write(6,3002) ii, Host$C_Host(ii),
	1		Host$C_Type(ii),
	2		Host$C_Link(ii),
	3		Host$C_Route(ii)
		End do
	    Else if ( Cli$Get_Value('HOST',Host) ) then
		Do ii = 1,Host$I_Last
		    If ( Host .eq. Host$C_Host(ii) ) then
			Write(6,3002) ii, Host$C_Host(ii),
	1		Host$C_Type(ii),
	2		Host$C_Link(ii),
	3		Host$C_Route(ii)
			Return
		    End if
		End do
		Write(6,4001)
	    End if
	End if
		

1001	Format(1X,'Number users: ',I3,', Maximum storage: ',I3)
1002	Format(1X,'(',I3,') Username: ',A,' Personal name: ',A)
2001	Format(1X,'Number terminals: ',I3,', Maximum storage: ',I3)
2002	Format(1X,'(',I3,') Terminal: ',A,' Location: ',A,
	1	' Type: ',A)
3001	Format(1X,'Number hosts: ',I3,', Maximum storage: ',I3)
3002	Format(1X,'(',I3,') Host: ',A,' Type: ',A,
	1	' Link: ',A,' Route: ',A)
4001	Format(1X,'Entry not found.')
	End

c------------------------------------------------------------------------------
	Integer Function Shr_Clear

	Include		'Fingercom.for'

	Integer		Cli$Present
	Integer		Cli$Get_Value

	Shr_Clear = 1

	If ( Cli$Present('USER') ) then
	    Usr$I_Last = 0
	    Usr$I_Max = max_users
	End if
	If ( Cli$Present('TERMINAL') ) then
	    Loc$I_Last = 0
	    Loc$I_Max = max_terms
	End if
	If ( Cli$Present('HOST') ) then
	    Host$I_Last = 0
	    Host$I_Max = max_terms
	End if
	If ( Cli$Present('ALL') ) then
	    Usr$I_Last = 0
	    Usr$I_Max = max_users
	    Loc$I_Last = 0
	    Loc$I_Max = max_terms
	    Host$I_Last = 0
	    Host$I_Max = max_terms
	End if

	Return

	End

c------------------------------------------------------------------------------
	Integer Function Shr_Help

	Integer		Lbr$Output_Help
	Character	Line*132
	Character	HelpLibrary*18 /'SYS$HELP:FINGMAINT'/
	External	Lib$Get_Input, Lib$Put_Output

	Call Cli$Get_Value('$LINE',Line)
c  skip over "HELP" word
	i1 = Index(Line,'H')
	i2 = Index(Line(i1:),' ') + i1
c  call help librarian
	Shr_Help = Lbr$Output_Help(Lib$Put_Output,,Line(i2:),
	1	HelpLibrary,,Lib$Get_Input)

	Return

	End

c------------------------------------------------------------------------------
	Integer Function Shr_Exit

	Call Exit

	End

c------------------------------------------------------------------------------
	Integer Function Signal_Handler(
	1	SignalVector,MechanismVector)

	Integer		SignalVector(8),	MechanismVector(5)
	Integer		SS$_Status,	SS$_Normal/1/
	Integer		MsgLen
	Character	Msg*132

	Signal_Handler = SS$_Normal	! Continue after condition
	SS$_Status = SignalVector(2)
	If ( SS$_Status .eq. SS$_Normal ) Return

	Call Sys$Getmsg(%Val(SS$_Status),Msglen,Msg,%VAL(1),)
	Call Lib$Put_Output(Msg(:Msglen))

	Return

1001	Format(1X,A)
	End
