	SUBROUTINE BOARD (NAR, INIT)

	LOGICAL		INIT
	DIMENSION	NAR(8,8), MAR(8,8)
	BYTE		BESC		/Z1B/
	CHARACTER*19	LINE (9)

	DATA	LINE(1)	/'   1 2 3 4 5 6 7 8 '/
	DATA	LINE(2)	/' A ~ ~ ~ ~ ~ ~ ~ ~ '/
	DATA	LINE(3)	/' B ~ ~ ~ ~ ~ ~ ~ ~ '/
	DATA	LINE(4)	/' C ~ ~ ~ ~ ~ ~ ~ ~ '/
	DATA	LINE(5)	/' D ~ ~ ~ ~ ~ ~ ~ ~ '/
	DATA	LINE(6)	/' E ~ ~ ~ ~ ~ ~ ~ ~ '/
	DATA	LINE(7)	/' F ~ ~ ~ ~ ~ ~ ~ ~ '/
	DATA	LINE(8)	/' G ~ ~ ~ ~ ~ ~ ~ ~ '/
	DATA	LINE(9)	/' H ~ ~ ~ ~ ~ ~ ~ ~ '/

	DATA	MAR	/64*0/

C	Set screen for reverse video and special graphics.
	WRITE (5, 1100) BESC, BESC
1100	FORMAT (1H ,1A1,'[7m',1A1,'(0')
	IF (INIT) THEN
	   INIT = .FALSE.
C	Clear the screen and home the cursor.
	   WRITE (5, 1020) BESC
1020	   FORMAT (1H ,1A1,'[2J')
	   WRITE (5, 1030) BESC, BESC, LINE(1)
1030	   FORMAT (1H , 1A1, '[1;1H', 1A1, '#3', A)
C	Print the top header.
1000	   FORMAT (1H , 1A1, '#3', A)
	   WRITE (5, 1010) BESC, LINE(1)
1010	   FORMAT (1H , 1A1, '#4', A)
C	Print the board.
	   DO I = 2, 9
	      WRITE (5, 1000) BESC, LINE(I)
	      WRITE (5, 1010) BESC, LINE(I)
	   END DO
C	Clear the temp board.
	   DO I = 1, 8
	      DO J = 1, 8
		MAR(I,J) = 0
	      END DO
	   END DO
C	End of initialization.
	END IF

C	Print new pieces on board.
	DO I = 1, 8
	   DO J = 1, 8
	      IF ( NAR(I,J) .EQ. MAR(I,J)) GO TO 30
	      MAR(I,J) = NAR(I,J)
		LINENO = ((I - 1) * 2) + 3
		ICOL = (J * 2) + 2
		LL = 1
		IF (LINENO .GE. 10) LL = 2
		LC = 1
		IF (ICOL .GE. 10) LC = 2
	      IF ( NAR(I,J) - 1 ) 25, 20, 10
C
C	Draw the white pieces.
C
10		WRITE (5, 2000) BESC, LINENO, ICOL, BESC
2000		FORMAT (1H ,1A1,'[',I<LL>,';',I<LC>,'H',1A1,'#30')
		LINENO = LINENO + 1
		IF (LINENO .GE. 10) LL = 2
		WRITE (5, 2010) BESC, LINENO, ICOL, BESC
2010		FORMAT (1H ,1A1,'[',I<LL>,';',I<LC>,'H',1A1,'#40')
		GO TO 30
C
C	Draw the black pieces.
C
20		CONTINUE
		WRITE (5, 3000) BESC, LINENO, ICOL, BESC
3000		FORMAT (1H ,1A1,'[',I<LL>,';',I<LC>,'H',1A1,'#3`')
		LINENO = LINENO + 1
		IF (LINENO .GE. 10) LL = 2
		WRITE (5, 3010) BESC, LINENO, ICOL, BESC
3010		FORMAT (1H ,1A1,'[',I<LL>,';',I<LC>,'H',1A1,'#4`')
		GO TO 30
C
C	Draw the blanks.
C
25		CONTINUE
		WRITE (5, 4000) BESC, LINENO, ICOL, BESC
4000		FORMAT (1H ,1A1,'[',I<LL>,';',I<LC>,'H',1A1,'#3~')
		LINENO = LINENO + 1
		IF (LINENO .GE. 10) LL = 2
		WRITE (5, 4010) BESC, LINENO, ICOL, BESC
4010		FORMAT (1H ,1A1,'[',I<LL>,';',I<LC>,'H',1A1,'#4~')

30	     CONTINUE
	   END DO
	END DO
C	Clear reverse video and special graphics.
	WRITE (5, 1110) BESC, BESC
1110	FORMAT (1H ,1A1,'[0m',1A1,'(B')

	RETURN

	END
