	PROGRAM ROME
C
C  Author: John Fedak
C	   Computer Science Department
C	   University of Pennsylvania
C
C  Date:   Spring 1977
C
C  Submitted by:
C
C          Ira Winston
C	   200 South 33rd Street
C	   Philadelphia, PA  19104
C	   (215)-243-4707
C
C Modified 29-Nov-81 :
C
C	Added VT100 cursor addressing.
C
C	   Dave Cook	29-Nov-81
C	   Ball Aerospace Systems Division
C	   Boulder, Colo.  80306
C	   (303)-441-4000
C
	CHARACTER*1	DUMDUM
	CHARACTER*80	SCRLINE
	LOGICAL		REDRAW	/.TRUE./
	DIMENSION	SAVE_BRD(8,8,40)

	DATA		LPRMPT	/22/
	DATA		LCMMD	/20/
	DATA		LEND1	/20/
	DATA		LEND2	/22/
	DATA		JVLINE	/23/
	DATA		JLINE	/5/
	DATA		JMOVE	/0/

      DIMENSION NRAY(8,8),INRAY(8,8),STR(8,8),NUMS(10)
      COMMON FR
      DATA NUMS/'0','1','2','3','4','5','6','7','8','9'/
      DATA LTA,LTB,LTC,LTD,LTE/'A','B','C','D','E'/
      DATA LTF,LTG,LTH,LTY,LTS/'F','G','H','Y','S'/
      DATA STR /200.,50.,60.,32.,32.,60.,50.,200.,
     2		50.,1.,2.,3.,3.,2.,1.,50.,
     3		60.,2.,18.,8.,8.,18.,2.,60.,
     4		48.,3.,8.,10.,10.,8.,3.,48.,
     5		48.,3.,8.,10.,10.,8.,3.,48.,
     6		60.,2.,18.,8.,8.,18.,2.,60.,
     7		50.,1.,2.,3.,3.,2.,1.,50.,
     8		200.,50.,60.,32.,32.,60.,50.,200./
      NFLAG=0
      IFLAG=0
      JLF=0
      JKF=0
      FR=1
C
C	Initialize board. Set initial pieces.
C
      DO I1=1,8
         DO I2=1,8
            NRAY(I1,I2)=0
            NRAY(I1,I2)=0
         END DO
      END DO
      NRAY(4,4)=1
      NRAY(4,5)=2
      NRAY(5,4)=2
      NRAY(5,5)=1

	CALL IFERR ( LIB$ERASE_PAGE (1, 1),
	1	'ERASE_PAGE error in Othello main.')
	CALL PUTSCRN (' Welcome to Othello', LCMMD, 1)
	CALL PUTSCRN (' Do you wish instructions ? ', LPRMPT, 1)

      READ(5,80,END=1000)JNS
80    FORMAT(A1)
      CALL UPCASE(JNS)
      IF(JNS.NE.LTY)GOTO 280

100	REDRAW = .TRUE.
	CALL IFERR ( LIB$ERASE_PAGE (1, 1),
	1	'ERASE_PAGE error in Othello main.')

      WRITE(5,120)
120   FORMAT(/' Rules are the same as standard OTHELLO. ',
     2/' Black is represented as an "*" and white as an "0".',
     3/' A blank space is represented as a ".".')
      WRITE(5,140)
140   FORMAT(/' When it is your move, you may issue any of ',
     2'the following commands:')
      WRITE(5,160)
160   FORMAT(/' S1: Display current status of the board.')
      WRITE(5,180)
180   FORMAT(' S2: Set flag to display relative values of ',
     2'The computers possible moves.',/3X,'  (the computer will',
     3' choose the move with the least value.)'/,
     4' S3: clear the S2 flag')
      WRITE(5,200)
200   FORMAT(' S4: Set flag to display strategic "score" ',
     2'After your move.'/' S5: Clear the S4 flag.')
      WRITE(5,220)
220   FORMAT(' S6: Enter board initialization mode where you ',
     2'may preset or change any',/3X,'  piece on the board.')
      WRITE(5,240)
240   FORMAT(' S7: Write these instructions')
      WRITE(5,260)
260   FORMAT(' S8: Stop the game')
      WRITE(5,261)
261   FORMAT(' S9: Unwind the board to the last move')
      WRITE(5,268)
268   FORMAT(/' Hit <CR> to continue.')
      READ(6,269)DUMDUM
269   FORMAT(A)
      CALL BOARD(NRAY,REDRAW)
C
C	If he has come through help while within a game
C	then it's his turn now, re-enter at his move.
C
      IF(IFLAG.EQ.1)GOTO 410

280   CONTINUE
      CALL PUTSCRN (' Do you wish to be black ? ', LPRMPT, 1)
      READ(5,320,END=1000)LNS
320   FORMAT(A1)
      CALL UPCASE(LNS)

	CALL IFERR ( LIB$ERASE_PAGE (1, 1),
	1	'ERASE_PAGE error in Othello main.')
	REDRAW = .TRUE.

      IF(LNS.NE.LTY)GOTO 660
      NC=1
      NCM=2

C
C	Main Loop.
C
340    CALL BOARD(NRAY,REDRAW)

      DO 360 IT1=1,8
      DO 360 IT2=1,8
360    INRAY(IT1,IT2)=NRAY(IT1,IT2)
      DO 380 IT1=1,8
      DO 380 IT2=1,8
      NLEG=0
      CALL MOVE(IT1,IT2,NC,INRAY,NLEG)
      IF(NLEG.EQ.1)GOTO 400
380   CONTINUE
	CALL PUTSCRN (' You cannot move.', LPRMPT, 1)
	CALL WAIT (3.)
      NFLAG=NFLAG+1
      IF(NFLAG.EQ.2)GOTO 900
      GOTO 540
400   NFLAG=0
C
C	Now it's the player's move.
C
410   CONTINUE
C
C	First, save the old board for unwinding.
C
	JMOVE = JMOVE + 1
	DO I = 1, 8
	   DO J = 1, 8
	      SAVE_BRD(I,J,JMOVE) = NRAY(I,J)
	   END DO
	END DO
420   CALL PUTSCRN (' Your move (letter first) : ', LPRMPT, 1)
440   READ(5,460,END=1000) L1,N2
460   FORMAT(2A1)
      CALL UPCASE(L1)
      DO INDEX = 1,10
         IF (NUMS(INDEX) .EQ. N2) GO TO 500
      END DO
      GO TO 700

500   CONTINUE
      N2 = INDEX - 1
      IF(L1.EQ.LTS)GOTO 720
      IF(N2.GT.8.OR.N2.LT.1)GOTO 700
      N1=0
      NLEG=0
      IF(L1.EQ.LTA)N1=1
      IF(L1.EQ.LTB)N1=2
      IF(L1.EQ.LTC)N1=3
      IF(L1.EQ.LTD)N1=4
      IF(L1.EQ.LTE)N1=5
      IF(L1.EQ.LTF)N1=6
      IF(L1.EQ.LTG)N1=7
      IF(L1.EQ.LTH)N1=8
      IF(N1.EQ.0)GOTO 700
      CALL MOVE(N1,N2,NC,NRAY,NLEG)
      IF(NLEG.EQ.0)GOTO 700
      CALL BOARD(NRAY,REDRAW)

      IF(JLF.EQ.0)GOTO 540
      JLV=NVALUE(NRAY,NC,STR)
	WRITE (SCRLINE, 521) JLV
521	FORMAT (' Your current board value is ',i4)
	NS = NBLANK(SCRLINE) + 1
	CALL PUTSCRN (SCRLINE(1:NS), JVLINE, 1)
540   KVAL=1000
      LKT=0
      TP=0
      DO 560 I=1,8
         DO 560 J=1,8
560         IF(NRAY(I,J).NE.0)TP=TP+1.
      IF(TP.GT.60.)TP=60.
      FR=1-(TP/60.)**2
	JVALINE = JLINE
      DO 620 JC1=1,8
         DO 600 JC2=1,8
            DO J1=1,8
               DO J2=1,8
                  INRAY(J1,J2)=NRAY(J1,J2)
               END DO
            END DO
            NLEG=0
            CALL MOVE(JC1,JC2,NCM,INRAY,NLEG)
            IF(NLEG.EQ.0)GOTO 600
            LKT=1
            KFLAG=0
            IVAL=0
            INTVAL=0
            IF(JC1.EQ.2.OR.JC1.EQ.7.OR.JC2.EQ.2.OR.JC2.EQ.7)
     &   	 INTVAL=MEVAL(JC1,JC2,INRAY,STR)/3
            CALL LOOK(INRAY,NC,NCM,KFLAG,IVAL,STR)
            IVAL=IVAL+INTVAL
            IF(KFLAG.EQ.1)IVAL=IVAL-100
            IF(JKF.EQ.1)CALL JVAL(JC1,JC2,IVAL,INTVAL,JVALINE,50)
	    JVALINE = JVALINE + 1
            IF(KVAL.LT.IVAL)GOTO 600
            KVAL=IVAL
            M1=JC1
            M2=JC2
600      CONTINUE
620   CONTINUE
      IF(LKT.EQ.0)GOTO 640
      GOTO 680
640	CALL PUTSCRN (' I cannot move.', LCMMD, 1)
	CALL WAIT (3.)
      NFLAG=NFLAG+1
      IF(NFLAG.EQ.2)GOTO 900
      GOTO 340
660   NC=2
      NCM=1
      M1=4
      M2=6
680   NFLAG=0
	CALL PUTSCRN ( ' My move is ', LCMMD, 1)
      CALL WR(M1,M2,LCMMD,13)
      NLEG=0
      CALL MOVE(M1,M2,NCM,NRAY,NLEG)
      IF (JLF .EQ. 0) GOTO 340
      WRITE(SCRLINE, 690)KVAL
690   FORMAT(' My current board value is ',i4)
      NS = NBLANK(SCRLINE)
      CALL PUTSCRN (SCRLINE(1:NS), JVLINE-2, 1)
      GOTO 340

700	CALL PUTSCRN ( ' Illegal move. Your move ? ', LPRMPT, 1)
      GOTO 440

720   IF(N2.EQ.1)GOTO 820
      IF(N2.EQ.2)JKF=1
      IF(N2.EQ.3)JKF=0
      IF(N2.EQ.4)JLF=1
      IF(N2.EQ.5)JLF=0
      IF(N2.EQ.6)GOTO 740
      IF(N2.EQ.7)GOTO 880
      IF(N2.EQ.8) STOP ' Gallina! Que te vayas bien...'
      IF(N2.EQ.8) THEN
	CALL PUTSCRN (' Illegal command, try again.',LPRMPT,1)
	CALL WAIT (1.)
      END IF
      IF(N2.EQ.9)GOTO 1100
      GOTO 420

740	CALL PUTSCRN (' Board location (letter first), piece types :',
	1	LCMMD, 1)
      CALL PUTSCRN (' 0 =".", 1 ="*", 2 ="0", 9 = Quit -------: ',
	1	LPRMPT-1, 1)
      READ(6,750) JK1, JK2, JK3
      CALL PUTSCRN ('							',
	1	LPRMPT-1, 1)
750   FORMAT (A1,2I1)
      IF(JK1.EQ.LTA)JK1=1
      IF(JK1.EQ.LTB)JK1=2
      IF(JK1.EQ.LTC)JK1=3
      IF(JK1.EQ.LTD)JK1=4
      IF(JK1.EQ.LTE)JK1=5
      IF(JK1.EQ.LTF)JK1=6
      IF(JK1.EQ.LTG)JK1=7
      IF(JK1.EQ.LTH)JK1=8
      IF(JK3.EQ.9)GOTO 820
      IF(JK1.LT.1.OR.JK2.LT.1.OR.JK2.GT.8)GOTO 840
      IF(JK3.GT.2)GOTO 840
      NRAY(JK1,JK2)=JK3
      CALL BOARD (NRAY,REDRAW)
      GO TO 420

820	CALL IFERR (LIB$ERASE_PAGE (1,1),
	1	'ERASE_PAGE error.')
	REDRAW = .TRUE.
      CALL BOARD(NRAY,REDRAW)
      GOTO 420

840   WRITE(5,860)
860   FORMAT(/' Invalid spec, try again')
      GOTO 740

880   IFLAG=1
      GOTO 100
900   MKT=0
      JKT=0
      DO 920 JE=1,8
      DO 920 JF=1,8
      IF (NRAY(JE,JF).EQ.NCM)MKT=MKT+1
920   IF(NRAY(JE,JF).EQ.NC)JKT=JKT+1
	CALL PUTSCRN (' The game is over.', LEND1, 1)
	IF (JKT - MKT) 940, 960, 980
940	ENCODE (26, 104, SCRLINE) JKT, MKT
 104  FORMAT(' You lost, chump! ',I2,' to ',I2)
	CALL PUTSCRN (SCRLINE, LEND2, 1)
	GO TO 1000
960	ENCODE (19, 105, SCRLINE) JKT, MKT
 105  FORMAT(' Tie game: ',I2,' to ',I2)
	CALL PUTSCRN (SCRLINE, LEND2, 1)
	GO TO 1000
980	ENCODE (22, 103, SCRLINE) JKT, MKT
 103  FORMAT(' You have won ',I2,' to ',I2)
	CALL PUTSCRN (SCRLINE, LEND2, 1)
	GO TO 1000
C
C	Unwind the board.
C
1100	CONTINUE
	JMOVE = JMOVE - 1
	IF (JMOVE .LT. 1) JMOVE = 1
	DO I = 1, 8
	   DO J = 1, 8
	      NRAY(I,J) = SAVE_BRD(I,J,JMOVE)
	   END DO
	END DO
	CALL BOARD (NRAY,REDRAW)
	GO TO 420

1000 	LEND2 = LEND2 + 1
	CALL PUTSCRN (' So long, Sucker !', LEND2, 1)
	END
