!
!
!         MGRINS.COM
!
!         Command procedure to install the directory manager.
!
!         Use it for every directory you wish to install the
!         directory manager in.  It will generate command
!         files to be executed upon system boot.
!
!
!         Ken Dellinger   Oct 1983   Hughes Aircraft Co.
!
$ save_verify = f$verify()
$ set noverify
!
$ type sys$input:

     Please have the following information ready:

        The device containing the directory to manage (eg. _DBA1: )
        The name of the directory to be managed (eg. [GAMES] )
        The name of the log file, if any (eg. SYS$MANAGER:DIRMGR.LOG )

$Q1:
$ INQUIRE/NOPUNCT DEV "Which device contains the directory to manage:  "
$ if "''dev'".eqs."" then goto q1
$Q2:
$ INQUIRE/NOPUNCT DIR "What is the name of the directory:  "
$ if "''dir'".eqs."" then goto q2
$Q3:
$ INQUIRE/NOPUNCT CON "Do you wish to log output on the operator console (Y/N):  "
$ if "''con'".eqs."" then goto q3
$Q4:
$ INQUIRE/NOPUNCT LOG "Do you wish to log output in a log file (Y/N):  "
$ if "''log'".eqs."" then goto q4
$ if "''log'".eqs."N" then goto next
$Q5:
$ INQUIRE/NOPUNCT NAM "Give the full file-spec for the log file:  "
!
$NEXT:
$ opout := "NL:"
$ lgout := "NL:"
$ if "''con'".eqs."Y" then opout := "_OPA0:"
$ if "''log'".eqs."Y".and."''nam'".nes."" then lgout := "''nam'"
$ if "''f$locate("]",dir)'".eqs."''f$length(dir)'" then dir := "[''dir']"
$ if "''f$locate(":",dev)'".eqs."''f$length(dev)'" then dev := "''dev':"
$ full := "''dev'''dir'"
$ N = 1
!
$ WRITE SYS$OUTPUT " "
$ WRITE SYS$OUTPUT " "
$ WRITE SYS$OUTPUT "  Searching for previous mgrsetup command files..."
$CBUILD_LOOP:
$ OPEN/READ/ERROR=CBUILD_CONT TEST SYS$MANAGER:MGRSETUP'N'.COM
$ CLOSE TEST
$ N = N + 1
$ GOTO CBUILD_LOOP
$CBUILD_CONT:
!
$ WRITE SYS$OUTPUT " "
$ WRITE SYS$OUTPUT "  Building command procedure SYS$MANAGER:mgrsetup''n'.com ..."
$ OPEN/WRITE OUTPUT SYS$MANAGER:MGRSETUP'N'.COM
$ WRITE OUTPUT "$ define/system mgr''n'$dir ''full'"
$ WRITE OUTPUT "$ define/system mgr''n'$log ''lgout'"
$ WRITE OUTPUT "$ define/system mgr''n'$dev ''opout'"
$ WRITE OUTPUT "$ MCR INSTALL"
$ WRITE OUTPUT "SYS$MANAGER:MGR''n'.EXE /OPEN/SHARE/PRIV=(SYSPRV,OPER,SETPRV,BYPASS,WORLD,DETACH)"
$ WRITE OUTPUT "/EXIT"
$ CLOSE OUTPUT
!
$ WRITE SYS$OUTPUT " "
$ WRITE SYS$OUTPUT "  Tailoring DIRMGR..." 
$ WRITE SYS$OUTPUT " "
$ OPEN/WRITE OUTPUT DIRMGREDT.TLR
$ WRITE OUTPUT "INCLUDE DIRMGR.SRC"
$ WRITE OUTPUT "SUBSTITUTE/MGR..DIR/MGR''n'$DIR/WHOLE/NOTYPE"
$ WRITE OUTPUT "SUBSTITUTE/MGR..LOG/MGR''n'$LOG/WHOLE/NOTYPE"
$ WRITE OUTPUT "SUBSTITUTE/MGR..DEV/MGR''n'$DEV/WHOLE/NOTYPE"
$ WRITE OUTPUT "EXIT"
$ CLOSE OUTPUT
$ EDIT/EDT/COMMAND=DIRMGREDT.TLR MGR'n'.FOR
$ WRITE SYS$OUTPUT " "
$ WRITE SYS$OUTPUT "  Compiling MGR''n' ..."
$ FORTRAN/NOLIST MGR'n'
$ WRITE SYS$OUTPUT " "
$ WRITE SYS$OUTPUT "  Linking MGR''n' ..."
$ LINK/EXE=SYS$MANAGER:MGR'n'.EXE MGR'n'
$ WRITE SYS$OUTPUT " "
$ WRITE SYS$OUTPUT "  Cleaning up work files..."
$ DELETE/NOLOG DIRMGREDT.TLR.*,MGR'n'.FOR.*,MGR'n'.OBJ.*
$ WRITE SYS$OUTPUT " "
$ WRITE SYS$OUTPUT " "
$ WRITE SYS$OUTPUT "  To install the new DIRMGR, execute SYS$MANAGER:MGRSETUP''n'.COM"
$ WRITE SYS$OUTPUT "  You may wish to include the following line in SYSTARTUP.COM :"
$ WRITE SYS$OUTPUT "$ @SYS$MANAGER:MGRSETUP''n'.COM"
$ if save_verify then set verify
$ exit
