$ ! Command file to display disk space statistics.
$ !
$	verif = F$VERIFY (0)
$	on control_Y then goto CLEANUP
$	On warning then goto CLEANUP
$	count = 0
$	tottot = 0
$	totused = 0
$	totfre = 0
$	date = F$EXTRACT (0, 11, F$TIME ())
$	l1 = F$LOCATE (".", F$TIME ())
$	l2 = l1 - 12
$	time = F$EXTRACT (12, l2, F$TIME ())
$ !
$	if P1 .nes. "" then goto GET_NAMES
$	define/user SYS$OUTPUT SYS$SCRATCH:diskspace.tmp
$	show device/mounted
$	goto WRITE_IT
$ !
$ GET_NAMES:
$	open/write file SYS$SCRATCH:diskspace.tmp
$	write file ""
$	write file ""
$	P1 = F$GETDVI (P1, "ROOTDEVNAM")
$ !
$ NEXT_DEVICE:
$	write file " ''P1'"
$	P1 = F$GETDVI (P1, "NEXTDEVNAM")
$	if P1 .nes. "" then goto NEXT_DEVICE
$	close/noerror file
$ !
$ WRITE_IT:
$	write SYS$OUTPUT -
" VAX/VMS ''F$GETSYI ("VERSION")' Disk Usage summary on ''date' at ''time'"
$	write SYS$OUTPUT ""
$	write SYS$OUTPUT -
"Device    Volume Label      Used Blocks       Free Blocks     Total Blocks"
$	write SYS$OUTPUT -
"------    ------------     -------------     -------------    ------------"
$	open/read file SYS$SCRATCH:diskspace.tmp
$	read file null
$	read file null
$ !
$ READ_REC:
$	read/end=done file rec
$	If F$LOCATE (":", rec) .eqs. F$LENGTH (rec) then goto READ_REC
$	disk = F$EXTRACT (2, F$LOCATE (":", rec), rec)
$	cyl = F$GETDVI ("''disk'", "DEVCLASS")
$	If cyl .ne. 1 then goto READ_REC
$	for = F$GETDVI ("''disk'", "FOR")
$	If for then goto READ_REC
$	label = F$GETDVI ("''disk'", "VOLNAM")
$	free = F$GETDVI ("''disk'", "FREEBLOCKS")
$	total = F$GETDVI ("''disk'", "MAXBLOCK")
$	used = total - free
$	peruse = (used * 100)/total
$	perfre = 100 - peruse
$ !
$	line = F$FAO (-
"!6AS    !12AS     !7UL (!2UL%)     !7UL (!2UL%)    !12UL", -
		      disk, label, used, peruse, free, perfre, total)
$	write SYS$OUTPUT line
$	count = count + 1
$	tottot  = tottot  + total
$	totused = totused + used 
$	totfre = totfre + free
$	pertotfre = (totfre * 100)/tottot
$	pertotuse = 100 - pertotfre
$	goto READ_REC
$ !
$ DONE:
$	close file
$	If count .le. 1 then goto CLEANUP
$	write SYS$OUTPUT ""
$	line = F$FAO (-
"Totals on !2UL structures    !7UL (!2UL%)     !7UL (!2UL%)    !12UL", -
count, totused, pertotuse, totfre, pertotfre, tottot)
$	write SYS$OUTPUT line
$ !
$ CLEANUP:
$	set noon
$	close/error=no file
$ !
$ NO:
$	open/error=not_open file SYS$SCRATCH:diskspace.tmp
$	close file
$	delete/nolog SYS$SCRATCH:diskspace.tmp;*
$ !
$ NOT_OPEN:
$	verif = F$VERIFY (verif)
$	exit
