$ ! ShowDev	- A command file to show all information about a device.
$ !
$ ! Written by Kevin Carosso, @ Hughes S&CG, PWB/Engineering.  12-Oct-1983
$ !
$ Ask:
$	if P1 .nes. "" then goto Start
$		inquire P1 "Device name"
$		goto ask
$ Start:
$	if F$GETDVI(P1, "EXISTS") then goto Get_info
$		write SYS$OUTPUT "No such device ''P1'"
$		exit
$ Get_info:
$	date = F$EXTRACT (0, 11, F$TIME ())
$	l1 = F$LOCATE (".", F$TIME ())
$	l2 = l1 - 12
$	time = F$EXTRACT (12, l2, F$TIME ())
$	ver = F$GETSYI ("VERSION") - "   "
$	write SYS$OUTPUT -
" VAX/VMS ''VER' device information for ''P1', on ''date' at ''time'"
$	write SYS$OUTPUT ""
$ !
$	Line = F$FAO("Device name:   !8AS      " + -
		     "Owner:    !10AS       " + -
		     "Transactions: !10UL", -
		F$GETDVI(P1, "DEVNAM"), -
		F$GETDVI(P1, "OWNUIC"), -   
		F$GETDVI(P1, "TRANSCNT"))
$	write SYS$OUTPUT Line
$ !
$	Line = F$FAO("Unit number:   !8UL      " + -
		     "Owner ID: !8AS         " + -
		     "Operations:   !10UL", -
		F$GETDVI(P1, "UNIT"), -
		F$GETDVI(P1, "PID"), -
		F$GETDVI(P1, "OPCNT"))
$	write SYS$OUTPUT Line
$ !
$	Line = F$FAO("Serial number: !8UL      " + -
		     "ACP ID:   !8AS         " + -
		     "References:   !10UL", -
		F$GETDVI(P1, "SERIALNUM"), -
		F$GETDVI(P1, "ACPPID"), -
		F$GETDVI(P1, "REFCNT"))
$	write SYS$OUTPUT Line
$ !
$	Line = F$FAO("Spooled to:    !12AS  " + -
		     "ACP type: !10AS       " + -
		     "Mount count:  !10UL", -
		F$GETDVI(P1, "SPLDEVNAM"), -
		F$GETDVI(P1, "ACPTYPE"), -
		F$GETDVI(P1, "MOUNTCNT"))
$	write SYS$OUTPUT Line
$ !
$	Line = F$FAO("Protection: !44AS" + -
		     "Error count:  !10UL", -
		"(" + -
		F$GETDVI(P1, "VPROT") - "YSTEM"  - "WNER" - "ROUP" - "ORLD" + -
		")", -
		F$GETDVI(P1, "ERRCNT"))
$	write SYS$OUTPUT Line
$	write SYS$OUTPUT ""
$ !
$	Line = F$FAO("Device type:             !10UL         " + -
		     "Free blocks:  !10UL", -
		F$GETDVI(P1, "DEVTYPE"), -
		F$GETDVI(P1, "FREEBLOCKS"))
$	write SYS$OUTPUT Line
$ !
$	Line = F$FAO("Device char longword:    !10XL         " + -
		     "Total blocks: !10UL", -
		F$GETDVI(P1, "DEVCHAR"), -
		F$GETDVI(P1, "MAXBLOCK"))
$	write SYS$OUTPUT Line
$ !
$	Line = F$FAO("Device class:            !10UL         " + -
		     "Max files:    !10UL", -
		F$GETDVI(P1, "DEVCLASS"), -
		F$GETDVI(P1, "MAXFILES"))
$	write SYS$OUTPUT Line
$ !
$	Line = F$FAO("Device dependent info 1: !10XL         " + -
		     "Cluster size: !10UL", -
		F$GETDVI(P1, "DEVDEPEND"), -
		F$GETDVI(P1, "CLUSTER"))
$	write SYS$OUTPUT Line
$ !
$	Line = F$FAO("Device dependent info 2: !10XL         ", -
		F$GETDVI(P1, "DEVDEPEND2"))
$	write SYS$OUTPUT Line
$	write SYS$OUTPUT ""
$ !
$	Line = F$FAO("Logical volume name: !12AS           " + -
		     "Volume name:     !12AS", -
		F$GETDVI(P1, "LOGVOLNAM"), -
		F$GETDVI(P1, "VOLNAM"))
$	write SYS$OUTPUT Line
$ !
$	Line = F$FAO("Root device name:    !12AS           " + -
		     "Volume count:    !10UL", -
		F$GETDVI(P1, "ROOTDEVNAM"), -
		F$GETDVI(P1, "VOLCOUNT"))
$	write SYS$OUTPUT Line
$ !
$	Line = F$FAO("Next device name:    !12AS           " + -
		     "Volume number:   !10UL", -
		F$GETDVI(P1, "NEXTDEVNAM"), -
		F$GETDVI(P1, "VOLNUMBER"))
$	write SYS$OUTPUT Line
$	write SYS$OUTPUT ""
$ !
$	Line = F$FAO("Sectors:    !10UL                      " + -
		     "Record size:     !10UL", -
		F$GETDVI(P1, "SECTORS"), -
		F$GETDVI(P1, "RECSIZ"))
$	write SYS$OUTPUT Line
$ !
$	Line = F$FAO("Tracks:     !10UL                      " + -
		     "Buffer size:     !10UL", -
		F$GETDVI(P1, "TRACKS"), -
		F$GETDVI(P1, "DEVBUFSIZ"))
$	write SYS$OUTPUT Line
$ !
$	Line = F$FAO("Cylinders:  !10UL", -
		F$GETDVI(P1, "CYLINDERS"))
$	write SYS$OUTPUT Line
$ !
$ ! All true or false ones follow:
$ !
$	Line = ""
$	if F$GETDVI(P1, "ALL") then Line = Line + ",All"
$	if F$GETDVI(P1, "AVL") then Line = Line + ",Avl"
$	if F$GETDVI(P1, "CCL") then Line = Line + ",Ccl"
$	if F$GETDVI(P1, "CONCEALED") then Line = Line + ",Concealed"
$	if F$GETDVI(P1, "DIR") then Line = Line + ",Dir"
$	if F$GETDVI(P1, "DMT") then Line = Line + ",Dmt"
$	if F$GETDVI(P1, "ELG") then Line = Line + ",Elg"
$	if F$GETDVI(P1, "FOD") then Line = Line + ",Fod"
$	if F$GETDVI(P1, "FOR") then Line = Line + ",For"
$	if F$GETDVI(P1, "GEN") then Line = Line + ",Gen"
$	if F$GETDVI(P1, "IDV") then Line = Line + ",Idv"
$	if F$GETDVI(P1, "MBX") then Line = Line + ",Mbx"
$	if F$GETDVI(P1, "MNT") then Line = Line + ",Mnt"
$	if F$GETDVI(P1, "NET") then Line = Line + ",Net"
$	if F$GETDVI(P1, "ODV") then Line = Line + ",Odv"
$	if F$GETDVI(P1, "OPR") then Line = Line + ",Opr"
$	if F$GETDVI(P1, "RCK") then Line = Line + ",Rck"
$	if F$GETDVI(P1, "REC") then Line = Line + ",Rec"
$	if F$GETDVI(P1, "RND") then Line = Line + ",Rnd"
$	if F$GETDVI(P1, "RTM") then Line = Line + ",Rtm"
$	if F$GETDVI(P1, "SDI") then Line = Line + ",Sdi"
$	if F$GETDVI(P1, "SHR") then Line = Line + ",Shr"
$	if F$GETDVI(P1, "SPL") then Line = Line + ",Spl"
$	if F$GETDVI(P1, "SQD") then Line = Line + ",Sqd"
$	if F$GETDVI(P1, "SWL") then Line = Line + ",Swl"
$	if F$GETDVI(P1, "TRM") then Line = Line + ",Trm"
$	if F$GETDVI(P1, "WCK") then Line = Line + ",Wck"
$ !
$	Line = Line - ","
$	write SYS$OUTPUT ""
$	write SYS$OUTPUT "Device characteristics: ''Line'"
