$!			OPERACNT
$! Provide access for operators to 
$!
$!		a) Add accounts, Directories and Disk accounting
$!		b) Produce a listing of SYSUAF
$!		c) Produce a listing of the Disk Quota File
$!		d) Reset the account password to VMS
$!
$	Verify_at_Start='F$VERIFY(0)'		! 
$	SET NOON
$	ON CONTROL_Y THEN GOTO START		!
$	@SYS$SYSDISK:[SYSMGR.CMDFIL]PAGE	! Erase screen
$	TYPE SYS$INPUT

	Operator Account File Maintanence
$	Current_Disk:='F$LOGICAL("SYS$DISK")'	! Get current disk/root
$	Current_Directory:='F$DIRECTORY()'	! Get current directory
$	Current_UIC:='F$USER()'			! Get current UIC
$Start:
$	SET MESSAGE/NOFACILITY/NOIDENT/NOSEVERITY/NOTEXT
$	DELETE/SYMBOL FUNCTION
$	TYPE SYS$INPUT

You may select:	

	ADD	Add a 'standard' user to the system
	LIST	Produce a listing of the SYSUAF entries
	QUOTA	Produce a listing of the Disk Quota entries
	RESET   Reset the account password to VMS
	EXIT	Exit

$	SET MESSAGE/FACILITY/IDENT/SEVERITY/TEXT! Restore warning messages
$Start_1:
$	SET UIC 'Current_UIC'			! Just in case got here via a
$	SET DEFAULT 'Current_Disk''Current_Directory'	! ^Y, reset directory
$	INQUIRE Functionx "What account function do you wish to perform"
$	Function0[0,1]:='Functionx'
$	IF Function0 .EQS. "E"  Then GOTO All_Done
$Get_Last_Name:
$	Tmp:='Last_Name'			!
$	Last_Name:='Tmp'			!
$	IF Last_Name .EQS. "" THEN -
	INQUIRE Last_Name "What is your last name"
$	IF Last_Name .EQS. "" THEN GOTO Get_Last_Name
$	IF Function0 .EQS. "A"   THEN GOTO Add_Account
$	IF Function0 .EQS. "L"   THEN GOTO List_Account
$	IF Function0 .EQS. "Q"   THEN GOTO List_Quota
$	IF Function0 .EQS. "R"   THEN GOTO Reset_Password
$	TYPE SYS$INPUT
OPERACNT -- Invalid function. Try again.

$	GOTO Start
$Add_Account:
$	@SYS$SYSDISK:[SYSMGR.CMDFIL]PAGE	! Erase screen
$	TYPE SYS$INPUT				!

     This procedure will let you add a standard user account,
disk quota for the user, create the user's directory, and insert
a default LOGIN.COM for the user.  After making all entries you
will be asked to verify the correctness of those entries.  It is
very important to get entries correct as files used to recreate
our account file structure will be modified with the information
you supply.

$Get_Name:
$	INQUIRE User_Name "What is the name for the account"
$	IF User_Name .EQS. "" THEN GOTO Start_1	! Back to menue on <CR>
$	SET NOCONTROL_Y				!
$	ASSIGN/USER WHO.TMP SYS$OUTPUT		! Write WHO output to file
$	WHO SHOW *				! List all users
$	OPEN/READ INFILE WHO.TMP		! Open list file
$	Test_Name:="	''User_Name'"		! Must test with tab in place
$Read_Loop:
$	READ/END_OF_FILE=Name_OK INFILE Record	! Get a record
$	IF 'F$LOCATE(Test_Name,Record)'  .EQ. -	! Did we find user
	   'F$LENGTH(Record)'  THEN GOTO Read_Loop! If no, read again
$	CLOSE INFILE				!
$	WRITE SYS$OUTPUT -			! Warn user
"OPERACNT -- You can not add the name ''User_Name' to the the account file"
$	WRITE SYS$OUTPUT -			!
"            The name is already in use.  Each user must have a unique last"
$	WRITE SYS$OUTPUT -			!
"            name.  Select a new name please and try again."
$	WRITE SYS$OUTPUT " "			! Blank line
$	DELETE WHO.TMP;*			! Delete the output listing
$	GOTO Get_Name				! Try again
$
$Name_OK:					! Name can be added
$	CLOSE INFILE				!
$	DELETE WHO.TMP;*			!
$	ON CONTROL_Y THEN GOTO Start_1		!
$	SET CONTROL_Y				!
$Get_Group:					!
$	TYPE SYS$INPUT				!

     At this time the user may belong to the following groups as
designated by the group mnemonics.

	ADMIN		Administrative Services
	AERO		KMS Aerospace
	DMS		Division of Material Science
	ENG		Engineering Services
	FEL		Free Electron Laser
	FUS_EXP		Fusion Experiments
	LASER		Laser Group
	THEORY		Theory Group

$	INQUIRE Account "What is the group name for this account"
$	IF Account .EQS. "ADMIN"    THEN GOTO Get_UIC
$	IF Account .EQS. "AERO"    THEN GOTO Get_UIC
$	IF Account .EQS. "DMS"      THEN GOTO Get_UIC
$	IF Account .EQS. "ENG"      THEN GOTO Get_UIC
$	IF Account .EQS. "FEL"	    THEN GOTO Get_UIC
$	IF Account .EQS. "FUS_EXP"  THEN GOTO Get_UIC
$	IF Account .EQS. "LASER"    THEN GOTO Get_UIC
$	IF Account .EQS. "THEORY"   THEN GOTO Get_Uic

$	TYPE SYS$INPUT				!

OPERACNT -- Not an allowed group mnemonic. Try again.

$	GOTO Get_Group				!
$Get_UIC:
$	Blocks:=2000				! Default Disk block
$	Priority:=4				! Default VMS Priority
$	IF Account .EQS. "ADMIN"    THEN Blocks:=1000
$	IF Account .EQS. "ADMIN"    THEN Priority:=4
$	IF Account .EQS. "ADMIN"    THEN Group:=340
$	IF Account .EQS. "AERO"     THEN Group:=345
$	IF Account .EQS. "DMS"      THEN Group:=350
$	IF Account .EQS. "ENG"      THEN Group:=360
$	IF Account .EQS. "THEORY"   THEN Group:=364
$	IF Account .EQS. "THEORY"   THEN Priority:=4
$	IF Account .EQS. "FEL"	    THEN Group:=365
$	IF Account .EQS. "FEL"      THEN Priority:=4
$	IF Account .EQS. "LASER"    THEN Group:=370
$	IF Account .EQS. "FUS_EXP"  THEN Group:=377
$	WRITE SYS$OUTPUT " "
$	WRITE SYS$OUTPUT "Existing member numbers for group ''Group' include:"
$	WHO SHOW ['Group',*]
$	WRITE SYS$OUTPUT " "
$	INQUIRE Member -			!
"What is the member number, M, for this account [''Group',M]"
$	IF Member .EQS. "" THEN GOTO Get_UIC	!
$	SET NOCONTROL_Y				!
$	ON ERROR THEN CONTINUE
$	SET UIC ['Group','Member']		!
$	IF $STATUS .EQ. 1  THEN GOTO Get_Owner	!
$	SET UIC 'Current_UIC'			!
$	SET DEFAULT 'Current_Directory'		! Reset directory
$	TYPE SYS$INPUT				!
"OPERACNT -- Not a valid member number, try again.
$	ON CONTROL_Y THEN GOTO Start_1		!
$	SET CONTROL_Y				!
$	GOTO Get_UIC				!
$Get_Owner:
$	SET NOCONTROL_Y				!
$	SET UIC 'Current_UIC'			!
$	SET DEFAULT 'Current_Directory'		! Reset directory
$	ASSIGN/USER WHO.TMP SYS$OUTPUT		! Write WHO output to file
$	User_UIC:=['Group','Member']		! The proposed user uIC
$	WHO SHOW 'User_UIC'			! Find out if UIC in use
$	OPEN/READ INFILE WHO.TMP		! Read info from acnt file
$	READ INFILE Record			! Read in the record
$	IF 'F$LOCATE(User_UIC,Record)'  .EQ. -	! Did we find user UIC
	   'F$LENGTH(Record)'  THEN GOTO Get_Owner_2! If EQ, NO, proceed
$	CLOSE INFILE
$	DELETE WHO.TMP;*			! Delete the tmp file
$	WRITE SYS$OUTPUT -			! Warn user of error
"OPERACNT -- ''User_UIC' is already used. Try again"
$	TYPE SYS$INPUT				!
            UIC's currently in use include:
$	WHO SHOW ['Group',*]			! Show who has accounts
$	ON CONTROL_Y THEN GOTO Start_1		! If ^Y, back to menue
$	SET CONTROL_Y				! Enable ^Y
$	GOTO Get_UIC				! Get the UIC again
$Get_Owner_2:					!
$	CLOSE INFILE				! Close file
$	DELETE WHO.TMP;*			! Delete tmp file
$	ON CONTROL_Y THEN GOTO Start_1		! Restore ^Y branch
$	SET CONTROL_Y				! Re-enable ^Y
$	INQUIRE TMP "What is the full name of the owner"! Find full name
$	IF TMP .EQS. "" THEN GOTO Get_Owner	! Must have a name
$	SET NOCONTROL_Y				! Disable ^Y for now
$! The next line must omit any comment after the last "
$	Owner:=/OWNER="""''TMP'""
$Display:					! Show user what we have
$	Disk:="''F$LOGICAL("SYS$SYSUSER0")'"	! Disk for user's files
$	TYPE SYS$INPUT				! Display the inputs 

The account parameters selected are:
$	WRITE SYS$OUTPUT "      User name:      ''User_Name'"
$	WRITE SYS$OUTPUT "   Primary Disk:      ''Disk'"
$	WRITE SYS$OUTPUT "      Directory:      ''User_Name'"
$	WRITE SYS$OUTPUT "       Password:      VMS"
$	WRITE SYS$OUTPUT "          [UIC]:      ''User_UIC'"
$	WRITE SYS$OUTPUT "        Account:      ''Account'"
$	WRITE SYS$OUTPUT "          Owner:      ''TMP'"
$	WRITE SYS$OUTPUT "          Priv.:      Default"
$	WRITE SYS$OUTPUT "       Priority:      ''Priority'"
$	WRITE SYS$OUTPUT "      Disk Blks:      ''Blocks'"
$	WRITE SYS$OUTPUT "      Overdraft:      300"
$	WRITE SYS$OUTPUT " "
$	INQUIRE OK "Are these parameters OK [Y/N]"! Chance to reject
$	IF .NOT. OK  THEN GOTO Start_1		! If not OK back to memue
$	SET DEFAULT SYS$SYSROOT:[SYSEXE]	! SYSUAF.DAT on this account
$	OPEN/WRITE OUTFILE AUTHORIZE.TMP	! The do-all command file
$	WRITE OUTFILE "$!"			!
$	WRITE OUTFILE -				! Log when addition made
"$! Operator ''Last_Name' added account on ''F$TIME()' 
$	WRITE OUTFILE "$MC AUTHORIZE"		! Give user a basic account
$	WRITE OUTFILE -				!
"ADD ''USER_NAME'/DIRECTORY=[''User_Name']/ACCOUNT=''Account'-"
$	WRITE OUTFILE "/DEVICE=SYS$SYSUSER0-"	! Disk for SYS$LOGIN
$	WRITE OUTFILE "/PRIORITY=''Priority'/PFLAG=DISDIALUP-"
$	WRITE OUTFILE Owner,"/PASSWORD=VMS/UIC=''User_UIC'"
$	WRITE OUTFILE -				! Make a directory for user
"$CREATE/DIRECTORY SYS$SYSUSER0:[''User_Name']/OWNER_UIC=''User_UIC'"
$	WRITE OUTFILE "$MC DISKQUOTA"		! Provide user with 1000 blks
$	WRITE OUTFILE "USE SYS$SYSUSER0"	!  on the user disk
$	WRITE OUTFILE "ADD ''User_UIC'/PERMQUOTA=''Blocks'/OVERDRAFT=300"!
$	CLOSE OUTFILE				!
$	SET PROCESS/PRIV=EXQUOTA		! Need for creating directory
$	@AUTHORIZE.TMP				! Execute the process
$	SET PROCESS/PRIV=NOEXQUOTA		!
$	ASSIGN/USER NL: SYS$OUTPUT		! Suppress messages
$	ASSIGN/USER NL: EDTINI			! Make an editable file
$	EDIT AUTHORIZE.TMP			! by passing once through EDT
	EXIT
$	MAIL AUTHORIZE.TMP VAX$MANAGER,VAVRA	! Tell manager we did this
$	APPEND AUTHORIZE.TMP ACCOUNTS.COM	! Add on the records
$	DELETE AUTHORIZE.TMP;*			! clean up
$	SET UIC 'User_UIC'			! Move to newly created 
$	SET DEFAULT SYS$SYSUSER0:['User_Name']	! directory and UIC
$	COPY SYS$SYSROOT:[SYSMGR.CMDFIL]LOGTMPLT.COM LOGIN.COM! to copy in a LOGIN.COM
$	SET UIC 'Current_UIC'			! Reset UIC
$	SET DEFAULT SYS$SYSDEVICE:'Current_Directory'	! Reset directory
$	GOTO Start_1				!
$!
$Reset_Password:				!
$	SET NOCONTROL_Y				!
$	INQUIRE User_Name "What is the account name"
$	IF User_Name .EQS. "" THEN GOTO Start_1	!
$	ASSIGN/USER WHO.TMP SYS$OUTPUT		! Write WHO output to file
$	WHO SHOW *				! List all users
$	OPEN/READ INFILE WHO.TMP 		!
$Scan_List:					! Read file to see if exists
$	READ/END_OF_FILE=Not_Found INFILE Record!
$	IF 'F$LOCATE(User_Name,Record)'  .EQ. -	! Did we find user
	   'F$LENGTH(Record)'  THEN GOTO Scan_List! If no, read again
$	CLOSE INFILE				! Found user
$	DELETE WHO.TMP;*			!
$	Tmp='F$LOCATE("[",Record)'		! Start of UIC
$	Tmp=Tmp+1				!
$	Group_num:='F$EXTRACT(Tmp,3,Record)'	! Extract code
$	Group='Group_num'			!
$	IF Group .LT. 300 THEN -		!
	WRITE SYS$OUTPUT "OPERACNT -- UICs >= [300,x], please"
$	IF Group .LT. 300 THEN GOTO Start_1	!
$	SET DEFAULT SYS$SYSROOT:[SYSEXE]	!
$	OPEN/WRITE OUTFILE AUTHORIZE.TMP	! The do-all command file
$	WRITE OUTFILE "$MC AUTHORIZE"		! Give user a basic account
$	WRITE OUTFILE "MODIFY ''USER_NAME'/PASSWORD=VMS"
$	CLOSE OUTFILE				!
$	@AUTHORIZE.TMP				!
$	DELETE AUTHORIZE.TMP;*			!
$	GOTO Start_1				!
$Not_Found:					!
$	CLOSE INFILE				!
$	DELETE WHO.TMP;*			!
$	WRITE SYS$OUTPUT "OPERACNT -- User ''User_Name' not found."
$	GOTO Start_1				!
$!
$List_Account:					!
$	SET NOCONTROL_Y				!
$	SET UIC [1,4]				! Move to system UIC	  ****
$	SET DEFAULT SYS$SYSROOT:[SYSEXE]	! Move to system directory****
$	ASSIGN/USER NL: SYS$OUTPUT		! Don't print messages
$	MC AUTHORIZE				! Start it up
	LIST
$	PRINT/DELETE /NOIDENTIFY SYSUAF.LIS	! Print the listing
$	TYPE SYS$INPUT

OPERACNT -- Please pick up your Account listing at the line printer.

$	SET UIC 'Current_UIC'			! Reset UIC
$	SET DEFAULT 'Current_Directory'		! Reset directory
$	ON CONTROL_Y THEN GOTO Start_1		!
$	SET CONTROL_Y				!
$	GOTO Start_1				! Another Function?
$!
$List_Quota:
$	SET NOCONTROL_Y				!
$	ASSIGN/USER QUOTA.LIS SYS$OUTPUT	! Write to output file
$	MC DISKQUOTA				!
	SHOW [*,*]
$	PRINT/DELETE/NOIDENTIFY QUOTA.LIS	!
$	TYPE SYS$INPUT				!

OPERACNT -- Please pick up your disk quota listing at the line printer.

$	SET NOCONTROL_Y				!
$	GOTO Start_1				!
$!
$All_Done:					!
$	IF Verify_at_Start THEN SET VERIFY	!
$	EXIT
$!
$!  File Name:	OPERACNT.COM
$!  Author:	James G. Downward
$!  Date:	23-Feb-1982
$!  Function:	Provide operators with a standardized way of adding
$!		standard accounts to our system in a controlled manner.
$!		Allow operators to reset passwords which have been
$!		forgotten to be VMS.
$!		  This procedure can add accounts, create the default
$!		directory, and startup disk block accounting for each
$!		account added.  To allow for later recreating that account
$!		a file [sysexe]ACCOUNTS.COM is appended to with all the
$!		information required to recreate that account.
$!		  Non-default accounts still must be added by hand.
$!		
$!
$!  Modified:
$!		06-July-82	Updated for VMS v3.0 with rooted directories
$!
$!		28-Dec-82	Place users on SYS$SYSUSER0. Notify VAX$MANAGER
$!
$!		06-May-83	Fix bug if adding user name contained in a
$!				user name already on system.  Allow for a
$!				minimum # keystrokes in selecting functions.
