$!			OPERCMD.COM
$! Provide operators the ability to submit an indirect command file
$! containing privileged commands for processing, and to log the output
$! and mail it to the manager for verification.
$!
$	Verify_at_Start='F$VERIFY(0)'		!
$	Current_Directory:='F$DIRECTORY()'	! Get current directory
$	Current_UIC:='F$USER()'			! Get current UIC
$	On CONTROL_Y THEN GOTO Start		!
$	@SYS$SYSDISK:[SYSMGR.CMDFIL]PAGE	! Erase screen
$	SET MESSAGE/NOIDENT/NOFACILITY/NOSEVERITY/NOTEXT
$	TYPE SYS$INPUT				!

			OPER_COMMAND
			    V1.0

This command procedure is designed to allow system operators to
submit privileged command procedures in a way that will provide a 
log of what has been done.  Type <CR> to exit.

$	SET MESSAGE/IDENT/FACILITY/SEVERITY/TEXT! Reset error message text
$Start:
$	INQUIRE Cmd_File "Command file"		! Get command file name
$	IF Cmd_File .EQS. "" THEN GOTO All_Done	!
$	TESTFILE 'Cmd_File'			! Is file there?
$	IF $STATUS .EQ. 1 THEN GOTO Got_File	! Yes, continue
$	WRITE SYS$OUTPUT "OPERCMD -- Command file ''Cmd_File' not found"
$	GOTO Start				!
$Got_File:					!
$	OPEN/WRITE OUTFILE CMDFIL.LOG		!
$	WRITE OUTFILE -				!
"! Operator ''Last_Name' submitted the command file below on ''F$TIME()'"
$	WRITE OUTFILE "!"			!
$	CLOSE OUTFILE				!
$	SET MESSAGE/NOIDENT/NOFACILITY/NOSEVERITY/NOTEXT
$	APPEND 'Cmd_File' CMDFIL.LOG		!
$	SET MESSAGE/IDENT/FACILITY/SEVERITY/TEXT!
$	SET NOCONTROL_Y				!
$	ON ERROR THEN GOTO Append		!
$	@'Cmd_File'/OUTPUT=TMP.LOG		! Issue the cmdfile
$Appemd:					!
$	SET NOVERIFY				!
$	SET UIC 'Current_UIC'			! Restore UIC (if changed)
$	SET DEFAULT 'Current_Directory'		!   and directory
$	ON ERROR THEN GOTO Start		!
$	APPEND TMP.LOG CMDFIL.LOG		!
$	DELETE TMP.LOG;*			! All done, delete it.
$	MAIL CMDFIL.LOG				! Send it off to manager
	DOWNWARD
$	APPEND/NEW CMDFIL.LOG OPERCMDS.LOG	! Keep a running log of use
$	DELETE CMDFIL.LOG;*			! No longer need this
$	GOTO Start				! Back for more
$All_Done:					!
$	SET CONTROL_Y				!
$	IF Verify_at_Start THEN SET VERIFY	!
$	EXIT					!
$!
$!  File Name:	OPERCMD
$!  Author:	James G. Downward
$!  Date:	09-Mar-1982
$!  Function:	Allow operators to issue privileged functions while providing
$!		a record of what they did.
$!
$!  Modified:
$!
