$	IF P1 .NES. "" THEN GOTO DO_SUBROUTINE
$	PAGE
$	WRITE SYS$OUTPUT "KMSCAI -- No subroutine specified
$	WAIT 00:00:03
$	EXIT
$Do_Subroutine:
$	GOTO 'P1'			!
$	EXIT
$!
$Menu:
$	PAGE
$	TYPE SYS$INPUT
   #4[7m                                [0m
   #3[7m  [0m The VAX/VMS DELETE Command [0;7m  [0m
   #4[7m  [0m The VAX/VMS DELETE Command [0;7m  [0m
   #3[7m                                [0m

			Type ^Y to Exit at any time
You may choose:

		[1mI[0mntro      -  Indroduction to the DELETE Command
		[1mQ[0mualifiers -  DELETE qualifiers
		[1mF[0minal      -  Final exam
		[1mE[0mxit       -  Exit this menu

$		EXIT
$Select:
$	Test:=="F"
$	Result:=="OK"
$	ZTmp=P2
$	ZTMP1=P3
$	IF ZTmp   .EQS. "E"  THEN Result:=="DONE"
$	IF ZTmp   .EQS. "E"  THEN EXIT
$	IF ZTmp   .EQS. "I"  THEN GOTO Do_Introduction
$	IF ZTmp   .EQS. "Q"  THEN GOTO Do_Qualifiers
$	IF Ztmp   .EQS. "F"  THEN GOTO Final_Exam
$	Result:=="BAD"
$	EXIT

$!______________
$	EXIT
$Final_Exam:
$	PAGE
$	TYPE SYS$INPUT

			The Final Exam



Now lets see if you remember how to use the DELETE command.
Will the following delete command
$!______________
$	Nmax==6
$	Test=="T"
$	Question==""
$	Question_1=="Delete files modified after 1-Jan-1983"
$	Example_1=="DEL /SINCE=1-JAN-1982 FOO.TXT;*"
$	Answer_1=="N"
$	Reason_1=="To DELETE modified files must also include /MODIFIED"
$	Question_2=="DELETE all text files on a directory"
$	Example_2=="DEL *.TXT"
$	Answer_2=="N"
$	Reason_2=="An explicit version number is always required."
$	Question_3=="DELETE all Fortran source files created today"
$	Example_3=="DEL/CREATED/SINCE=TODAY *.FOR;*"
$	Answer_3=="Y"
$	Reason_3=="TODAY is also a valid date string"
$	Question_4=="Prompt for each file to delete"
$	Example_4=="DEL/CONFIRM *.txt;*"
$	Answer_4=="Y"
$	Reason_4=="VMS will prompt to confirm the deletion of each file"
$	Question_5=="Recover a deleted file"
$	Example_5=="DEL/RECOVER *.TXT;*"
$	Answer_5=="N"
$	Reason_5=="Once a file is deleted is is gone for good."
$	Question_6=="Delete a file across the network"
$	Example_6=="DEL FUSION::[7,250]VECTOR.TXT;*"
$	Answer_6=="N"
$	Reason_6=="To delete files on a remote node requires an account and password string"
$	EXIT
$Do_Introduction:
$	Test=="F"
$	Page
$	Type SYS$INPUT
		  Introduction to the VMS DELete Command

     The VMS DELete command is used to delete files from your directory.
The command may be abbreviated as "DEL".  The command has the following syntax.

	$ DEL/qualif1..../qualifN filspec1,filespec2.....,filespecN

where the file specifiers can include wild cards (*) for directory, name,
type, or extension.  The qualifiers are used for producing selective directory 
formatting, or extended informational display.  One or more qualifiers may
be present but none are required.  The DELete command will produce an error
message if you do not explicitly state the version number of the file
to be deleted.  This is done as a safety precaution.  You either MUST
specify a specific version number or a wild card (*) version number.

     The first file specification must contain an explicit or default
directory specification plus a file name, a file type, and a version number.
Subsequent file specifications must contain at least a version number.  A
semicolon followed by no file version number, a version number of 0, or one
or more blanks, results in the deletion of the latest version of the file.

$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT
     The DELete command assumes certain defaults if partial file specifiers
are present.

	-  If no device is present, it defaults to your current 
	   system device.

	-  If no directory is specified, it defaults to your current
  	   directory.

	-  If multiple file specifiers are present, files specifiers
	   after the first default to the file name and file type
 	   of the first file specified.

$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT
     Now let us observe the effects of certain DELETE commands.
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	WRITE SYS$OUTPUT "[12;24r"		! Scroll bet lines 11-24
$	Return="Command_1
$	Text="The DELETE command requires a file specifier"
$	Command="DEL"
$	GOTO Do_Command
$Command_1:
$	Command="DEL DELXXXXX1.TXT;1
$	Text="You are warned if the file is not found"
$	Return="Command_2"
$	GOTO Do_Command
$Command_2:
$	TYPE/OUTPUT=DELXXXXX1.TXT SYS$INPUT
	THIS IS A DUMMY FILE TO DELETE
$	Command="DEL DELXXXXX1.TXT"
$	Text="To DELete a file, you must supply an explicit version number"
$	Return="Command_3"
$	GOTO Do_Command
$Command_3:
$	Command="DELETE DELXXXXX1.TXT;*
$	Text="If the file exists, and version number is supplied, the file is deleted"
$	Return="Command_4"
$	GOTO Do_Command
$Command_4:
$	TYPE/OUTPUT=DELXXXXX1.TXT SYS$INPUT
	THIS IS A DUMMY FILE TO DELETE
$	COPY DELXXXXX1.TXT *
$	Command="DELETE DELXXXXX1.TXT;1,;2"
$	Text="The second file uses the name and type of the first file"
$	Return="Command_5"
$	GOTO Do_Command
$Command_5:
$	TYPE/OUTPUT=DELXXXXX1.TXT SYS$INPUT
	THIS IS A DUMMY FILE TO DELETE
$	COPY DELXXXXX1.TXT *
$	Command="DEL DELXXXXX1.TXT;1 DELXXXXX1.TXT;2"
$	Text="Multiple files must be seperated with commas or + signs"
$	Return="Command_6"
$	GOTO Do_Command
$Command_6:
$	DELETE DELXXXXX*.TXT;*
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	PAGE
$	TYPE SYS$INPUT

	Remember, once a file is deleted it is GONE FOR GOOD.  For general
use, the PURGE command can be used to delete old versions of files always
keeping the most recent files.  Be very careful when using wild cards as
part of file.  It is very easy to wipe out all your work.
$	Test="F"
$	INQUIRE/NOPUN TMP "''EraseL23'Press RETURN when ready"
$	EXIT
$Do_Qualifiers:
$	Test=="F"
$	PAGE
$	TYPE SYS$INPUT
     You may request that files be interactively deleted by using the

				/CONFIRM

qualifier.  When the /CONFIRM qualifier is included, prior to deleting a 
file you are requested to confirm thay you wish the file deleted by answering
a "Y" to the confirmation request.  Unless you respond the the request with
a "Y" followed by a RETURN the file will not be deleted.  /NOCONFIRM is
also a valid qualifier.  The default for DELete is /NOCONFIRM.

     The /LOG qualifier displays the file specifier for each file after
it is deleted.  /NOLOG is also a valid qualifier.  /NOLOG is the default
for DELete.


$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT
     A number of qualifiers may be used to control the deletion of files.
In addition to selecting files for deletion based on file name, type or
version, files may be selected for deletion based on the dates when they
were created or modified. The qualifiers

               /CREATED          and          /MODIFIED

select whether or not file deletion based on creation date or modification
date is to be used.  If either /CREATED or /MODIFIED is used, it is also
necessary to specify the range of dates to delete using either or both
of  /BEFORE or /SINCE.

     Both /BEFORE and /SINCE require a valid date string.  The syntax is

	          /BEFORE=date_string
	          /SINCE=date_string

where date_string is goverened by the rules for forming a VMS time/date 
string.  You can specify an absolute or delta time or a combination of
the two.

$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT

	Detailed information on forming valid date_strings can be found
in the VMS Command Language user's in section 5.8.1 or by typing 
HELP SPECIFY DATE_TIME from DCL.  In its simplist format a date string
is 
			DD-MMM-YYYY

where 		DD    -  Day of Month
		MMM   -  Month of year (Jan, Feb,....Dec)
		YYYY  -  Year (1982, 1983, etc)

So to delete all files created prior to August 12, 1976 one would use
a command of the form

	$ DELETE /CREATED/SINCE=12-AUG-1976 *.*;*


$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT
     Now let us observe the effects of certain DELETE qualifiers.
$	ON CONTROL_Y THEN GOTO Reset_Terminal	!
$	WRITE SYS$OUTPUT "[12;24r"		! Scroll bet lines 11-24
$	TYPE/OUTPUT=DELXXXXX1.TXT SYS$INPUT
	THIS IS A DUMMY FILE TO DELETE
$	TYPE/OUTPUT=DELXXXXX1.TXT SYS$INPUT
	THIS IS A DUMMY FILE TO DELETE
$	Command="DELETE/LOG DELXXXXX1.TXT;*"
$	Text="Display all files deleted to SYS$OUTPUT"
$	Return="QUAL_1"
$	GOTO Do_Command
$Qual_1:
$	TYPE/OUTPUT=DELXXXXX1.TXT SYS$INPUT
	THIS IS A DUMMY FILE TO DELETE
$	TYPE/OUTPUT=DELXXXXX2.TXT SYS$INPUT
	THIS IS A DUMMY FILE TO DELETE
$	Command="DELETE/CONFIRM DELXXXXX*.TXT;*"
$	Text="Specify Y/N for each file please"
$	Return="QUAL_2"
$	GOTO Do_Command
$Qual_2:
$	TYPE/OUTPUT=DELXXXXX1.TXT SYS$INPUT
	THIS IS A DUMMY FILE TO DELETE
$	TYPE/OUTPUT=DELXXXXX2.TXT SYS$INPUT
	THIS IS A DUMMY FILE TO DELETE
$	Command="DELETE/CREATED/SINCE=01-JAN-1983 DELXXXXX*.TXT;*"
$	Text="Delete the named files created since 01-Jan-1983"
$	Return="QUAL_3"
$	GOTO Do_Command
$Qual_3:
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	EXIT					!
$!
$Reset_Terminal:
$	WRITE SYS$OUTPUT "[1;24r"	! reset scrolling region
$	WRITE SYS$OUTPUT "[?4l"	! Back to jump scroll
$	EXIT


$Do_command:
$	WRITE SYS$OUTPUT "''EraseL05'''Text'"
$	WRITE SYS$OUTPUT -
"''Erasel07'Execute the command:  ''Bold'''Command'''No_Bold'"
$	WRITE SYS$OUTPUT -
"''EraseL11'			===================="
$	WRITE SYS$OUTPUT "''EraseL12'[J[?4h"
$	WRITE SYS$OUTPUT "''EraseL12'$ ''Command'"
$	ON ERROR THEN CONTINUE
$	'Command'
$	INQUIRE/NOPUN TMP "''EraseL23'Press RETURN when ready"
$	WRITE SYS$OUTPUT "''EraseL23'[?4l"
$	GOTO 'Return'
