$	IF P1 .NES. "" THEN GOTO DO_SUBROUTINE
$	PAGE
$	WRITE SYS$OUTPUT "KMSCAI -- No subroutine specified
$	WAIT 00:00:03
$	EXIT
$Do_Subroutine:
$	GOTO 'P1'			!
$	EXIT
$!
$Menu:
$	PAGE
$	TYPE SYS$INPUT
#4[7m                                   [0m
#3[7m  [0m The VAX/VMS Directory Command [0;7m  [0m
#4[7m  [0m The VAX/VMS Directory Command [0;7m  [0m
#3[7m                                   [0m

			Type ^Y to Exit at any time
You may choose:

		[1mI[0mntro      -  Indroduction to the Directory Command
		[1mO[0mutput     -  Directory output qualifiers
		[1mQ[0mualifiers -  File attribute qualifiers
		[1mS[0melection  -  File selection qualifiers
		[1mF[0minal      -  Final exam
		[1mE[0mxit       -  Exit this menu

$		EXIT
$Select:
$	Test:=="F"
$	Result:=="OK"
$	ZTmp=P2
$	ZTMP1=P3
$	IF ZTmp   .EQS. "E"  THEN Result:=="DONE"
$	IF ZTmp   .EQS. "E"  THEN EXIT
$	IF ZTmp   .EQS. "I"  THEN GOTO Do_Introduction
$	IF ZTmp   .EQS. "Q"  THEN GOTO Do_Qualifiers
$	IF Ztmp   .EQS. "S"  THEN GOTO Do_Select
$	IF ZTmp   .EQS. "O"  THEN GOTO Do_Output
$	IF Ztmp   .EQS. "F"  THEN GOTO Final_Exam
$	Result:=="BAD"
$	EXIT

$!______________
$	EXIT
$Final_Exam:
$	PAGE
$	TYPE SYS$INPUT

			The Final Exam



Now lets see if you remember what the qualifiers do.
Will the following directory command
$!______________
$	Nmax==8
$	Test=="T"
$	Question==""
$	Question_1=="Display files modified after 1-Jan-1982"
$	Example_1=="DIR /SINCE=1-JAN-1982"
$	Answer_1=="N"
$	Reason_1=="To list modified files must also include /MODIFIED"
$	Question_2=="Display all files on a directory"
$	Example_2=="DIR/VERSION=1 *.*;*"
$	Answer_2=="N"
$	Reason_2=="Only the highest version of each file will be listed."
$	Question_3=="Display the work done today on fortran source files"
$	Example_3=="DIR/SINCE *.FOR"
$	Answer_3=="Y"
$	Reason_3=="/SINCE defaults to files created today since midnight."
$	Question_4=="Display the total block usage on the system disk"
$	Example_4=="DIR SYS$SYSDEVICE:[000000...]/TOT"
$	Answer_4=="Y"
$	Reason_4=="The command starts with the index directory and works down."
$	Question_5=="Display the file owner and the date of last backup"
$	Example_5=="DIR/FULL/EXCLUDE=(*.LIS,*.MAR) FOO.*"
$	Answer_5=="Y"
$	Reason_5=="The /FULL qualifier lists all file attributes."
$	Question_6=="Display a single column listing of all files"
$	Example_6=="DIR/COLUMN=2/OWNER/DATE *.*;*"
$	Answer_6=="Y"
$	Reason_6=="The /COL switch only works for simple, /BRIEF format."
$	Question_7=="Send a directory to the printer for listing."
$	Example_7=="DIR/OUTPUT=PRINTER.LIS/OWNER/DATE"
$	Answer_7=="N"
$	Reason_7=="Printer.LIS will not get automatically get sent to the printer."
$	Question_8=="Display the number of blocks allocated to a file."
$	Example_8=="DIR/SIZE"
$	Answer_8=="N"
$	Reason_8=="The /SIZE displays blocks used, not blocks allocated."
$	EXIT
$Do_Introduction:
$	Test=="F"
$	Page
$	Type SYS$INPUT
		  Introduction to the VMS DIRectory Command

     The VMS DIRectory command is used to show which files are in a directory
and display certain characteristics about them.  The command (normally
abreviated as DIR) has the following syntax.

	$ DIR/qualif1..../qualifN filspec1,filespec2.....,filespecN

where the file specifiers can include wild cards (*) for directory, name,
type, or extension.  The qualifiers are used for producing selective directory 
formatting, or extended informational display.  One or more qualifiers or
file specifiers may be present but neither is required


$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT
     The DIRectory command assumes certain defaults if partial file specifiers
or no filespecifiers are present.

	-  If no file specification is present, all versions of
	   all files in your current directory are displayed.  

	-  If you specify only a device name as part of the file
	   specifier, DIR uses your current default directory.  

	-  Whenever the file specification omits a file name and type, 
	   all versions of all files in the directory are displayed.

	-  If a file specification contains a file name and/or file
	   type and no version number, all versions are listed.

	-  If a file specification contains only a file name, all
	   file type and versions are listed.

$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT
     Now let us observe the effects of certain DIRectory commands.
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	WRITE SYS$OUTPUT "[12;24r"		! Scroll bet lines 11-24
$	Return="Command_1
$	Text="The current directory is displayed if there are no file specifiers"
$	Command="DIR"
$	GOTO Do_Command
$Command_1:
$	Command="DIR SYS$SYSROOT:[SYSUPD]"
$	Text="Only specify a directory and all files on it are displayed"
$	Return="Command_2"
$	GOTO Do_Command
$Command_2:
$	Command="DIR SYS$SYSROOT:[SYSEXE]SYS"
$	Text="All file types are displayed if file type is omitted."
$	Return="Command_3"
$	GOTO Do_Command
$Command_3:
$	Command="DIR SYS$SYSROOT:[SYSEXE]SYS.EXE"
$	Text="Use a complete file specifier to select a specific file."
$	Return="Command_4"
$	GOTO Do_Command
$Command_4:
$	Command="DIR SYS$SYSROOT:[SYSEXE]*.COM"
$	Text="Use wild cards to display all files of a given type."
$	Return="Command_5"
$	GOTO Do_Command
$Command_5:
$	Command="DIR SYS$SYSROOT:[SYSEXE]SYS.*"
$	Text="Use wild cards to display all file types with a given name."
$	Return="Command_6"
$	GOTO Do_Command
$Command_6:
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	PAGE
$	TYPE SYS$INPUT

	Remember the DIRectory command is simple to use.  Whenever you
want to see what files are present on your current directory just type

		$ DIR

to the DCL prompt ($).  Often you will see that unneeded files are
accumulating (old versions).  Use the PURge or DELete command to remove
these files so you do not run out of allocated disk space.
$	Test="F"
$	INQUIRE/NOPUN TMP "''EraseL23'Press RETURN when ready"
$	EXIT
$!______________
$	EXIT
$Do_Qualifiers:
$	Test=="F"
$	PAGE
$Do_Qualifiers_1:
$	Qualif_Return="Do_Qualifiers"
$	TYPE SYS$INPUT
		Directory Qualifiers

You may choose:
		[1mI[0mntro       -  Indroduction to DIRectory qualifiers
		[1m/D[0mATE       -  Date display      
		[1m/F[0mULL       -  Complete file information
		[1m/O[0mWNER      -  File owner information
		[1m/P[0mROTECTION -  File protection information
		[1m/S[0mize       -  File size information
		[1m/T[0motal      -  Print file size totals
		[1mE[0mxit        -  Exit this menu

$Qualif_Select:
$	INQUIRE Z "''Erasel15'Choice"
$	Z1[0,1]:='Z'
$	Z2[0,2]:='Z'
$	IF Z1     .EQS. "E"  THEN EXIT
$	IF Z2     .EQS. "/D" THEN GOTO Qualif_Date
$	IF Z2     .EQS. "/F" THEN GOTO Qualif_Full
$	IF Z2     .EQS. "/O" THEN GOTO Qualif_Owner
$	IF Z2     .EQS. "/P" THEN GOTO Qualif_Protect
$	IF Z2     .EQS. "/S" THEN GOTO Qualif_Size
$	IF Z2     .EQS. "/T" THEN GOTO Qualif_Total
$	IF Z1     .EQS. "I"  THEN GOTO Qualif_Intro
$	WRITE SYS$OUTPUT "''EraseL22'KMSCAI -- ''Choice' is not an allowed qualifier"
$	GOTO QUALIF_SELECT
$Qualif_Intro:
$	PAGE
$	TYPE SYS$INPUT
	The DIRectory command has a wealth of qualifiers which can be used
for extracting specific information about the files on a given directory.
By default, the DIRectory command produces a display with the following
qualifiers active.

	/BRIEF          Only file name, type and version listed
	/COLUMNS=4      Display directory in 4 column format.
	/NODATE         Do not display date information.
	/HEADING        Display Directory header before listing files.
	/NOOWNER        No display of file ownership
	/NOPROTECTION   No display of file protection
	/NOSIZE         No display of file sizes
	/TRAILING       Display disk space allocation and # files at end

All the information that one can obtain about a file may be seen by
using the /FULL qualifier.


$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	GOTO Do_Qualifiers
$Qualif_Full:
$	PAGE
$	TYPE SYS$INPUT
		The /FULL Qualifier

     All the information available about a file can be obtained using
the /FULL qualifier.  The information available includes;

	File Name         Date of creation           Date of last back-up
	File Type         Date of last modification  Date of expiration
	Version #         File Owner's UIC           File Protection
	# Blocks Used     File Id # (FID)            File Organization
	# Blocks Alloc.   Record Attributes          Record format

Observe the difference in display as we issue both a DIR/BRIEF and a 
DIR/FULL command on the same file.

$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	ON CONTROL_Y THEN GOTO Reset_Terminal	!
$	WRITE SYS$OUTPUT "[12;24r"		! Scroll bet lines 11-24
$	Command="DIR/BRIEF SYS$SYSROOT:[SYSEXE]SYS.EXE"
$	Text="Use the /BRIEF qualifier for a brief display."
$	Return="QUAL_1"
$	GOTO Do_Command
$Qual_1:
$	Command="DIR/FULL SYS$SYSROOT:[SYSEXE]SYS.EXE"
$	Text="Use the /FULL qualifier for a Full display."
$	Return="QUAL_2"
$	GOTO Do_Command
$Qual_2:
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	GOTO Do_Qualifiers
$Qualif_Size:	
$	PAGE
$	TYPE SYS$INPUT
     Various file attributes displayed by the /FULL qualifier can be
individually displayed.  For example the /SIZE qualifier is used to
display the amount of disk space files are using.  The format of the
/SIZE qualifier is
			/SIZE[=option]

where the '=option' is optional, and can be any of ALL, ALLOCATION, or
USED.  When a file is created so many disk blocks are allocated for
its use.  It may or may not use all of these disk blocks.  Disk space
is allocated in clusters of 'n' blocks, where 'n' is set when the
disk is initialized.  The value of 'n' is called the Cluster Factor of
the disk.  If the space a file is Using differs from its allocation
by more than its cluster factor, you may be waisting space and should
consider truncating the file (SET FILE/TRUNCATE filespec).

$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT
     Now let us observe the DIR/SIZE display with various options.
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	WRITE SYS$OUTPUT "[12;24r"		! Scroll bet lines 11-24
$	Command="DIR/SIZE SYS$SYSROOT:[SYSEXE]SYS.EXE"
$	Text="Use the /SIZE qualifier with no options."
$	Return="QUAL_3"
$	GOTO Do_Command
$Qual_3:
$	Command="DIR/SIZE=ALL SYS$SYSROOT:[SYSEXE]SYS.EXE"
$	Text="Display Used and Allocated space with the /SIZE=ALL qualifier."
$	Return="QUAL_4"
$	GOTO Do_Command
$Qual_4:
$	Command="DIR/SIZE=USED SYS$SYSROOT:[SYSEXE]SYS.EXE"
$	Text="Display Used space with the /SIZE=USED qualifier.
$	Return="QUAL_5"
$	GOTO Do_Command
$Qual_5:
$	Command="DIR/SIZE=ALLOCATION SYS$SYSROOT:[SYSEXE]SYS.EXE"
$	Text="Display Allocated space with the /SIZE=ALLOCATED qualifier.
$	Return="QUAL_6"
$	GOTO Do_Command
$QUAL_6:
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	GOTO Do_qualifiers
$Qualif_Owner:
$	PAGE
$	TYPE SYS$INPUT
     The file's owner (UIC) can easily be displayed by using the /OWNER
qualifier.  For example;

$	Command="DIR/OWNER SYS$SYSROOT:[SYSEXE]SYS.EXE"
$	Text="Display the file and its owner"
$	Return="QUAL_7"
$	GOTO Do_Command
$QUAL_7:
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	GOTO DO_QUALIFIERS
$Qualif_Total:
$	PAGE
     The /TOTAL qualifier inhibits the listing of all individual file 
information and prints only;
	# of files listed
	Total # of blocks used per directory
	Total # of blocks allocated
	Total number of directories and total blocks used
	    and/or allocated in all directories 
	    (if multiple directories are listed).

By default the output format is /BRIEF
$	INQUIRE/NOPUN Tmp "''EraseL15'Press RETURN to continue"
$	GOTO Do_Qualifiers

$Qualif_Protect:
$	PAGE
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	TYPE SYS$INPUT
     File protection is broken down into four protection levels based 
on the user's UIC.  The levels are SYSTEM, OWNER, GROUP, and WORLD.  The 
file's OWNER is the person who's UIC matches the UIC of the file.  A SYSTEM
UIC is any UIC with a group number of 10 or less.  A user's GROUP are all
users sharing the same group code in the UIC.  The WORLD represents all others.
Each level can individually be granted READ(R), WRITE(W), EXECUTE(E), and
DELETE(D) privileges for a file. The protection mask for the file can be 
displayed with the /PROTECTION qualifier.  File protection is coded
for display as [S:RWED,O:RWED,G:RWED,W:RWED] where the letters following
the S:, O:, G: and W: signify the access level to the file.  If the level
is RWED, all forms of access is permitted and the file is totally unprotected.

$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	WRITE SYS$OUTPUT "[12;24r"		! Scroll bet lines 11-24
$	TYPE SYS$INPUT
   For an example of the /PROT qualifier:
$	Command="DIR/OWNER/PROT SYS$SYSROOT:[SYSEXE]SYS.EXE"
$	Text="Display the file and its owner and its protection level"
$	Return="QUAL_8"
$	GOTO Do_Command
$QUAL_8:
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	GOTO DO_Qualifiers
$Qualif_date:
$	PAGE
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	TYPE SYS$INPUT
     The /DATE qualifier displays the four dates associated with each
file.  The form of this option is 

	/DATE[=option]

where '=option' is optional and can take values

	  /DATE=ALL		Displays all four dates
 	       =BACKUP		Displays date of last backup
	       =CREATED		Displays creation date
	       =EXPIRED		Displays the expiration date
	       =MODIFIED	Displays the date last modified

If no option is specified /DATE=CREATED is defaulted.

$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	WRITE SYS$OUTPUT "[12;24r"		! Scroll bet lines 11-24
$	TYPE SYS$INPUT
   For an examples of the /DATE qualifier:

$	Command="DIR/DATE SYS$SYSROOT:[SYSEXE]SYS.EXE"
$	Text="Display the file creation date (by default)"
$	Return="QUAL_9"
$	GOTO Do_Command
$QUAL_9:
$	Command="DIR/DATE=ALL SYS$SYSROOT:[SYSEXE]SYS.EXE"
$	Text="Display all dates related to the file"
$	Return="QUAL_10"
$	GOTO Do_Command
$QUAL_10:
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	GOTO Do_Qualifiers
$!
$Do_Output:
$	Test=="F"
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	PAGE
$	WRITE SYS$OUTPUT "[?4h"		! Force smooth scroll
$	TYPE SYS$INPUT
     A number of qualifiers are used to control the format of the directory
display and to direct the output of the display.

	/BRIEF				Only display the file names.  Uses a 
					multi-column output format display.

	/COLUMNS=n			Lists files using the specified number
					of columns.  Only valid for /BRIEF
					format.

	/OUTPUT[=filespec]		Directs output to the specified file
					rather than the current SYS$OUTPUT

	/PRINTER			The output is directed to DIRECTORY.LIS
					which is spooled to the printer and
					then deleted.

	/NOHEADING			By default a directory heading is
					displayed prior to file listings.
					/NOHEADING suppresses this output.

	/NOTRAILING			Supresses display of the number of
					files listed, the number of blocks
					used, and the totals for directories
					and blocks if multiple directories
					specified.

$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	WRITE SYS$OUTPUT "[12;24r"	! set scrolling region
$	INQUIRE/NOPUN TMP "''EraseL23'Press RETURN when ready"
$	page
$	TYPE SYS$INPUT
	Now for some examples;

$	Command="DIR/NOHEADING/NOTRAILING SYS$ERRORLOG"
$	Text="Display files without heading and trailing information"
$	Return="Out_1"
$	GOTO Do_Command
$Out_1:
$	Command="DIR/COLUMN=2 SYS$ERRORLOG"
$	Text="Display using two columns instead of the standard 4 columns"
$	Return="Out_2"
$	GOTO Do_Command
$Out_2:
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	EXIT
$Do_Select:
$	Test=="F"
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	PAGE
$	TYPE SYS$INPUT
     Certain qualifiers are used to select certain classes of files for
display based on dates or versions of files, or based on excluding certain
files.

 /SINCE [=time]		Displays all files which were CREATED, MODIFIED,
 /BEFORE[=time]		which EXPIRED  or which were backed up SINCE or
 			BEFORE the specified time.  If no time specified,
 			then the current date at 00:00 is used.  Also
 			by default, if none of /CREATED, /MODIFIED,/BACKUP 
 			or /EXIRED is specified, /CREATED is assumed.
 
 /EXCLUDE=(fspec,...)	Excludes the listed file specifications from
 			the directory listing.
 
 /BACKUP  /CREATED	Used with the /SINCE or /BEFORE switch to
 /EXPIRED /MODIFIED	select the type of date to select on.
 	
 /VERSIONS=n		Lists the latest 'n' versions of each file.

$	WRITE SYS$OUTPUT " "
$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT
	Some examples of file selection qualifiers

$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	WRITE SYS$OUTPUT "[?4h"		! Back to smooth scroll
$	WRITE SYS$OUTPUT "[12;24r"		! set scrolling region
$	Command="DIR/EXCLUDE=(*.EXE,*.SYS,*.COM,*.DAT,*.STB) SYS$SYSROOT:[SYSEXE]"
$	Text="Exclude *.EXE, *.SYS, *.COM, *.DAT and *.STB files from listing"
$	Return="Do_select_2"
$	GOTO Do_Command
$Do_Select_2:
$	Command="DIR/SINCE"
$	Text="Display all files created on this account today."
$	Return="Do_Select_3"
$	GOTO Do_Command
$Do_Select_3:
$	Command="DIR/SINCE/MODIFIED SYS$MANAGER"
$	Text="Display files modified since today at midnight"
$	Return="Do_Select_4"
$	GOTO Do_Command
$Do_Select_4:
$	WRITE SYS$OUTPUT "[1;24r"	! reset scrolling region
$	WRITE SYS$OUTPUT "[?4l"	! Back to jump scroll
$	EXIT
$!
$Reset_Terminal:
$	WRITE SYS$OUTPUT "[1;24r"	! reset scrolling region
$	WRITE SYS$OUTPUT "[?4l"	! Back to jump scroll
$	EXIT


$Do_command:
$	WRITE SYS$OUTPUT "''EraseL05'''Text'"
$	WRITE SYS$OUTPUT -
"''Erasel07'Execute the command:  ''Bold'''Command'''No_Bold'"
$	WRITE SYS$OUTPUT -
"''EraseL11'			===================="
$	WRITE SYS$OUTPUT "''EraseL12'[J[?4h"
$	WRITE SYS$OUTPUT "''EraseL12'$ ''Command'"
$	'Command'
$	INQUIRE/NOPUN TMP "''EraseL23'Press RETURN when ready"
$	WRITE SYS$OUTPUT "''EraseL23'[?4l"
$	GOTO 'Return'
