$	IF P1 .NES. "" THEN GOTO DO_SUBROUTINE
$	PAGE
$	WRITE SYS$OUTPUT "KMSCAI -- No subroutine specified
$	WAIT 00:00:03
$	EXIT
$Do_Subroutine:
$	GOTO 'P1'			!
$	EXIT
$!
$Menu:
$	PAGE
$	TYPE SYS$INPUT
   #4[7m                                [0m
   #3[7m  [0m The VAX/VMS File Specifier [0;7m  [0m
   #4[7m  [0m The VAX/VMS File Specifier [0;7m  [0m
   #3[7m                                [0m

			Type ^Y to Exit at any time
You may choose:

		[1mI[0mntro     -  Indroduction to the VMS file specifier
		[1mDE[0mvice    -  Learn/test on Device Name
		[1mDI[0mrectory -  Learn/test on Directory Name
		[1mNA[0mme      -  Learn/test on File Name
		[1mNO[0mde      -  Learn/test on Node Name
		[1mT[0mype      -  Learn/test on File type
		[1mV[0mersion   -  Learn/test on File Version Number
		[1mF[0minal     -  Final Exam
		[1mE[0mxit      -  Exit this menu

$		EXIT
$Select:
$	Test:=="F"
$	Result:=="OK"
$	ZTmp=P2
$	ZTMP1=P3
$	IF ZTmp1  .EQS. "DE" THEN GOTO Do_Device
$	IF ZTmp1  .EQS. "DI" THEN GOTO Do_Directory
$	IF ZTmp   .EQS. "E"  THEN Result:=="DONE"
$	IF ZTmp   .EQS. "E"  THEN EXIT
$	IF ZTmp   .EQS. "F"  THEN GOTO Final_Exam
$	IF ZTmp   .EQS. "I"  THEN GOTO Do_Introduction
$	IF ZTmp1  .EQS. "NA" THEN GOTO Do_Name
$	IF ZTmp1  .EQS. "NO" THEN GOTO Do_Node
$	IF ZTmp   .EQS. "T"  THEN GOTO Do_Type
$	IF ZTmp   .EQS. "V"  THEN GOTO Do_Version
$	Result:=="BAD"
$	EXIT
$Do_Device:
$	PAGE
$	TYPE SYS$INPUT
		The VAX/VMS Device Specifier

     Files reside on physical devices; disks and tapes in general.  The
device name is used to reference these devices.  The device name consists
of three parts the device mnemonic, the controler index, and the unit number.
The general form of the device name is 

			DDCUU:

where:	DD  - The device mnemonic 
	C   - The controler index (A - Z)
	UU  - The unit number (0 - 7)
	:     Terminates the device name 

The device mnemonics on our system are

		DM     RK07 disk  (Controler A, Unit 1 only)
		DR     RM03 disk drive (Controler A, Unit 0 and 1 only)
		MS     TS11 Tape Drive
		TT     Terminals (Controlers A, B, C. Units 0 - 7)

$	INQUIRE/NOPUN Tmp "Press RETURN to continue"
$	PAGE
$	TYPE SYS$INPUT

	The general form of the device specifier is

                                DDCUU:

Now let's see if you learned the rules
$!______________
$	Nmax==8
$	Question=="Is the above example a valid device name"
$	Test=="T"
$	Example_1=="DRA0:"
$	Answer_1=="Y"
$	Reason_1=="DRA0: is our system disk."
$	Example_2=="D?A0:"
$	Answer_2=="N"
$	Reason_2=="A ? can not be in a device name."
$	Example_3=="DR0"
$	Answer_3=="N"
$	Reason_3=="Both the controler index and the : are missing."
$	Example_4=="DRA:"
$	Answer_4=="N"
$	Reason_4=="The unit number must be specified."
$	Example_5=="DA1:"
$	Answer_5=="N"
$	Reason_5=="The device mnemonic must be two letters."
$	Example_6=="MSA0:
$	Answer_6=="Y"
$	Reason_6=="MSA0: is the name of our TS11 tape drive."
$	Example_7=="TTC9:"
$	Answer_7=="N"
$	Reason_7=="Terminal unit numbers run from 0 - 7 only."
$	Example_8=="OPA0:"
$	Answer_8=="Y"
$	Reason_8=="OPA0: is the name of the system console."
$	EXIT


$Do_Directory:
$	PAGE
$	TYPE SYS$INPUT
 		    The VAX/VMS Directory Specifier

     Directories are named areas of the disk (like file drawers) where
files can be located.  Each directory name consists of 1-9 alpha-numeric
characters.  The entire directory name is enclosed in brackets.  VMS also
supports directory/subdirectory combinations.  A subdirectory name
also consists of 1-9 alpha-numeric characters.  Subdirectories may them
selves have subdirectories.  A total of 8 levels of directories and
subdirectories are possible.  The general form of a directory string is

  [ Directory . Subdirectory1 . Subdirectory2 . .... Subdirectory8 ]

where the spaces are for clarity and should not be present.  In the 
total directory specifier, each subdirectory is seperated from its
adjoining directories or subdirectories by a ".".  When a directory-
subdirectory string is specified for locating a file specifier, each
directory and subdirectory must be correctly accessed in sequence for
the system to find the file.

$	INQUIRE/NOPUN Tmp "Press RETURN when ready to continue"
$	PAGE
$	TYPE SYS$INPUT

  [1m[ [0mDirectory [1m.[0m Subdirectory1 [1m.[0m Subdirectory2 [1m.[0m .... Subdirectory8 [1m][0m

     To simplify the problem of searching through multiple directories for 
a file the wild card (*) and the elipsis (...) may be used.  The wild card
will match any directory/subdirectory name at that level.  The elipsis
means that starting with the toplevel directory one should search down
through all in-line directories.  Either [ ] or < > pairs may be used to
delimit the directory names.

Now lets see if you learned the rules
$!______________
$	Nmax==8
$	Question=="Is the above example a valid directory specifier"
$	Test=="T"
$	Example_1=="[DOWNWARD]"
$	Answer_1=="Y"
$	Reason_1=="[DOWNWARD] is a legal directory name."
$	Example_2=="[SMITH.RUNOFF"
$	Answer_2=="N"
$	Reason_2=="The Directory is not terminated with a ]."
$	Example_3=="[ALLMYFILES]"
$	Answer_3=="N"
$	Reason_3=="A directory can have a maximum of 9 alpha-numeric characters"
$	Example_4=="[ROY$SMITH]"
$	Answer_4=="N"
$	Reason_4=="Only alpha numeric characters are allowed in directory names."
$	Example_5=="[VAVRA...]"
$	Answer_5=="Y"
$	Reason_5=="All files in all subdirectories of VAVRA will be searched."
$	Example_6=="[MARKB..GRAPH]"
$	Answer_6=="N"
$	Reason_6=="A single . seperates subdirectories, a ... is the elipsis."
$	Example_7=="MARKB.GRAPH.DATA"
$	Answer_7=="N"
$	Reason_7=="Both the [ and the ] are missing."
$	Example_8=="[310310]"
$	Answer_8=="Y"
$	Reason_8=="Numbers are valid in directory names."
$!______________
$	EXIT
$Do_Name:
$	PAGE
$	TYPE SYS$INPUT
			The VAX/VMS File Name

     A file name consists of from 1 - 9 alpha-numeric characters.  The
file name is seperated from the file type by a period.  The file name
is seperated from a directory by a ].  If no directory is specified
and a device or node name is specified, the ":" seperates the device
specifier or node name from the file name.

Now lets see if you learned the rules
$!______________
$	Nmax==8
$	Question=="Is the above a vaild file name"
$	Test=="T"
$	Example_1=="MYFILE"
$	Answer_1=="Y"
$	Reason_1=="MYFILE is a legal file name."
$	Example_2=="MYVERYLONGFILENAME"
$	Answer_2=="N"
$	Reason_2=="The filename length is more than 9 characters long."
$	Example_3=="MY_FILE"
$	Answer_3=="N"
$	Reason_3=="A file name can contain only the letters A-Z and numbers 1-9."
$	Example_4=="MY FILE"
$	Answer_4=="N"
$	Reason_4=="Embedded spaces are not allowed in file names."
$	Example_5=="DBA0:Myfile;Typ"
$	Answer_5=="N"
$	Reason_5=="File names must be seperated from file types with a .  "
$	Example_6=="[DirectoryMyfile.Typ"
$	Answer_6=="N"
$	Reason_6=="File names must be seperated from directories with a ]."
$	Example_7=="DRA0Myfile.Typ"
$	Answer_7=="N"
$	Reason_7=="Device names and file names must be seperated with a :."
$	Example_8=="DRA0:SN1234.DAT"
$	Answer_8=="Y"
$	Reason_8=="Numbers are allowed in file names."
$!______________
$	EXIT
$Do_Node:
$	PAGE
$	TYPE SYS$INPUT
		The VAX/VMS Node Name Specifier

   The VMS node name designates which computer on a network to reference.
A VMS node name consists of 1 - 6 alpha-numeric characters seperated
from the rest of the file specifier with a ::.  Optionally, the node
name may contain a access control string enclosed in quotes which is 
required to gain access to a file on a remote network node. This general
form for the node specifier is

		Node_Name"Account_name Password"::

Now lets see if you learned the rules
$!______________
$	Nmax==6
$	Question=="Is the above an example of a valid node name"
$	Test=="T"
$	Example_1=="FUSION::"
$	Answer_1=="Y"
$	Reason_1=="FUSION:: is the node name of the 11/45."
$	Example_2=="VERYLONGNODENAME::"
$	Answer_2=="N"
$	Reason_2=="The node name length is more than 6 characters."
$	Example_3=="MY_NODE"
$	Answer_3=="N"
$	Reason_3=="A node name can contain only the letters A-Z and numbers 1-9."
$	Example_4=="DMS 34::"
$	Answer_4=="N"
$	Reason_4=="Embedded spaces are not allowed in simple node names."
$	Example_5=="STAR"
$	Answer_5=="N"
$	Reason_5=="Node names need a trailing :: when used in a file specifier."
$	Example_6=="FUSION""""Myname Password""""::"
$	Answer_6=="Y"
$	Reason_6=="An access control string is specified in the node name."
$!______________
$	EXIT
$Do_Type:
$	PAGE
$	TYPE SYS$INPUT
			The VMS File Type

     The file type consists of 1 - 3 alpha numeric characters seperated
from the file name with a ".".  It is used to designate the file type.
For example .BAS files are BASIC source files, .FOR are fortran source
files and .EXE are executable programs to RUN.

Now lets see if you learned the rules
$!______________
$	Nmax==6
$	Question=="Is the above an example of a valid file name"
$	Test=="T"
$	Example_1==".DAT"
$	Answer_1=="Y"
$	Reason_1==".DAT is a valid VMS type."
$	Example_2==".FORT"
$	Answer_2=="N"
$	Reason_2=="The file type is longer than 3 characters."
$	Example_3=="123"
$	Answer_3=="Y"
$	Reason_3=="Numbers are legal file types."
$	Example_4==";LIS"
$	Answer_4=="N"
$	Reason_4=="A ; can not be used to seperate the file name from file type."
$	Example_5==".D"
$	Answer_5=="Y"
$	Reason_5=="File types can be shorter than 3 characters, but not longer."
$	Example_6=="FOR"
$	Answer_6=="N"
$	Reason_6=="When used as part of a file specifier, a . must preceed file type."
$!______________
$	EXIT
$Do_Version:
$	Page
$	TYPE SYS$INPUT
		    VAX File Version Numbers

     The first time a file is created it is assigned a version number of 1.
Each time the file is revised (edited), a new version of the file is created
with one higher version number.  The previous version number file is usually
retained unless deleted by the user.  File version numbers may range from
1 to 32767 decimal.  Version numbers must be seperated from file types
with a ";".


Now lets see if you learned the rules.
$!______________
$	Nmax==6
$	Question=="Is the above example a valid file version number"
$	Test=="T"
$	Example_1==";2"
$	Answer_1=="Y"
$	Reason_1=="The second version of the file, the previous version is ;1."
$	Example_2==";77777"
$	Answer_2=="N"
$	Reason_2=="The largest version number is 32767."
$	Example_3==";-1"
$	Answer_3=="Y"
$	Reason_3=="Negative version numbers are relative the the most recent one."
$	Example_4==".10"
$	Answer_4=="N"
$	Reason_4=="The . makes this a file type not a version number."
$	Example_5==";abc"
$	Answer_5=="N"
$	Reason_5=="Version numbers must be decimal numbers."
$	Example_6==";1600"
$	Answer_6=="Y"
$	Reason_6=="A huge version number, but legal."
$!______________
$	EXIT
$Final_Exam:
$	PAGE
$	TYPE SYS$INPUT

			The Final Exam

	If you have taken the previous modules, you have seen examples of
     the various components of a file specifier.  Before seeing if you can
     recognize a good from a bad file specifier, here is your opportunity
     to enter a file specifier and see if the system likes it.  When you
     are ready to go on to the final test, just type RETURN.  File specifiers
     will not be accepted unless specified directories exist on the system.
$Ask:
$	READ/PROMPT="''Erasel12'Input a file specifier (RETURN ->Continue): " -
	SYS$COMMAND RECORD
$	WRITE SYS$OUTPUT "''ERASEL20'"
$	IF Record .EQS. "" THEN GOTO Ask_2
$	tmp=F$PARSE(Record,"SYS$SYSDEVICE:",,"DEVICE")
$	IF Tmp .EQS. "" THEN GOTO  Bad_Specifier
$	IF .NOT. F$GETDVI(TMP,"EXISTS") THEN GOTO NO_DEVICE
$	tmp1=f$parse(record,,,"VERSION")
$	ver=F$INTEGER(f$extract(1,F$LENGTH(TMP1)-1,TMP1))
$	IF VER .GT. 32767 THEN GOTO Bad_Version
$	WRITE SYS$OUTPUT -
	"''ERASEL20'Right.   ''Record' is a valid VMS file specifier."
$	GOTO Ask
$No_Device:
$	WRITE SYS$OUTPUT -
	"''ERASEL20'Wrong.  The specified device, ''Tmp', does not exist."
$	GOTO ASK
$Bad_Version:
$	WRITE SYS$OUTPUT -
	"''Erasel20'Wrong.  The version number for ''Record' is not valid."
$	GOTO ASK
$Bad_Specifier:
$	WRITE SYS$OUTPUT -
	"''EraseL20'Wrong.   ''Record' is not a valid VMS file specifier."
$	GOTO ASK
$Ask_2:
$	PAGE
$	TYPE SYS$INPUT
     As you learned earlier, the standard VAX/VMS file specifier looks 
like

  Node_Name[1m::[0mDevice_Name[1m:[0m[1m[[0mDirectory[1m][0mFile_Name [1m.[0mFile_Type[1m;[0mVersion

Now lets see if you learned the rules
$!______________
$	Nmax==9
$	Question=="Is the above example a valid file specifier"
$	Test=="T"
$	Example_1=="FUSION:DRA0:[DOWNWARD.RUNOFF]FOO.RNO;4"
$	Answer_1=="N"
$	Reason_1=="Node names must be seperated with a :: from the device name."
$	Example_2=="DRA0:[DOWNWARD.RUNOFF]FOO.RNO.1"
$	Answer_2=="N"
$	Reason_2=="Version numbers must be separated with a ; from the file type."
$	Example_3=="FUSION::DRA0:[DOWNWARD.DEANZA.TASKS]TAKPIX.EXE"
$	Answer_3=="Y"
$	Reason_3=="All required rules are observed."
$	Example_4=="DMS34::DMA1:[DOWNWARD.DEANZA.SUBROUTINE.MACRO]TMP.MAR"
$	Answer_4=="N"
$	Reason_4=="The subdirectory name SUBROUTINE exceeds 9 characters."
$	Example_5=="DR:FOOBAR.DAT;32767"
$	Answer_5=="N"
$	Reason_5=="The device name must include a Controler index and unit number."
$	Example_6=="DRA0:DOWNWARD.PICTURE]IMAGE.EXE"
$	Answer_6=="N"
$	Reason_6=="The [ is missing in the directory specifier."
$	Example_7=="FUSION::[SYSTEM..CMDFIL]TERM.COM;0"
$	Answer_7=="N"
$	Reason_7=="The .. in the directory name is illegal."
$	Example_8=="[VAVRA.ADMIN]MEMO;tmp.0"
$	Answer_8=="N"
$	Reason_8=="The ; and the . are interchanged."
$	Example_9=="FUSION::[SYSTEM...]FOO.COM"
$	Answer_9=="Y"
$	Reason_9=="FOO.COM will be searched for starting in [SYSTEM] and working down."
$	EXIT
$Do_Introduction:
$	Page
$	Type SYS$INPUT
		  Introduction to the VMS File Specifier

     The file is the basic unit of storage for VAX/VMS.  All user information
is stored in files, usually on tapes or disks.  In order to retrieve a file
from storage, or create and store a new one, you must be able to identify
the file to the system.

     The VAX/VMS file specifier is used to name a file on a disk or tape in
such a way that it can be uniquely identified for use by the system and
users.  It is composed of a number of distinct parts.  The general form
of the file specifier is

  [1mNode_Name[0m :: [1mDevice_Name[0m : [[1mDirectory[0m] [1mFile_Name[0m . [1mFile_Type[0m ; [1mVersion[0m

The spaces in the above example are for clarity only and should not be present.
Any or all of the file specifier may be used.  In general, all that is needed
to reference a file on a users account is to specify the File_Name and the
File_Type.

			File_Name.File_Type

$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT
  Node_Name [1m::[0m  Device_Name [1m:[0m  [1m[[0mDirectory[1m][0m  File_Name [1m.[0m  File_Type [1m;[0m  Version

Several rules should be noted about the general file specifier.

 1) The   Node_Name    must be separated from   Device_Name   by a   ::
 2) The   Device_Name  must be separated from   Directory     by a   :
 3) The   Directory    must be enclosed in  [ ]
 4) The   File_Name    must be separated from   File_Type     by a   .
 5) The   File_Type    must be separated from   File_Version  by a   ;
 6) Only the letters A-Z and the numbers 0-9 may be in a legal file specifier.

Now lets see if you learned the rules
$!______________
$	Nmax==8
$	Question=="Is the above example a valid file specifier"
$	Test=="T"
$	Example_1=="Dev:Myfile.Typ;Version"
$	Answer_1=="Y"
$	Reason_1=="Device, name, type and version all had proper seperators."
$	Example_2=="Dev:Directory]Myfile.Typ;Version"
$	Answer_2=="N"
$	Reason_2=="The Directory was not preceeded with a [."
$	Example_3=="Dev:[Directory]MyfileTyp;Version"
$	Answer_3=="N"
$	Reason_3=="The file name and file type must be seperated with a ."
$	Example_4=="Dev:[Directory]Myfile;Typ;Version"
$	Answer_4=="N"
$	Reason_4=="The file name and file type may not be seperated with a ;."
$	Example_5=="Dev:[Directory]Myfile.Typ.Version"
$	Answer_5=="N"
$	Reason_5=="The file type and file version may not be seperated with a ."
$	Example_6=="Myfile.Typ"
$	Answer_6=="Y"
$	Reason_6=="Device, directory, and version need not be specified."
$	Example_7=="Node:Dev:[Directory]Myfile.Typ"
$	Answer_7=="N"
$	Reason_7=="The Node must be seperated from device with ::."
$	Example_8=="[Directory]Myfile.Typ"
$	Answer_8=="Y"
$	Reason_8=="The directory name is correctly enclosed in [ ]."
$!______________
$	EXIT
