$	IF P1 .NES. "" THEN GOTO DO_SUBROUTINE
$	PAGE
$	WRITE SYS$OUTPUT "KMSCAI -- No subroutine specified
$	WAIT 00:00:03
$	EXIT
$Do_Subroutine:
$	GOTO 'P1'			!
$	EXIT
$!
$Menu:
$	PAGE
$	TYPE SYS$INPUT
   #4[7m                               [0m
   #3[7m  [0m The VAX/VMS PURGE Command [0;7m  [0m
   #4[7m  [0m The VAX/VMS PURGE Command [0;7m  [0m
   #3[7m                               [0m

			Type ^Y to Exit at any time
You may choose:

		[1mI[0mntro      -  The PURGE Command
		[1mQ[0mualifiers -  The PURGE qualifiers
		[1mF[0minal      -  Final exam
		[1mE[0mxit       -  Exit this menu

$		EXIT
$Select:
$	Test:=="F"
$	Result:=="OK"
$	ZTmp=P2
$	ZTMP1=P3
$	IF ZTmp   .EQS. "E"  THEN Result:=="DONE"
$	IF ZTmp   .EQS. "E"  THEN EXIT
$	IF ZTmp   .EQS. "I"  THEN GOTO Do_Introduction
$	IF ZTmp   .EQS. "Q"  THEN GOTO Do_Qualifiers
$	IF Ztmp   .EQS. "F"  THEN GOTO Final_Exam
$	Result:=="BAD"
$	EXIT

$!______________
$	EXIT
$Final_Exam:
$	PAGE
$	TYPE SYS$INPUT

			The Final Exam



Now lets see if you remember how to use the PURGE command.
Will the following PURGE command
$!______________
$	Nmax==6
$	Test=="T"
$	Question==""
$	Question_1=="Purge all but the most recent version of FOOBAR.FOO"
$	Example_1=="PUR FOOBAR.FOO;11"
$	Answer_1=="N"
$	Reason_1=="Explicit version numbers are not allowed"
$	Question_2=="Prompt for files to purge"
$	Example_2=="PURGE"
$	Answer_2=="N"
$	Reason_2=="PURge without a file specifier, purges all files in your directory"
$	Question_3=="Purge all files with the prefix FOO"
$	Example_3=="PUR FOO*.*"
$	Answer_3=="Y"
$	Reason_3=="Wild cards are allowed in file specifiers"
$	Question_4=="Log deleted files to a file"
$	Example_4=="PUR/LOG=LOGFILE.TXT *.*"
$	Answer_4=="N"
$	Reason_4=="Purged files are listed to the current SYS$OUTPUT"
$	Question_5=="Recover a purged file"
$	Example_5=="PUR/RECOVER FOO.TXT"
$	Answer_5=="N"
$	Reason_5=="Once a file is deleted is is gone for good."
$	Question_6=="Purge files across the network"
$	Example_6=="PUR FUSION::[7,250]VECTOR.TXT"
$	Answer_6=="N"
$	Reason_6=="To purge files on a remote node requires an account and password string"
$	EXIT
$Do_Introduction:
$	Test=="F"
$	Page
$	Type SYS$INPUT



		  Introduction to the VMS PURge Command

     Every time you edit a file, compile a program, or link a task, a new
output file with a version number one higher than the previous version number
is created.  This creation of new files will continue untill either all 
available disk space is used up, or VMS disk accounting refuses to let you
use more disk space.  So that you have adequate available disk space to do 
your work, it is important to periodically remove old, obsolete, and 
unneeded files from your directory.

     The VMS PURge command is used to delete obsolete versions of files from
your directory.  The command may be abbreviated as "PUR".  Once a file is
Purged from your directory, it is gone for good.  However, the purge command
will never delete the most recent version of a file.  If your most recent
versions are valid, using the PURge command rather than the DELete command
protects these files against accidental deletion.



$	INQUIRE/NOPUN TMP "''EraseL23'Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT



     The PURge command has the following syntax:

	$ PUR/qualif1..../qualifN filspec1,filespec2.....,filespecN

where the file specifiers can include wild cards (*) for directory, name,
type, or extension.  Qualifiers are used to produce a listing of purged
files and for setting the number of files to keep.  If more than one
file is specified, the file specifiers must be seperated with commas ","
or plus signs "+".  If no file specification is given all files in the
current default directory are purged.

     The PURge command does not provide file name or file type defaults to
use if the file name or type is omitted.  Version numbers are not allowed.  

$	INQUIRE/NOPUN TMP "''EraseL23'Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT
     Now let us observe the effects of using the  PURge command.
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	WRITE SYS$OUTPUT "[12;24r"		! Scroll bet lines 11-24
$	Return="Command_1
$	Text="You are warned if a file is not found"
$	Command="PUR PURXXXXX1.TXT"
$	GOTO Do_Command
$Command_1:
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	Command="PUR PURXXXXX1.TXT;1"
$	Text="Explicit version numbers are not allowed"
$	Return="Command_2"
$	GOTO Do_Command
$Command_2:
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	Command="DIR PURXXXXX1.TXT"
$	Text="Here we have many versions of the file PURXXXXX1.TXT"
$	Return="Command_3"
$	GOTO Do_Command
$Command_3:
$	Command="PUR PURXXXXX1.TXT"
$	Text="Delete all but the most recent version of the file"
$	Return="Command_4"
$	GOTO Do_Command
$Command_4:
$	Command="DIR PURXXXXX1.TXT"
$	Text="Only the most recent version of the file remains after purging"
$	Return="Command_5"
$	GOTO Do_Command
$Command_5:
$	Command="PUR PURXXXXX1.TXT PURXXXXX2.TXT"
$	Text="Multiple files must be seperated with commas or + signs"
$	Return="Command_6"
$	GOTO Do_Command
$Command_6:
$	DELETE PURXXXXX*.TXT;*
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	PAGE
$	TYPE SYS$INPUT



	Remember, once a file is purged, it is GONE FOR GOOD.  
$	Test="F"
$	INQUIRE/NOPUN TMP "''EraseL23'Press RETURN when ready"
$	EXIT
$Do_Qualifiers:
$	Test=="F"
$	PAGE
$	TYPE SYS$INPUT
                      PURGE Command Qualifiers

     Two qualifiers exist for the PURge command, /KEEP and /LOG (/NOLOG).
The /KEEP qualifier controls how many versions of a file to retain.  By
default, it it is not specified, the PURge command retains ONLY the most
recent version of a file.  However, if /KEEP=n is used as a qualifier to
the PURge command, the "n" most recent versions of a file will be kept.

     By default, when files are deleted with the PURge command, no notification
is given as to which files have been purged.  If you wish to see which 
files have been deleted, use the /LOG qualifier.  The /LOG qualifier
will cause the file specifications of each file to be displayed as the
files are deleted.  By default, the PURge command assumes /NOLOG.

$	INQUIRE/NOPUN TMP "''EraseL23'Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT
     Now let us observe the effects of PURge qualifiers
$	ON CONTROL_Y THEN GOTO Reset_Terminal	!
$	WRITE SYS$OUTPUT "[12;24r"		! Scroll bet lines 11-24
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	Command="PURGE/LOG PURXXXXX1.TXT"
$	Text="Display all files purged to SYS$OUTPUT"
$	Return="QUAL_1"
$	GOTO Do_Command
$Qual_1:
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	CREATE PURXXXXX1.TXT
$	Command="PUR/KEEP=3 PURXXXXX1.TXT"
$	Text="Keep the most recent three versions of a file"
$	Return="QUAL_2"
$	GOTO Do_Command
$Qual_2:
$	Command="PUR PURXXXXX1.TXT"
$	Text="Purge all but the most recent version"
$	Return="QUAL_3"
$	GOTO Do_Command
$Qual_3:
$	DELETE PURXXXXX1.TXT;*
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	EXIT					!
$!
$Reset_Terminal:
$	WRITE SYS$OUTPUT "[1;24r"	! reset scrolling region
$	WRITE SYS$OUTPUT "[?4l"	! Back to jump scroll
$	EXIT


$Do_command:
$	WRITE SYS$OUTPUT "''EraseL05'''Text'"
$	WRITE SYS$OUTPUT -
"''Erasel07'Execute the command:  ''Bold'''Command'''No_Bold'"
$	WRITE SYS$OUTPUT -
"''EraseL11'			===================="
$	WRITE SYS$OUTPUT "''EraseL12'[J[?4h"
$	WRITE SYS$OUTPUT "''EraseL12'$ ''Command'"
$	ON ERROR THEN CONTINUE
$	'Command'
$	INQUIRE/NOPUN TMP "''EraseL23'Press RETURN when ready"
$	WRITE SYS$OUTPUT "''EraseL23'[?4l"
$	GOTO 'Return'
