$	IF P1 .NES. "" THEN GOTO DO_SUBROUTINE
$	PAGE
$	WRITE SYS$OUTPUT "KMSCAI -- No subroutine specified
$	WAIT 00:00:03
$	EXIT
$Do_Subroutine:
$	GOTO 'P1'			!
$	EXIT
$!
$Menu:
$	PAGE
$	TYPE SYS$INPUT
 #4[7m                                     [0m
 #3[7m  [0m Document Formatting with RUNOFF [0;7m  [0m
 #4[7m  [0m Document Formatting with RUNOFF [0;7m  [0m
 #3[7m                                     [0m

			Type ^Y to Exit at any time
You may choose:

		[1mI[0mntro      -  Introduction to RUNOFF
		[1mB[0masic      -  Basic Formatting commands
		[1mQ[0mualifiers -  RUNOFF Command qualifiers
		[1mE[0mxit       -  Exit this menu

$		EXIT
$Select:
$	Test:=="F"
$	Result:=="OK"
$	ZTmp=P2
$	ZTMP1=P3
$	IF ZTmp   .EQS. "E"  THEN Result:=="DONE"
$	IF ZTmp   .EQS. "E"  THEN EXIT
$	IF ZTmp   .EQS. "I"  THEN GOTO Do_Introduction
$	IF Ztmp   .EQS. "B"  THEN GOTO Do_Basic
$	IF ZTmp   .EQS. "Q"  THEN GOTO Do_Qualifiers
$	IF Ztmp   .EQS. "F"  THEN GOTO Final_Exam
$	Result:=="BAD"
$	EXIT

$!______________
$	EXIT
$Final_Exam:
$	PAGE
$	TYPE SYS$INPUT

			The Final Exam

			NOT AVAILABLE YET
$EXIT
Now lets see if you remember how to use the DELETE command.
Will the following delete command
$!______________
$	Nmax==6
$	Test=="T"
$	Question==""
$	Question_1=="Delete files modified after 1-Jan-1983"
$	Example_1=="DEL /SINCE=1-JAN-1982 FOO.TXT;*"
$	Answer_1=="N"
$	Reason_1=="To DELETE modified files must also include /MODIFIED"
$	Question_2=="DELETE all text files on a directory"
$	Example_2=="DEL *.TXT"
$	Answer_2=="N"
$	Reason_2=="An explicit version number is always required."
$	Question_3=="DELETE all Fortran source files created today"
$	Example_3=="DEL/CREATED/SINCE=TODAY *.FOR;*"
$	Answer_3=="Y"
$	Reason_3=="TODAY is also a valid date string"
$	Question_4=="Prompt for each file to delete"
$	Example_4=="DEL/CONFIRM *.txt;*"
$	Answer_4=="Y"
$	Reason_4=="VMS will prompt to confirm the deletion of each file"
$	Question_5=="Recover a deleted file"
$	Example_5=="DEL/RECOVER *.TXT;*"
$	Answer_5=="N"
$	Reason_5=="Once a file is deleted is is gone for good."
$	Question_6=="Delete a file across the network"
$	Example_6=="DEL FUSION::[7,250]VECTOR.TXT;*"
$	Answer_6=="N"
$	Reason_6=="To delete files on a remote node requires an account and password string"
$	EXIT
$Do_Introduction:
$	Test=="F"
$	Page
$	Type SYS$INPUT
            Introduction to Using RUNOFF to Format Documents

     The VMS RUNOFF command is used to take the input from a text file 
created with an editor and output a nicely formatted document.  Many word
processors operate in a "What you see is what you get" mode.  At this time
we do not have such a word processor for the VAX.  However, RUNOFF is capable
of taking ragged, totally unformatted input created from a editor, and turn
out a professionally appearing document.  Moreover, RUNOFF allows greater
control over the output format of a document than is probably possible with
any word processor.

     To format a document using RUNOFF, you insert document format control
commands within the text file you are creating.  All RUNOFF document format
control commands consist of a period (".") in column 1 followed by a command
name.  Any line not preceeded by a period (".") is considered to be text which
RUNOFF will format.
 
 
 
 
$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	PAGE
$	Type SYS$INPUT
     RUNOFF's inherent capabilities allow it to tackle both large and small
formatting jobs ranging from a single page memo, to an entire book with
chapters and indexing of key words, footnoting, and reserving space for 
figures.  Because of the breadth of RUNOFF's capabilities, there are a great
many possible commands.  However, for general use, a small number of commands
should suffice.

     Users desiring to utilize all of RUNOFF's capabilities would do well
to get a copy of the RUNOFF user's manual.  Other serious users should
obtain a mini reference guide.  For users with very basic needs, however, 
this CAI course should provide sufficient information.

     Users using the Vax Professional Workstation Word Processing facility
will find that RUNOFF commands are automatically inserted into document
files it creates.  By the end of this course, you should understand what
those commands mean, and be able to modify them to suit your needs.
 
 
 
 
$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	PAGE
$	Type SYS$INPUT
     Once format control commands are embedded within a text file, creating
a formatted document is easy using the VAX RUNOFF command.  The format of the
command is
		$ RUNOFF/qualifiers File_name

If no file type is specified, the type automatically defaults to .RNO.  If
no output qualifiers are specified, entering the command RUNOFF Filename
will result in a formatted document output to the file  Filename.MEM.
If you want to preview the file prior to creating a document file on disk,
you can direct RUNOFF's output to your terminal by including the
/OUTPUT=TT: qualifier.

     RUNOFF has a number of other qualifiers for special purpose use and these
are covered in a different section of this course.

 
 
 
 
 
$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	EXIT
$Do_qualifiers:
$	PAGE
$	TYPE SYS$INPUT
The format of the RUNOFF command is

		$ RUNOFF/qualifiers File_name

The most important qualifiers are:

	/BOLD=Number_of_Overstrikes		Default=1
	/OUTPUT=filespec			Default is Input_file.MEM
	/PAGES="start:end"

The Vax Professional Workstation ordinarily will handle the RUNOFF qualifiers.
About 28 additional qualifiers exist but these are unneeded except for
very heavy and serious use of RUNOFF.  In that event you should get, and
read the DSR (Digital Standard RUNOFF) manual.  Information on all the
various qualifiers can be obtained by typing HELP RUNOFF.




$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	EXIT
$Do_Basic:
$	Test=="F"
$	PAGE
$Do_Basic_1:
$	Basic_Return="Do_Basic"
$	TYPE SYS$INPUT
		RUNOFF Formatting Commands

You may choose:
		[1mI[0mntro       -  Indroduction to RUNOFF commands
		[1mF[0mill        -  Setting word fill and justification
		[1mLIS[0mT        -  Creating lists
		[1mLIT[0meral     -  Bypassing fill and justification
		[1mM[0margins     -  Setting document margins
		[1mP[0maragraphs  -  Setting paragraphs
		[1mS[0mpecial     -  Special RUNOFF characters
		[1mT[0mitle       -  Setting a document's title
		[1mE[0mxit        -  Exit this menu

$Basic_Select:
$	INQUIRE Z "''Erasel15'Choice"
$	Z1[0,1]:='Z'
$	Z2[0,2]:='Z'
$	Z3[0,3]:='Z'
$	IF Z1     .EQS. "E"   THEN EXIT
$	IF Z1     .EQS. "F"   THEN GOTO Basic_Fill
$	IF Z3     .EQS. "LIS" THEN GOTO Basic_List
$	IF Z3     .EQS. "LIT" THEN GOTO Basic_Literal
$	IF Z1     .EQS. "M"   THEN GOTO Basic_Margins
$	IF Z1     .EQS. "P"   THEN GOTO Basic_Paragraphs
$	IF Z1     .EQS. "S"   THEN GOTO Basic_Special
$	IF Z1     .EQS. "T"   THEN GOTO Basic_Title
$	IF Z1     .EQS. "I"   THEN GOTO Basic_Intro
$	WRITE SYS$OUTPUT "''EraseL22'KMSCAI -- ''Choice' is not an allowed qualifier"
$	GOTO Basic_SELECT
$Basic_Intro:
$	PAGE
$	TYPE SYS$INPUT
	A RUNOFF format control command must begin with a period (".") and 
start in column 1.  For example if your screen looks like:
)0
          lqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqk
          x.Right Margin 72                              x
          xText    ....     text     ....    text  ..... x
          x    .Right Margin 50                          x
          xText2   ....     text2    ....    text2 ....  x
          mqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqj

In this case the first ".Right Margin 72" is interpreted as a RUNOFF command 
but the second ".Right Margin 50" command is interpreted as text.  RUNOFF
format commands must preceed the text they are going to format.  
 
 
 
 
 
 
 	
$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	PAGE
$	TYPE SYS$INPUT
     By default RUNOFF will format text in such a way to try and justify text
against the right margin by inserting spaces between words.  This means that
RUNOFF will change spacing between words, and their location in the output
to make the text fit.  If explicit spaces are needed between words or letters
you can use the "#" to represent an explicit space which may not be moved,
expanded, or contracted.  If you need to use the "#" as part of text, you
can either preceed it by a "_" (the accept flag), disable recognition of
"#" as an explicit space character (.NOFLAGS SPACE), or enclose the text
in a litteral field.


     If output is set for Justification and Fill, the exact format of the text
input is generally not important, as RUNOFF will attempt to make the text
"pretty".  An exception to this is that text should begin in column 1.  If it
is necessary to have text which begins in columns other than the first column,
either change margins, use a LITERAL field, or disable justification and word 
fill. 
 
 
 
 
$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	PAGE
$	TYPE SYS$INPUT
An example of what the start of a document might look like is

          lqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqk
          x.Right Margin 30                              x
          x.Left Margin 5                                x
          x.AP                                           x
          x                                              x
          xThis sample paragraph is in                   x
          xragged format, but RUNOFF will justify and    x
          xfill the text to make it pretty.              x
          mqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqj

The output from RUNOFF might look like.

          lqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqk
          x                                              x
          x        This sample  paragraph is in ragged   x
          x   format, but RUNOFF will justify and fill   x
          x   the text to make it pretty.                x
          mqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqj
$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	PAGE
$	TYPE SYS$INPUT
     RUNOFF commands generally have both long and short forms.  For example
the command to set the right margin at column 72 can either be written as

	.RIGHT MARGIN 72       or       .RM 72

If RUNOFF encounters what it thinks should be a command but isn't, it will 
produce an error message.  For example, if the .RIGHT MARGIN command is 
spelled incorrectly as .RGIHT MARGIN 72, RUNOFF will issue the message

  %RUNOFF-W-ILC, Illegal command: ".RGIHT MARGIN 72"
	  on output page xx; on input line yy of page zz of file "file_name"

where "file_name" is the name of the file with the invalid command and the
values of "xx", "yy", and "zz" reflect where the error was found.


$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	GOTO Do_Basic
$Basic_Fill:
$	PAGE
$	TYPE SYS$INPUT
     By default FILL and JUSTIFY modes are set in RUNOFF.  To enable or 
disable these modes use the commands

   .F   or   .FILL		Enables fill mode.  Adds sords to each output
				line until the addition of one more word would
				cross the right margin.

   .NF  or   .NO FILL		Disables fill mode.  Ragged lines of text
				will not be merged to fill as much of each
				line as possible.

   .J   or   .JUSTIFY		Inserts enough additional space between words
				on a line so that the last word reaches the
				right margin.

   .NF  or   .NO JUSTIFY	Inserts no additional spaces.  Creates a 
				ragged right margin.




$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	PAGE
$	TYPE SYS$INPUT
	                       This is an example of
	                       ragged text that is input. We
	.NOFILL/.NOJUSTIFY     want
	                       to see the effect of using the
	                       RUNOFF .FILL/.NOFILL 
	                       and .JUSTIFY/.NOJUSTIFY commands on
	                       how the text will appear.

  	                       This is an example of ragged text
	 .FILL/.JUSTIFY        that is input.  We want to see the
                               effect of using the RUNOFF
	                       .FILL/.NOFILL and
	                       .JUSTIFY/.NOJUSTIFY commands on how
	                       the text will appear.

	                       This is an example of  ragged  text
	 .FILL/.JUSTIFY        that  is input.  We want to see the
	                       effect   of   using   the    RUNOFF
	                       .FILL/.NOFILL                   and
	                       .JUSTIFY/.NOJUSTIFY commands on how
	                       the text will appear.
$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	GOTO Do_Basic
$Basic_List:
$	PAGE
$	TYPE SYS$INPUT
	One often wants to create formatted, numbered lists.  RUNOFF allows
this to be done easliy with the commands .LIST,.LIST ELEMENT, and .END LIST.

.LS         or   .LIST			Start a List Block
.LE;text    or   .LIST ELEMENT;text	Set a new element in the list
.ELS        or   .END LIST              End a List Block

The .LE command is followed by a ";" which is followed by the text which is
supposed to be part of the list.  This text may continue for one or more lines.
Each list element will be sequentially numbered and the text will be indented.
By default the numbers are numeric, and a "." follows each number.









$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	PAGE
$	TYPE SYS$INPUT
     Lists can be contained within lists by starting a new list block.

               lqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqk
               x.text...text...text...text                    x
               x.LIST                                         x
               x.LE;List 1 item 1                             x
               x.LIST                                         x
               x.LE;List 2 item 1                             x
               x.le;List 2 item 2                             x
               x.END LIST                                     x
               x.LE;List 1 item                               x
               x.END LIST                                     x
               mqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqj
Will produce
               lqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqk
               xtext...text...text...text                     x
               x1. List 1 item 1                              x
               x   1. List 2 item 1                           x
               x   2. List 2 item 2                           x
               x2. List 1 item 2                              x
               mqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqj
$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	PAGE
$	TYPE SYS$INPUT
     The format of a list can be changed by following the .LIST command
with a .DISPLAY ELEMENT command

	.DISPLAY ELEMENT list-format-code   or   .DLE  list-format-code

where  list-format-code  is one of

	List-format-code     	Effect
	      D			Decimal Numbers
	      O			Octal Numbers
	      H			Hexadecimal Numbers
	      RU		Roman Uppercase numerals
	      RL		Roman Lowercase numerals
	      RM		Roman Mixedcase numerals
	      LU		Letters, Uppercase
	      LL		Letters, Mixedcase
	      LM		Letters, Mixedcase


$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	PAGE
$	TYPE SYS$INPUT
     The format of the list can further be changed with the .DSIPLAY ELEMENT
because the element number can have both a preceeding and following single
character specified (instead of a single trailing ".").  In this event the
format of the command is

	.DISPLAY ELEMENT ["l",]list-format-code[,"r"]  

where the items enclosed in brackets ("[]") are optional.  The preceeding
character if present is enclosed in "" and followed with a comma (",") and
the following character if present is preceeded with a comma (",") and 
enclosed in quotes.  For example

	.DISPLAY ELEMENT "(",LL,")"

would produce a list indexed with lower case letters enclosed in "()"
as seen in the next example




$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	PAGE
$	TYPE SYS$INPUT
               lqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqk
               xtext...text...text...text                     x
               x.LIST                                         x
               x.LE;List 1 item 1                             x
               x.LIST                                         x
               x.DLE "(",LL,")"                               x
               x.LE;List 2 item 1                             x
               x.le;List 2 item 2                             x
               x.END LIST                                     x
               x.LE;List 1 item                               x
               x.END LIST                                     x
               mqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqj
Will produce
               lqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqk
               xtext...text...text...text                     x
               x1. List 1 item 1                              x
               x   (a) List 2 item 1                          x
               x   (a) List 2 item 2                          x
               x2. List 1 item 2                              x
               mqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqj

$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	GOTO Do_Basic
$Basic_Literal:
$	PAGE
$	TYPE SYS$INPUT
     There are times one wishes to place text on a page and not have
the positions of the words in that text moved by JUSTIFY or FILL mode
or margin settings.  To accomplish this use Litteral fields.  The
commands to do this are

	.LITERAL		Start a literal block.  No RUNOFF commands
				except .END LITERAL are recognized.
	.END LITERAL		Stop a literal block.

For example the words MEMO:, TO:, FROM:, SUBJECT: contained in

		.LITERAL
		MEMO:
		TO:
		FROM:
		SUBJECT:
		.END LITERAL

would wind up in the same line if they were not enclosed in a literal field.

$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	GOTO Do_Basic
$Basic_Margins:
$	PAGE
$	TYPE SYS$INPUT
	RUNOFF is just like a typewritter in that you have to set the margins
before using it.  Of course if you don't set the margins, RUNOFF will assume
default values which may or may not be what you want.  Both the right and
left margins are setable to occur at any column.  However, the right margin
must be greater than the left margin.  You can also set the size of paper
to be output to (ie the number of lines printed on each page). 

  .LM mmm     or    .LEFT MARGIN mmm        Set left margin to column "mmm"
                                            (Default column 0)

  .RM nnn     or    .RIGHT MARGIN nnn       Set right margin to column "nnn"
                                            (Default set to page width)

  .PAGE SIZE length, width                  Set the length and width of the
                                            paper. 
                                            (Default 58 lines, 60 columns)




$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	PAGE
$	TYPE SYS$INPUT
     The settings for the margins can be changed anywhere within the body
of the text.  Each command will affect all subsequent text.  Specifying
that a page has a given length does not necessarily mean that text you
enter goes there.  By default, RUNOFF will number pages at the top and
insert a title if specified.  Pages numbers can also be selected for
printing at the bottom of a page.  At the end of each page, a new page 
will be correctly positioned on the printer.

     If you do not like the way RUNOFF decides when to start a new page,
you can force a new page to start by inserting a 

	.PAGE

at the point where you want the new page to occur.






$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	GOTO Do_Basic
$Basic_Paragraphs:
$	PAGE
$	TYPE SYS$INPUT
	RUNOFF is most conveniently used if you let it handle the formatting
of paragraphs.  This is called "auto-paragraph" mode.  The commands

  .AP   or   .AUTOPARAGRAPH		Turns on auto-paragraph mode
  .NAP  or   .NO AUTOPARAGRAPH		Turns off auto-paragraph mode

If autoparagraph mode is set, a paragraph will be started each time a blank
line is left in the body of a text.  When RUNOFF encounters a blank line,
it skips a line, and indents the text to start a new paragraph.  If you wish
to insert blank lines without starting a new paragraph, either use the
.LITERAL/.END LITERAL commands to enclose a field of text RUNOFF will not
format, or use the command

  .B nn   or    .BLANK nn		To insert "nn" blank lines of text.






$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	GOTO Do_Basic
$Basic_Special:
$	PAGE
$	TYPE SYS$INPUT
      RUNOFF has a number of special characters whose action may be controlled
with "FLAG" commands.  A "flag" is a signal, which if set tells RUNOFF to take
some special action if it encounters the character.  To use the special 
character, the flag recognition must be first turned on and then the flag
enabled.

ACCEPT				Take the next character following a "_"
				as a literal.  The "_" is the default 
				ACCEPT flag character.
	.FLAGS ACCEPT
	.ENABLE ACCEPT

BOLD				BOLDS the next character following a "*".
				Also requires the /BOLD:n qualifier on the
				RUNOFF command line.
	.FLAGS BOLD             *  -- Bold next character
	.ENABLE BOLDING         ^* -- Bold all following text
                                \* -- Turn off bolding of all text

$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	PAGE
$	TYPE SYS$INPUT
UNDERLINE			Allows text to be underlined using the & flag.
	.FLAGS UNDERLINE	&   -- Underline next character.
	.ENABLE UNDERLINING     ^&  __ Underline all following text.
				\&  -- Turn off underlining of all text.





$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	GOTO Do_Basic
$Basic_Title:
$	PAGE
$	TYPE SYS$INPUT
     A title can be inserted on every page of text using the .TITLE command.
Its format is;

	.TITLE  title

A subtitle can be set with the .SUBTITLE command.

	.SUBTITLE sub-title

A title on a cover page can be set with the .FIRST TITLE command.  The 
.FIRST TITLE command must preceed any text.  This command will output the
page number, title and subtitle on the first page of the document.

	.FIRST TITLE first-title



$	INQUIRE/NOPUN TMP "Press [1mRETURN[0m when ready"
$	GOTO Do_Basic


$!
$Reset_Terminal:
$	WRITE SYS$OUTPUT "[1;24r"	! reset scrolling region
$	WRITE SYS$OUTPUT "[?4l"	! Back to jump scroll
$	EXIT


$Do_command:
$	WRITE SYS$OUTPUT "''EraseL05'''Text'"
$	WRITE SYS$OUTPUT -
"''Erasel07'Execute the command:  ''Bold'''Command'''No_Bold'"
$	WRITE SYS$OUTPUT -
"''EraseL11'			===================="
$	WRITE SYS$OUTPUT "''EraseL12'[J[?4h"
$	WRITE SYS$OUTPUT "''EraseL12'$ ''Command'"
$	ON ERROR THEN CONTINUE
$	'Command'
$	INQUIRE/NOPUN TMP "''EraseL23'Press RETURN when ready"
$	WRITE SYS$OUTPUT "''EraseL23'[?4l"
$	GOTO 'Return'
