$	IF P1 .NES. "" THEN GOTO DO_SUBROUTINE
$	PAGE
$	WRITE SYS$OUTPUT "KMSCAI -- No subroutine specified
$	WAIT 00:00:03
$	EXIT
$Do_Subroutine:
$	GOTO 'P1'			!
$	EXIT
$!
$Menu:
$	PAGE
$	TYPE SYS$INPUT
     #4[7m                              [0m
     #3[7m  [0m The VAX/VMS TYPE Command [0;7m  [0m
     #4[7m  [0m The VAX/VMS TYPE Command [0;7m  [0m
     #3[7m                              [0m

			Type ^Y to Exit at any time
You may choose:

		[1mI[0mntro      -  Indroduction to the TYPE Command
		[1mF[0minal      -  Final exam
		[1mE[0mxit       -  Exit this menu

$		EXIT
$Select:
$	Test:=="F"
$	Result:=="OK"
$	ZTmp=P2
$	ZTMP1=P3
$	IF ZTmp   .EQS. "E"  THEN Result:=="DONE"
$	IF ZTmp   .EQS. "E"  THEN EXIT
$	IF ZTmp   .EQS. "I"  THEN GOTO Do_Introduction
$	IF Ztmp   .EQS. "F"  THEN GOTO Final_Exam
$	Result:=="BAD"
$	EXIT

$!______________
$	EXIT
$Final_Exam:
$	PAGE
$	TYPE SYS$INPUT

			The Final Exam



Now lets see if you remember what the qualifiers do.
Will the following TYPE command
$!______________
$	Nmax==6
$	Test=="T"
$	Question==""
$	Question_1=="Display all text files at your terminal"
$	Example_1=="TYPE *.TXT"
$	Answer_1=="Y"
$	Reason_1=="TYPE accepts wild cards as part of file specifiers"
$	Question_2=="Display FILE1.TXT and FILE2.TXT at your terminal"
$	Example_2=="T FILE1.TXT FILE2.TXT
$	Answer_2=="N"
$	Reason_2=="Multiple file names must be seperated with commas, not spaces."
$	Question_3=="Output a text file to the line printer TTA1:"
$	Example_3=="TYPE/OUTPUT=TTA1: MYFILE.TXT"
$	Answer_3=="N"
$	Reason_3=="VMS only allows you to output to allocated terminals."
$	Question_4=="Type the first file to the terminal, the second to file"
$	Example_4=="TYPE FILE1.TXT,FILE2.TXT/OUTPUT=FILE3.TXT"
$	Answer_4=="Y"
$	Reason_4=="The /OUTPUT qualifier may also be attached to a file name."
$	Question_5=="Type all text files in a given directory."
$	Example_5=="TYPE *.*;*"
$	Answer_5=="N"
$	Reason_5=="Wildcard file type will allow non-text files to be displayed."
$	Question_6=="Output text from within a command file to another file"
$	Example_6=="TYPE/OUTPUT=FOO.TXT SYS$INPUT
$	Answer_6=="Y"
$	Reason_6=="All text until the next line starting with a "$" goes to FOO.TXT""
$	EXIT
$Do_Introduction:
$	Test=="F"
$	Page
$	Type SYS$INPUT
		       Using the VMS TYPE Command

     The VMS TYPE command is used to display the contents of a file or group
of files to the current output device.  The files should be ASCII text files.
Typing a binary file (object module, executable image or the like) to one's
terminal produces very unsatisfactory results.   The TYPE command can be
abreviated with the single letter "T".  The command (normally abreviated as
TYP) has the following syntax: 

	$ TYPE filspec1[,filespec2.....,filespecN]

where the file specifiers can include wild cards (*) for directory, name, type,
or extension.  



$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	Type SYS$INPUT

     A single qualifier is allowed to direct the output of the TYPE command to
an output device other than one's current terminal.  This qualifier is

		/OUTPUT=file-spec.  

The qualifier may be placed immediately after TYPE or after any given file
specifier.  The /OUTPUT qualifier directs the output to go to the file
specifier specified by "file-spec".  This may be a terminal or any other valid
VMS file specifier.  For example, 

	$ TYPE /OUTPUT=TTn: FOO.COM 

displays FOO.COM on terminal TTn:.  Remember, however, VMS will not allow
you to output to physical devices which you do not own.  To own a device you
must allocate it, and for terminals this requires special privileges.

     If you enter the command TYPE with no files, VMS will prompt you for
the file specifier.  Enter a file specifier, or type Control-Z or Control-Y
to cancel the request.



$	INQUIRE/NOPUN TMP "Press RETURN when ready"
$	PAGE
$	TYPE SYS$INPUT
     Now let us observe the effects of a TYPE command.
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	WRITE SYS$OUTPUT "[12;24r"		! Scroll bet lines 11-24
$	Command="T FOO123456.XYZ"
$	Text="VMS produces a warning message if the file can not be found."
$	Return="Command_2"
$	GOTO Do_Command
$Command_2:
$	TYPE/OUTPUT=TYPEXXXX1.TXT SYS$INPUT

	This is a short text file containing many lines which you can practice
using control-O (^O) on.  Control-O is simple to use.  Type it and further
output is disgarded.  Type it again and output resumes to your terminal.
You can use the VT100 NOSCROLL key to HALT/RESUME output to your terminal.
On Non-VT100 terminals use control-S to halt output and control-Q to resume
output.
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*        Type ^O, Please           *            Type ^O, Please          *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
**************************************************************************
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*        Type ^O, Please           *            Type ^O, Please          *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
**************************************************************************
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*        Type ^O, Please           *            Type ^O, Please          *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
**************************************************************************
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*        Type ^O, Please           *            Type ^O, Please          *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
**************************************************************************
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*        Type ^O, Please           *            Type ^O, Please          *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
**************************************************************************
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*        Type ^O, Please           *            Type ^O, Please          *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
**************************************************************************
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*        Type ^O, Please           *            Type ^O, Please          *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
**************************************************************************
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*        Type ^O, Please           *            Type ^O, Please          *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
*                                  *                                     *
**************************************************************************
$	Command="T TYPEXXXX1.TXT"
$	Text="Type ^O (control-O) to discard output to terminal."
$	Return="Command_3"
$	GOTO Do_Command
$Command_3:
$	Command="TYPE TYPEXXXX1.TXT"
$	Text="Press NOSCROLL to halt output. NOSCROLL again to restart output."
$	Return="Command_4"
$	GOTO Do_Command
$Command_4:
$	DELETE TYPEXXXX1.TXT;*
$	Command="TYP /OUTPUT=TYP123456.COM TYPE.SUB"
$	Text="Capture the output from the text file in another text file."
$	Return="Command_5"
$	GOTO Do_Command
$Command_5:
$	DELETE TYP123456.COM;*
$	Command="TYP /OUTPUT=NL: TYPE.SUB"
$	Text="Output the data to a device other than your terminal."
$	Return="Command_6"
$	GOTO Do_Command
$Command_6:
$	WRITE SYS$OUTPUT "[1;24r"		! reset scrolling region
$	PAGE
$	INQUIRE/NOPUN TMP "''EraseL23'Press RETURN when ready"
$	EXIT
$!______________
$	EXIT

$Do_command:
$	WRITE SYS$OUTPUT "''EraseL05'''Text'"
$	WRITE SYS$OUTPUT -
"''Erasel07'Execute the command:  ''Bold'''Command'''No_Bold'"
$	WRITE SYS$OUTPUT -
"''EraseL11'			===================="
$	WRITE SYS$OUTPUT "''EraseL12'[J[?4h"
$	WRITE SYS$OUTPUT "''EraseL12'$ ''Command'"
$	ON ERROR THEN CONTINUE
$	'Command'
$	INQUIRE/NOPUN TMP "''EraseL23'Press RETURN when ready"
$	WRITE SYS$OUTPUT "''EraseL23'[?4l"
$	GOTO 'Return'
