	SUBROUTINE Display_Entries(Iterminal,Cfile,
     -				   Csearch_string,Iform_DCL)	!
	CHARACTER*1		Cans,Cesc,Cnull,Cbell	!
	CHARACTER*4		Cbold,Cnorm		!
	CHARACTER*20		Cprogram		! Program name
	CHARACTER*20		Cout_File		!
	CHARACTER*50		Cform_name

	CHARACTER*80		Csearch_String		!
	CHARACTER*132		Ctmp			!
	CHARACTER*132		Ctmp2			!
	CHARACTER*132		Cform
	Character*512		Record			!
	CHARACTER*512		Tmp_Record		!
	CHARACTER*(*)		Cfile			! File name
	LOGICAL*1		Lall_Flag		! True if must sort
	LOGICAL*1		Lonce	      /.FALSE./ ! True if one shot
	LOGICAL*1		Lprint_Flag   /.FALSE./ ! True if -> printer
	INTEGER*4		Record_Length		!
	INTEGER*4		Iterminal		!
	INTEGER*4		Number_of_Forms
	INTEGER*4		Number_of_Items
	INTEGER*4		Iorder_of_Items
	COMMON	/Record_buf/	Record_Length,Record	!
	COMMON	/Constants/	Cesc,Cbell,Cnull,Cbold,Cnorm
	COMMON	/Screen/	Iline,Itop_Line,Ibot_Line
	COMMON	/Program/	Cprogram		!
	COMMON	/Display/	Iform

	PARAMETER		(Isize=20)

	COMMON	/FORMS/		Number_of_Forms,
     -				Number_of_Items(Isize),
     -				Iorder_of_Items(Isize,Isize),
     -				Cform(Isize),
     -				Cform_name(Isize)


	LUN_File = 1					!
	LUN_File_Write=2				!
	Record= ' '					! Fill with spaces
	CALL String_Length(Csearch_String,Nchar)	!
	IF(Iform_DCL.NE.0	.AND.			! If in command mode
     -	   Nchar.GE.1)				THEN	!
	   Itop_Line=1					!
	   Ibot_Line=24					!
	   Lonce=.TRUE.					! One pass only
	   Iform=Iform_DCL				!
	   Ctmp=Csearch_string(1:Nchar)			!
	   Lall_Flag=.FALSE.				!
	   IF(Ctmp(1:1).EQ.'*') Lall_Flag=.TRUE.	!
	   GOTO 200					!
	END IF						!
	Itop_line=3					!
	Ibot_line=24					!
	CALL PAGE					! Erase screen
	CALL SCREEN('Display Entries',Iterminal,1,32,1)	! Title page
	IF(Iterminal.LT.96)	TYPE *,' '		!

5	IF(Number_of_Forms.GT.1)		THEN	!
	  CALL SCREEN('Available display forms:',Iterminal,3,1,1)	!
	  DO I=1,Number_of_Forms
	    CALL SCREEN(' ',Iterminal,4+I,1,0)		! Position cursor
	    CALL String_Length(Cform_Name(I),Ilen)	!
	    WRITE(*,10) I,Cform_Name(I)(1:Ilen)		!
10	    FORMAT('+',10x,I2,'.   ',A)			!
	  END DO					!
	  Iline=5+I					! needed in common
	  Ierase=0					!
15	  CALL SCREEN('Use Form #: ',Iterminal,5+I,1,Ierase)! Prompt for form
	  CALL Read_String(Ctmp,Nchar)			! Read value
	  IF(Nchar.EQ.0)			RETURN	! If <CR> on 1st entry
	  IF(Nchar.EQ.-1)			RETURN	! If ^Z input

C	  CALL CHECK_ESCAPE(Ctmp,Nchar,Iterminal,Helptxt,
C     -			^Z-return,
C     -			Backup_return,
C     -			Done_return,
C     -			Help/VPW_return)
	  IF(Nchar.EQ.-2)			THEN	! If escape seq
	    CALL Check_Escape(Ctmp,Nchar,Iterminal,	!
     -	  	            Cprogram(1:JJ)//' DISPLAY',	!
     -			*9999,				! ^z Return
     -			*5,				! Backup Return
     -			*9999,				! Done_return
     -			*18)				! Help/VPW return

	    RETURN
18	    Ierase=1					! Erase to Screen end
	    GOTO 15					!
	  END IF
	
	  READ(Ctmp(1:Nchar),20,ERR=5)IFORM		!
20	  FORMAT(I2)					!
	  IF(Iform.LT.1			.OR.		! Check to see it is
     -	     Iform.GT.Number_of_Forms)		THEN	!  within legal range
	    Ctmp='VPW_Display -- Non-existant form selected'//Cbell
	    CALL String_Length(Ctmp,Ilen)		!
	    CALL SCREEN(Ctmp(1:Ilen),Iterminal,24,1,4)	!
	    GOTO 15					!
	  END IF					!
	ELSE
	  Iform=1					! Always must be one
	END IF						!


	CALL String_Length(Cprogram,JJ)			!
	Iline=6+I					!
25	Lall_flag=.FALSE.				!
	Ctmp='Search for (* -> ALL): '			!
	CALL String_Length(Ctmp,Ilen)			!
	Ierase=1					!
30	CALL SCREEN(Ctmp(1:Ilen+1),Iterminal,Iline,1,Ierase)! Get string
	Ierase=4					! Erase EOL only
	CALL Read_String(Ctmp,Nchar)			! Read value
	IF(Nchar.EQ.0)				RETURN	! If <CR> on 1st entry
	IF(Nchar.EQ.-1)				RETURN	! If ^Z input

C	  CALL CHECK_ESCAPE(Ctmp,Nchar,Iterminal,Helptxt,
C     -			^Z-return,
C     -			Backup_return,
C     -			Done_return,
C     -			Help/VPW_return)
	IF(Nchar.EQ.-2)				THEN	! If escape seq
	  CALL Check_Escape(Ctmp,Nchar,Iterminal,	!
     -	  	            Cprogram(1:JJ)//' SEARCH_STRING',	!
     -			*9999,				! ^z Return
     -			*5,				! Backup Return
     -			*9999,				! Done_return
     -			*40)				! Help/VPW return

	  RETURN
40	  Ierase=1					! Erase to Screen end
	  GOTO 25					!
	END IF
	IF(Nchar    .GE.1	.AND. 			!
     -	   Ctmp(1:1).EQ.'*')	 Lall_Flag=.TRUE.	!
	Iline=Iline+1					!



100	Ctmp2='Output data to printer [Y/N]'		!
	CALL String_Length(Ctmp2,Ilen)			!
	Ierase=1					!
130	CALL SCREEN(Ctmp2(1:Ilen+1),Iterminal,Iline,1,Ierase)! Get string
	Ierase=4					! Erase EOL only
	CALL Read_String(Ctmp2,Nmbr)			! Read value
	IF(Nchar.EQ.-1)				RETURN	! If ^Z input

C	  CALL CHECK_ESCAPE(Ctmp,Nchar,Iterminal,Helptxt,
C     -			^Z-return,
C     -			Backup_return,
C     -			Done_return,
C     -			Help/VPW_return)
	IF(Nchar.EQ.-2)				THEN	! If escape seq
	  CALL Check_Escape(Ctmp2,Nmbr,Iterminal,	!
     -	  	            Cprogram(1:JJ)//' PRINT',	!
     -			*9999,				! ^z Return
     -			*25,				! Backup Return
     -			*9999,				! Done_return
     -			*140)				! Help/VPW return

	  RETURN
140	  Ierase=1					! Erase to Screen end
	  GOTO 100					!
	END IF
	IF(Ctmp2(1:1) .EQ. 'Y'	.OR.			!
     -	   Ctmp2(1:1) .EQ. 'y')			THEN	! If spool output
	   Lprint_Flag=.TRUE.				!
	   Cout_File='LP.LIS'				!
	   OPEN(Unit	   = LUN_File_Write,		!
     -		Name	   = Cout_File,			!
     -		Status	   = 'New',			!
     -		Form	   = 'Formatted',		!
     -		Recordsize = 512,			!
     -		CarriageControl = 'List',		!
     -		Dispose	   = 'Print/Delete',			!
     -		Err 	   = 9900)			!
	ELSE
	   OPEN(Unit	   = LUN_File_Write,		!
     -		Name	   = 'SYS$OUTPUT',		!
     -		Status	   = 'Unknown')			!

	END IF						!

200	OPEN(	Unit	   = LUN_File,			! Open up our data
     -		Name	   = Cfile,			!  file
     -		Status	   = 'OLD',			!
     -		Form	   = 'Formatted',		!
     -		CarriageControl = 'List',		!
     -		Readonly,				!
     -		Err 	   = 9000)			!

	IF(.NOT.Lonce)				THEN	! If interactive
	  CALL VPW_SCROLL(Iterminal,3,21,1)		!
	  CALL SCREEN(' ',Iterminal,3,1,1)		!
	END IF						!
500	READ(Lun_File,505,END=5000)Record_Length,Record	!
505	FORMAT(Q,A)					!


C ..  Find the record
	IF(.NOT.Lall_Flag)			THEN	!
	  CALL Upper_Case(Ctmp(1:Nchar))		! Make uppercase
	  Tmp_Record=Record(1:Record_Length)		!
	  CALL Upper_Case(Tmp_Record(1:Record_length))	!
	  CALL Match_Strings(Ctmp(1:Nchar),		!
     -			     Tmp_Record(1:Record_Length),Imatch)
	  IF(Imatch.EQ.0)			GOTO 500! If no match
	END IF						!
	IF(.NOT.Lprint_Flag)			THEN	!
	  CALL Display_Record(Iform)			! display record
	ELSE						!
	  CALL Display_Record(Iform,Lun_File_Write)	!
	END IF						!
	GOTO 500

5000	CLOSE (UNIT=LUN_FILE)				! close file
	CLOSE (UNIT=Lun_File_Write)			!
	IF(Lonce)			RETURN		!
	TYPE *,' '					!
	TYPE *,'Type '//Cbold//'RETURN'//Cnorm//' to continue'	!
	CALL Read_String(Cans,NN)			! Read value
	IF(NN.EQ.-1)				THEN	!
	CALL VPW_SCROLL(Iterminal,1,24,0)		! Reset jump scroll
			RETURN				! If ^Z input
	END IF						!
	ILINE=23
	GOTO 25						! More


9000	CLOSE(UNIT=Lun_File_Write,Dispose='Delete')	!
	CALL STRING_LENGTH(Cfile,JJ)			!
	Ctmp='VPW_Display -- Error opening file '//	!
     -	      Cbold//Cfile(1:JJ)//Cnorm//Cbell		!
	CALL STRING_LENGTH(Ctmp,Nchar)			!
9005	WRITE(*,9010)Ctmp(1:Nchar)			!
9010	FORMAT(' ',A)					!
	GOTO 9950					!

9500	Ctmp='VPW_Display -- Non-numeric form #s not allowed.'//Cbell
	CALL STRING_LENGTH(Ctmp,Ilen)
	CALL SCREEN(Ctmp(1:Ilen),Iterminal,24,1,1)	!
	GOTO 15
9900	CALL String_Length(Cout_File,JJ)		!
	Ctmp='VPW_Display -- Error opening output file '//
     -	      Cbold//Cout_file(1:JJ)//Cnorm//Cbell	!
	CALL STRING_LENGTH(Ctmp,Nchar)			!	
	WRITE(*,9010)Ctmp(1:Nchar)			!
	GOTO 9950					! 

9950	TYPE *,' '					!
	TYPE *,'Type '//Cbold//'RETURN'//Cnorm//' to continue'		!
	CALL Read_String(Cans,NN)			! Read value
	IF(NN.EQ.-1)			RETURN		! If ^Z input
9999	RETURN
	END
